!=======================================================================
!
!  PROGRAM  PHASE/0 2014.01 (rev.375)
!
!  "First-principles Electronic Structure Calculation Program"
!
!  SUBROUINE: Initial_MD_Condition
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!   The original version of this set of the computer programs "PHASE" was developed by 
!  the members of the Theory Group of Joint Research Center for Atom Technology 
!  (JRCAT), based in Tsukuba, in the period 1993-2001.  
!   Since 2002, this program set had been intensively developed as a part of the following 
!  national projects supported by the Ministry of Education, Culture, Sports, Science and 
!  Technology (MEXT) of Japan; "Frontier Simulation Software for Industrial Science 
!  (FSIS)" from 2002 to 2005, "Revolutionary Simulation Software (RSS21)" from 2006 to 
!  2008. "Research and Development of Innovative Simulation Software (RISS)" from 2008 
!  to 2013. These projects is lead by the Center for Research on Innovative Simulation 
!  Software (CISS), the Institute of Industrial Science (IIS), the University of Tokyo.
!   Since 2013, this program set has been further developed centering on PHASE System 
!  Consortium. 
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
subroutine Initial_MD_Condition
! $Id: Initial_MD_Condition.F90 238 2012-11-12 04:11:13Z yamasaki $
  use m_Const_Parameters,   only : CONTINUATION, T_CONTROL, BLUEMOON, QUENCHED_CONSTRAINT &
 &                               , COORDINATE_CONTINUATION, INITIAL, FIXED_CHARGE_CONTINUATION
  use m_Files,              only : nfinp, nfcntn, nfout
#ifdef _EMPIRICAL_
  use m_Control_Parameters, only : icond, imdalg
  use m_IterationNumbers,   only : m_Iter_total_increment
#else
  use m_Control_Parameters, only : icond, imdalg, iprimd &
       &                         , m_CtrlP_rd_isolver
#endif
  use m_Total_Energy,       only : m_TE_rd_total_energy
  use m_Ionic_System,       only : m_IS_rd_forcp_etc &
       &                         , m_IS_rd_nrsv, m_IS_natm_can_change
!!$  use m_Ionic_System,       only : m_IS_rd_T_parameters, m_IS_rd_forcp_etc &
!!$       &                         , m_IS_rd_nrsv, m_IS_rd_nrsv_stdin

  implicit none
  if(icond == CONTINUATION.or.icond==COORDINATE_CONTINUATION.or.icond == FIXED_CHARGE_CONTINUATION) then
     call m_TE_rd_total_energy(nfcntn)
     if(iprimd >= 3 ) write(nfout,'(" imdalg = ",i8)') imdalg
     if(imdalg==T_CONTROL.or.imdalg==BLUEMOON.or.imdalg==QUENCHED_CONSTRAINT) then
        if(imdalg /= QUENCHED_CONSTRAINT) call m_IS_rd_nrsv(nfcntn)
        call m_IS_rd_forcp_etc(imdalg,nfcntn)
     end if
#ifndef _EMPIRICAL_
     call m_CtrlP_rd_isolver(nfcntn)
#endif
     if(icond==CONTINUATION.and.m_IS_natm_can_change())then
        icond = INITIAL
     endif
  end if

#ifdef _EMPIRICAL_
  call m_Iter_total_increment()
#endif

end subroutine Initial_MD_Condition

#define NEC_TUNE
!=======================================================================
!
!  PROGRAM  PHASE/0 2014.01 (rev.375)
!
!  "First-principles Electronic Structure Calculation Program"
!
!  MODULE: m_NonLocal_Potential
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!   Since 2002, this program set had been intensively developed as a part of the following 
!  national projects supported by the Ministry of Education, Culture, Sports, Science and 
!  Technology (MEXT) of Japan; "Frontier Simulation Software for Industrial Science 
!  (FSIS)" from 2002 to 2005, "Revolutionary Simulation Software (RSS21)" from 2006 to 
!  2008. "Research and Development of Innovative Simulation Software (RISS)" from 2008 
!  to 2013. These projects is lead by the Center for Research on Innovative Simulation 
!  Software (CISS), the Institute of Industrial Science (IIS), the University of Tokyo.
!   Since 2013, this program set has been further developed centering on PHASE System 
!  Consortium. 
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
module m_NonLocal_Potential
!    ( m_NLP )
!  $Id: m_NonLocal_Potential.F90 348 2013-11-14 07:50:23Z tkato $
!
!  This module contains following major subroutines
!  1.  m_NLP_alloc_snl
!  2.  m_NLP_wd_snl(nfcntn_bin,kv3)
!  3.  m_NLP_rd_snl(nfcntn_bin,kv3)
!  4.  m_NLP_betar_dot_PWs(nfout,kv3,vkxyz)
!  5.  m_NLP_betar_dot_PWs_diff(nfout,kv3,vkxyz)
!
! The subroutine "m_NLP_betar_dot_WFs" originates from a subroutine "kbint".
! The subroutine "kbint" was coded mainly by Y. Morikawa in 1993 or earlier.
! The subroutine "kbint" has following comments
!!!$C Fourier transformation of function beta(r).
!!$c  #1) gx,gy,gz --> ngabc by T.Yamasaki on 15th Feb. 1995
!!$c  #2) vx,vy,vz --> vkxyz by T.Yamasaki on 15th Feb. 1995
!!$c  #3) betar --> betar_l  by T.Yamasaki on 3rd Mar. 1995
!!$c  #4) snl2 is introduced by Y. Morikawa. 14th May. 1996
!!$c  #5) antiferromagnetic calculation is added on 9th Jul. 1996
!!$c                                          by H.Sawada
!
! The subroutine "m_NLP_betar_dot_PWs_diff" originates from a subroutine
! "kbint_diff" coded by H. Sawada at 8th May 1997.
! This was translated into the subroutine "m_NLP_betar_dot_PWs_diff" using
! fortran90+MPI by H. Sawada and T. Yamasaki in 1999.
!
  use m_PlaneWaveBasisSet,    only : kgp,kg1,ngabc,iba,nbase
  use m_PseudoPotential,      only : wos,radr,betar,nmesh,mmesh,ilmt,xh,rmax,ntau &
       &                           , m_PP_tell_lmtt_l_m_tau,nlmtt &
       &                           , m_PP_tell_lmtt_l_m_tau_phi &
       &                           , m_PP_tell_lmtt_l_m_tau_add &
       &                           , m_PP_tell_lmtt_l_m_tau_pao &
       &                           , phirt,ilmt_phi, nlmtt_phi &
       &                           , betar_add,ilmt_add, nlmtt_add &
       &                           , paor,ilmt_pao, nlmtt_pao
  use m_Crystal_Structure,    only : rltv, univol, op
  use m_Ionic_System,         only : ntyp
  use m_Timing,               only : tstatc0_begin, tstatc0_end
  use m_Control_Parameters,   only : nspin, ipri, iprisnl, istress &
       &                           , sw_orb_popu, ipriphig, ipripao
  use m_Const_Parameters,     only : DP, PAI2, PAI4, BUCS, CRDTYP, ON, DELTA
  use m_Parallelization,      only : map_k,myrank_k,ista_k,iend_k,mype &
       &                           , myrank_e,nrank_e,mpi_k_world,ierr &
       &                           , ista_snl, iend_snl, mpi_comm_group
  use m_Parallelization,      only : np_g1k,ista_g1k, iend_g1k    &
       &                           , mpi_kg_world,mpi_ke_world 
  use m_PlaneWaveBasisSet,   only : ngabc_kngp_l, ngabc_kngp_B_l,kg

! ================================ added by K. Tagami ============== 11.0
  use m_Control_Parameters,   only : noncol, ndim_spinor
! ================================================================== 11.0

  implicit none
  include 'mpif.h'                              ! MPI
  integer istatus(mpi_status_size)              ! MPI

  real(kind=DP), allocatable,target,dimension(:,:,:)     :: snl  !d(kg1,nlmtt,ista_snl:iend_snl)
  real(kind=DP), allocatable,target,dimension(:,:,:,:,:) :: snld !d(kg1,nlmtt,ista_snl:iend_snl,3)

  real(kind=DP), allocatable,dimension(:,:,:)     :: snl_add  !d(kg1,nlmtt_add,ista_snl:iend_snl)

  real(kind=DP),private,allocatable,dimension(:) :: qx,qy,qz,vlength,snl2,wka,wkb,ylm
  real(kind=DP),private,allocatable,dimension(:)     :: snl3,wkc,wkd
  real(kind=DP),private,allocatable,dimension(:,:)   :: ylmd,alinvt

  real(kind=DP), allocatable,dimension(:,:,:) :: phig !d(kg1,nlmtt_phi,ista_snl:iend_snl)
  real(kind=DP), allocatable,dimension(:,:) :: norm_phig !d(nlmtt_phi,ista_snl:iend_snl)

  real(kind=DP), allocatable,dimension(:,:,:) :: paog !d(kg1,nlmtt_pao,ista_snl:iend_snl)
contains
  subroutine m_NLP_alloc_snl
!!$    ista_snl = (ista_k + nspin - 1)/nspin
!!$    iend_snl = iend_k/nspin
!!$    print '(" ista_snl = ",i3)',ista_snl
!!$    print '(" iend_snl = ",i3)',iend_snl
    allocate(snl(maxval(np_g1k),nlmtt,ista_snl:iend_snl)); snl = 0.d0
    if(istress == ON) then

       allocate(snld(maxval(np_g1k),nlmtt,ista_snl:iend_snl,3,3)); snld = 0.d0
    end if
  end subroutine m_NLP_alloc_snl

  subroutine m_NLP_alloc_phig
    if(sw_orb_popu == ON) then
       allocate(phig(maxval(np_g1k),nlmtt_phi,ista_snl:iend_snl)); phig = 0.d0
       allocate(norm_phig(nlmtt_phi,ista_snl:iend_snl)); norm_phig = 1.d0
    end if
  end subroutine m_NLP_alloc_phig
 
  subroutine m_NLP_alloc_snl_add

    allocate(snl_add(maxval(np_g1k),nlmtt_add,ista_snl:iend_snl)); snl_add = 0.d0
  end subroutine m_NLP_alloc_snl_add

  subroutine m_NLP_alloc_paog
    allocate(paog(maxval(np_g1k),nlmtt_pao,ista_snl:iend_snl)); paog = 0.d0
  end subroutine m_NLP_alloc_paog




    subroutine wd_lmt_l_m_tau_etc(nfout,it,lmt1,il1,im1,tau1,lmtt1,nspher)
    integer, intent(in)  :: nfout,it,lmt1,il1,im1,tau1,lmtt1,nspher
      write(nfout,230) it,lmt1,il1,im1,tau1,lmtt1,nspher
230   format(' ',' it=',i2,' lmt1=',i2,' il1,im1,tau1=',3i2, &
           &                   ' lmtt1=',i3,' nspher=',i3)
    end subroutine wd_lmt_l_m_tau_etc

    subroutine new_radr_and_wos(ik,it)
      integer, intent(in)  :: ik,it
      real(kind=DP), parameter :: delta = 1.d-40
      real(kind=DP)      :: hn
      real(kind=DP),save :: xhn = 0.d0 , rmaxn = 0.d0
      integer,save       :: nmeshn = 0
      if((ik == ista_k .and. it == 1) .or. &            ! MPI
           & (nmeshn /= nmesh(it) .or. dabs(xhn-xh(it)) > delta  .or. &
           &  dabs(rmaxn-rmax(it)) > delta) ) then
         call rmeshs(nmesh(it),nmesh(it),xh(it),rmax(it),radr,hn) ! -(b_PP)
         call coef_simpson_integration(nmesh(it),nmesh(it),xh(it),radr,wos) ! -(b_PP)
         xhn = xh(it); rmaxn = rmax(it); nmeshn = nmesh(it)
      endif
    end subroutine new_radr_and_wos

    subroutine radr_and_wos_p(n1,n2,mtyp,mradr,ip_radr,radr_p,wos_p)
      integer, intent(in) :: n1, n2, mtyp,mradr
      integer, intent(in), dimension(mtyp) :: ip_radr
      real(kind=DP), intent(out), dimension(n1:n2,mradr) :: radr_p, wos_p

      real(kind=DP)      :: hn
      integer :: it, i, ip, ip0
      ip = 0
      do it = 1, ntyp
         if(ntyp > mtyp) cycle
         if(ip_radr(it) /= ip) then
            call rmeshs(nmesh(it),nmesh(it),xh(it),rmax(it),radr,hn) ! -(b_PP)
            call coef_simpson_integration(nmesh(it),nmesh(it),xh(it),radr,wos) ! -(b_PP)
            ip = ip_radr(it)
            do i = n1, n2
               radr_p(i,ip) = radr(i)
               wos_p(i,ip) = wos(i)
            end do
         end if
      end do
    end subroutine radr_and_wos_p

    subroutine find_critical_point(r,n,x,idp)
      real(kind=DP), intent(in) :: r
      integer,  intent(in)      :: n
      real(kind=DP), intent(in), dimension(n) :: x
      integer,  intent(out)     :: idp
      integer :: i
      do i = 1, n
         idp = i
         if(x(i) > r) exit
      end do
    end subroutine find_critical_point


  subroutine m_NLP_dealloc
    if(allocated(snl)) deallocate(snl)
    if(allocated(snl_add)) deallocate(snl_add)          

    if(allocated(paog)) deallocate(paog)          
    if(istress == ON) deallocate(snld)
  end subroutine m_NLP_dealloc

!===============================================================================
  subroutine m_NLP_betar_dot_PWs_3D(nfout,kv3,vkxyz)
    integer,       intent(in)       :: nfout,kv3
    real(kind=DP), intent(in)       :: vkxyz(kv3,3,CRDTYP)

    real(kind=DP)       :: fac, facr
    integer             :: ik,iksnl,it,n,lmt1,lmtt1,il1,im1,tau1,nspher, ig, n1, n2
    integer             :: i, j, k
    integer             :: id_sname = -1
    real(kind=DP), dimension(:,:), allocatable :: snl2_mpi, snl1

#ifndef _mNLP_no_loop_exchange_
    integer, parameter  :: lcmax = 4
    integer :: ip
    integer :: mil, mp  ! mp = maxval(np)
    integer, dimension(:),     allocatable :: nil  ! d(ntyp)
    integer, dimension(:,:),   allocatable :: nt   ! d(ntyp,mil)
    integer, dimension(:,:,:), allocatable :: tu2p ! d(ntau,ntyp,mil)
    integer, dimension(:),     allocatable :: np   ! d(mil), np=sum_{u=1}^{ntyp}(nt(u,mil))
    integer, dimension(:,:,:), allocatable ::  pm2lmtt1 ! d(mp,2*(mil-1)+1,mil)
    real(kind=DP), dimension(:,:), allocatable :: snl_t, snl_t_mpi ! d(iba(ik),mp)
    real(kind=DP), dimension(:,:), allocatable :: radr_p, wos_p ! d(n1:n2,ntyp)
    integer :: p, mradr_indp 
    logical, dimension(:,:), allocatable :: flag_radr !d(ntyp,mil)
    integer, dimension(:), allocatable   :: ip_radr !d(ntyp)
    real(kind=DP) :: r, w
#endif

#ifdef __TIMER_SUB__
  call timer_sta(1224)
#endif

    call tstatc0_begin('m_NLP_betar_dot_PWs ',id_sname,1)
    call innerPr_allocate_3D()

    fac = PAI4/dsqrt(univol)

#ifndef _mNLP_no_loop_exchange_
!!$    allocate(nil(ntyp)); nil = 0
!!$    allocate(nt(ntyp,lcmax)); allocate(tu2p(ntau,ntyp,lcmax)); allocate(np(lcmax))
!!$    nt = 0; tu2p = 0
!!$    call set_index_arrays1(ntyp,nil,nt,tu2p,mil,mp) ! mil, mp, nil, nt, tu2p, np, pm2lmtt1, contained here
!!$    allocate(pm2lmtt1(mp,2*(mil-1)+1,mil))
!!$    call set_index_arrays2(mp,pm2lmtt1)
    call set_index_arrays() ! mil, mp, nil, nt, tu2p, np, pm2lmtt1, contained here

    n = ceiling(dble(mmesh)/nrank_e)
    if(n == 0) n = 1
    n1 = n*myrank_e + 1
    n2 = n*(myrank_e+1)
    if(n2 > mmesh) n2 = mmesh

    allocate(flag_radr(ntyp,mil))
    allocate(ip_radr(ntyp))
!!$ASASASASAS
    flag_radr = .false.
    ip_radr = 0
!!$ASASASASAS
    call set_flag_radr_and_ip_radr() ! -> mradr_indp,flag_radr, ip_radr

    if(n1 <= n2) then
       allocate(radr_p(n1:n2,mradr_indp))
       allocate(wos_p(n1:n2,mradr_indp))
!!$ASASASASAS
       radr_p = 0; wos_p = 0
!!$ASASASASAS
       call radr_and_wos_p(n1,n2,ntyp,mradr_indp,ip_radr,radr_p,wos_p) ! -> radr_p, wos_p
    end if

    do ik = 1, kv3, nspin
       if(ipri >= 2) write(nfout,'(" ik = ",i8)') ik
       if(map_k(ik) /= myrank_k) cycle                     ! MPI
!!$ASASASASAS
!!$       allocate(snl_t(iba(ik),mp))
!!$       if(nrank_e > 1) allocate(snl_t_mpi(iba(ik),mp))
       allocate(snl_t(np_g1k(ik),mp)); snl_t = 0
       if(nrank_e > 1) then
          allocate(snl_t_mpi(np_g1k(ik),mp)); snl_t_mpi = 0
       endif
!!$ASASASASAS

       if(ipri >= 2) write(nfout,'(" entering k_plus_G_vectors")')
       if(ipri >= 2) then
          write(nfout,'(" iba(ik) = ",i8)') iba(ik)
          write(nfout,'(" vkxyz(ik) = ",3f8.4)') vkxyz(ik,1:3,BUCS)
       end if
       if(.not.allocated(qx)) stop ' qx is not allocated'
       if(.not.allocated(vlength)) stop ' vlength is not allocated'
       if(.not.allocated(nbase)) stop ' nbase is not allocated'
!       call k_plus_G_vectors_3D(ik,kgp,kg1,kv3,iba,nbase,vkxyz,ngabc,rltv&
!            &,qx,qy,qz,vlength)                            ! ->(bottom_Subr.)
       call k_plus_G_vectors_3D(ik,kg,kg1,kv3,iba,nbase,vkxyz,ngabc,rltv&
            &,qx,qy,qz,vlength)                            ! ->(bottom_Subr.)
       iksnl = (ik-1)/nspin + 1

       do il1 = 1, mil
          snl_t = 0.d0
          do n = n1, n2
             do it = 1, ntyp
                if(il1 > nil(it)) cycle
                if(flag_radr(it,il1)) then
                   r = radr_p(n,ip_radr(it))
                   do ig = 1, np_g1k(ik)
                      wka(ig) = vlength(ig)*r
                   end do
                   call dsjnv(il1-1,np_g1k(ik),wka,wkb)     ! -(bottom_Subr.)
                end if

                w = fac * wos_p(n,ip_radr(it)) * radr_p(n,ip_radr(it))
                do tau1 = 1, nt(it,il1)
                   facr = w * betar(n,il1,tau1,it)
                   ip = tu2p(tau1,it,il1)
                   do ig = 1, np_g1k(ik)
                      snl_t(ig,ip) = snl_t(ig,ip) + facr*wkb(ig)
                   end do
                end do
             end do
          end do
          if(nrank_e > 1) then
             call mpi_allreduce(snl_t,snl_t_mpi,np_g1k(ik)*np(il1),mpi_double_precision,mpi_sum,mpi_kg_world,ierr)
             snl_t = snl_t_mpi
          end if

          do im1 = 1, 2*(il1-1)+1
             nspher = (il1-1)**2 + im1
             call sphr(np_g1k(ik),nspher,qx,qy,qz,ylm)        ! -(bottom_Subr.)
             do p = 1, np(il1)
                ip = pm2lmtt1(p,im1,il1)
                do ig = 1, np_g1k(ik)
                   snl(ig,ip,iksnl) = snl_t(ig,p)*ylm(ig)
                end do
             end do
          end do
       end do
       if(nrank_e > 1) deallocate(snl_t_mpi)
       deallocate(snl_t)
    end do

    if(n1 <= n2) deallocate(wos_p,radr_p)
    deallocate(ip_radr,flag_radr)
    call dealloc_index_arrays()

#else
    if(nrank_e > 1) then
       allocate(snl1(kg1,nlmtt)); snl1 = 0.d0
       allocate(snl2_mpi(kg1,nlmtt))
!!$ASASASASAS
       snl2_mpi = 0.d0
!!$ASASASASAS
    end if

    do ik = 1, kv3, nspin
       if(map_k(ik) /= myrank_k) cycle                     ! MPI

       call k_plus_G_vectors(ik,kgp,kg1,kv3,iba,nbase,vkxyz,ngabc,rltv&
            &,qx,qy,qz,vlength)                            ! ->(bottom_Subr.)
       iksnl = (ik-1)/nspin + 1

       do it=1,ntyp

          n = ceiling(dble(nmesh(it))/nrank_e)
          if(n == 0) n = 1
          n1 = n*myrank_e + 1
          n2 = n*(myrank_e+1)
          if(n2 > nmesh(it)) n2 = nmesh(it)

          call new_radr_and_wos(ik,it)                 ! --> radr, wos
          do lmt1 = 1,ilmt(it)
             call m_PP_tell_lmtt_l_m_tau(lmt1,it,lmtt1,il1,im1,tau1,nspher)
             call sphr(iba(ik),nspher,qx,qy,qz,ylm)        ! -(bottom_Subr.)
             if(iprisnl >= 2) call wd_lmt_l_m_tau_etc &
                                (nfout,it,lmt1,il1,im1,tau1,lmtt1,nspher)
             snl2 = 0.d0

             do n = n1, n2
                facr = fac*wos(n)*radr(n)*betar(n,il1,tau1,it)
                do ig = 1, iba(ik)
                   wka(ig) = vlength(ig)*radr(n)
                end do
                call dsjnv(il1-1,iba(ik),wka,wkb)     ! -(bottom_Subr.)
                do ig = 1, iba(ik)
                   snl2(ig) = snl2(ig) + facr*wkb(ig)
                end do
             end do

             if(nrank_e == 1) then
                do ig = 1, iba(ik)
                   snl(ig,lmtt1,iksnl) = snl2(ig)*ylm(ig)
                end do
             else
                do ig = 1, iba(ik)
                   snl1(ig,lmtt1) = snl2(ig)*ylm(ig)
                end do
             end if
          end do
       end do

       if(nrank_e > 1) then
          call mpi_allreduce(snl1, snl2_mpi, kg1*nlmtt,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)
          do lmtt1 = 1, nlmtt
             do ig = 1, iba(ik)
                snl(ig,lmtt1,iksnl) = snl2_mpi(ig,lmtt1)
             end do
          end do
       end if
    end do
    if(nrank_e > 1) deallocate(snl2_mpi,snl1)
#endif
    if(iprisnl >= 2) call wd_snl

    call innerPr_deallocate_3D
    call tstatc0_end(id_sname)
#ifdef __TIMER_SUB__
  call timer_end(1224)
#endif

  contains
#ifndef _mNLP_no_loop_exchange_
    subroutine set_flag_radr_and_ip_radr()
      integer :: it, il, ip, it2, is, it1

      mradr_indp = 1
      ip_radr(1) = 1
      do it = 2, ntyp
         is = 0
         search_loop: do it2 = 1, mradr_indp
            ip = ip_radr(it2)
            if((nmesh(ip) == nmesh(it) .and. dabs(xh(ip)-xh(it)) < DELTA .and. &
              & dabs(rmax(ip)-rmax(it)) < DELTA)) then
               is = it2
               exit search_loop
            end if
         end do search_loop
         if(is <= 0 .or. is > mradr_indp) then
            mradr_indp = mradr_indp+1
            is = mradr_indp
         end if
         ip_radr(it) = is
      end do

      if(ipri >= 2) then
         write(nfout,'(" !mNLP : mradr_indp = ", i5)') mradr_indp
         do it = 1, ntyp
            write(nfout,'(" !mNLP : ip_radr(",i5,") = ",i5)') it, ip_radr(it)
         end do
      end if

      do il = 1, mil
         flag_radr(1:ntyp,il) = .true.
         it1 = 0
         do it = 1, ntyp
            if(il > nil(it)) cycle
            it1 = it1+1
            if(it1 == 1) then
               flag_radr(it,il) = .true.
            else if(it1 >= 2) then
               if(ip_radr(ip) /= ip_radr(it)) then
                  flag_radr(it,il) = .true.
               else
                  flag_radr(it,il) = .false.
               end if
            end if
            ip = it
         end do
      end do

      if(ipri >= 2) then
         do il = 1, mil
            do it = 1, ntyp
               write(nfout,'(" !mNLP : flag_radr(",i5,",",i5,") = ",l3)') it,il,flag_radr(it,il)
            end do
         end do
      end if
    end subroutine set_flag_radr_and_ip_radr

    subroutine set_index_arrays()
      integer :: it, lmt1, n, il1, im1

      allocate(nil(ntyp)); nil = 0
      allocate(nt(ntyp,lcmax)); allocate(tu2p(ntau,ntyp,lcmax)); allocate(np(lcmax))
      nt = 0; tu2p = 0
      mil = 0
      if(ipri>=2) write(nfout,'(" !mNLP:    it, lmt1: lmtt1, il1, im1, tau1, nspher")')
      do it=1,ntyp
         do lmt1 = 1, ilmt(it)
            call m_PP_tell_lmtt_l_m_tau(lmt1,it,lmtt1,il1,im1,tau1,nspher)
            if(ipri>=2) write(nfout,'(" !mNLP: ",2i5," : ",5i5)') it,lmt1, lmtt1,il1,im1,tau1,nspher
            if(mil < il1) mil = il1
            if(nil(it) < il1) nil(it) = il1
            if(nt(it,il1) < tau1) nt(it,il1) = tau1
         end do
      end do

      do il1=1,mil
         n = 0
         np(il1) = 0
         do it=1,ntyp
            if(il1 > nil(it)) cycle
            np(il1) = np(il1)+nt(it,il1)
            do tau1=1,nt(it,il1)
               n = n+1
               tu2p(tau1,it,il1)= n
            end do
         end do
      end do

      mp = maxval(np(1:mil))
      allocate(pm2lmtt1(mp,2*(mil-1)+1,mil))
!!$ASASASASAS
      pm2lmtt1 = 0
!!$ASASASASAS
      do it = 1, ntyp
         do lmt1=1,ilmt(it)
            call m_PP_tell_lmtt_l_m_tau(lmt1,it,lmtt1,il1,im1,tau1,nspher)
            n = tu2p(tau1,it,il1)
            pm2lmtt1(n,im1,il1) = lmtt1
         end do
      end do

      if(ipri>=2) then
         write(nfout,'(" !mNLP: mil = ",i5)') mil
         do it = 1, ntyp
            write(nfout,'(" !mNLP: nil(",i3,") = ",i5)') it,nil(it)
         end do
         do it = 1, ntyp
            write(nfout,'(" !mNLP: nt(",i3,", : ) = ",5i5)') it,(nt(it,il1),il1=1,nil(it))
         end do

         write(nfout,'(" !mNLP: mp = ",i5)') mp
         do il1 = 1, mil
            write(nfout,'(" !mNLP: np(",i3,")=",i5)') il1, np(il1)
         end do
         do il1 = 1, mil
            do it = 1, ntyp
               if(il1 > nil(it)) cycle
               do tau1 = 1, nt(it,il1)
                  write(nfout,'(" !mNLP: tu2p(",i3,",",i3,",",i3,") = ",i5)') tau1,it,il1,tu2p(tau1,it,il1)
               end do
            end do
         end do
         do il1 = 1, mil
            do im1 = 1, 2*(il1-1)+1
               do n = 1, np(il1)
                  write(nfout,'(" !mNLP: il1 = ",i3," im1 = ",i3," n = ", i3, " pm2lmtt1 = ",i5)') &
                       & il1,im1, n,pm2lmtt1(n,im1,il1)
               end do
            end do
         end do
      end if
    end subroutine set_index_arrays

    subroutine dealloc_index_arrays()
      deallocate(pm2lmtt1,np,tu2p,nt,nil)
    end subroutine dealloc_index_arrays
#endif
      
    subroutine wd_snl
      integer, parameter :: MSNLSIZE = 20
      integer :: i, ilmtt, ik, j, iksnl, icycle, icolumn, max_elements, istart, iend, ic
      write(nfout,'(" << m_NLP_betar_dot_PWs.wd_snl >>")')
      write(nfout,'(10("(",3i2,")"))') ((ngabc(i,j),j=1,3),i=1,30)
      do ik = 1, kv3, nspin
         if(map_k(ik) /= myrank_k) cycle        ! MPI
         iksnl = (ik-1)/nspin + 1
         write(nfout,'(" ik = ",i5)') iksnl
         write(nfout,'(" nbase(1:8,",i5,")",i8,9i12)') ik,(nbase(i,ik),i=1,8)
         if(iprisnl >= 3) then
            max_elements = iba(ik)
         else
            max_elements = min(MSNLSIZE,iba(ik))
         end if
         icolumn = 10
         icycle = ceiling(dble(min(max_elements,kg1))/icolumn)
         do ilmtt = 1, nlmtt
!!$            write(nfout,'("(ilmtt = ",i5,")",8f10.5,99(/15x,8f10.5))') ilmtt,(snl(i,ilmtt,iksnl),i=1,kg1)
            write(nfout,'(" !nlp (ilmtt = ",i5,")")') ilmtt
            istart = 1
            do ic = 1, icycle
               iend = min(istart+icolumn-1,max_elements,kg1)
               write(nfout,'(" !nlp (nx)    ",10i12)') (ngabc(nbase(i,ik),1),i=istart,iend)
               write(nfout,'(" !nlp (ny)    ",10i12)') (ngabc(nbase(i,ik),2),i=istart,iend)
               write(nfout,'(" !nlp (nz)    ",10i12)') (ngabc(nbase(i,ik),3),i=istart,iend)
               write(nfout,'(" !nlp (snl)   ",10d12.4)') (snl(i,ilmtt,iksnl),i=istart,iend)
               istart = iend + 1
            end do
         end do
      end do
    end subroutine wd_snl
  end subroutine m_NLP_betar_dot_PWs_3D

  subroutine innerPr_allocate_3D
    allocate(qx(maxval(np_g1k))); qx = 0.d0
    allocate(qy(maxval(np_g1k))); qy = 0.d0
    allocate(qz(maxval(np_g1k))); qz = 0.d0
    allocate(vlength(maxval(np_g1k))); vlength = 0.d0
    allocate(snl2(maxval(np_g1k))); snl2 = 0.d0
    allocate(wka(maxval(np_g1k)));  wka  = 0.d0
    allocate(wkb(maxval(np_g1k)));  wkb  = 0.d0
    allocate(ylm(maxval(np_g1k)));  ylm  = 0.d0
  end subroutine innerPr_allocate_3D

  subroutine innerPr_deallocate_3D
    deallocate(ylm)
    deallocate(wkb)
    deallocate(wka)
    deallocate(snl2)
    deallocate(vlength)
    deallocate(qz)
    deallocate(qy)
    deallocate(qx)
  end subroutine innerPr_deallocate_3D

!------
  subroutine innerPr1_allocate_3D
    allocate(qx(maxval(np_g1k))); qx = 0.d0
    allocate(qy(maxval(np_g1k))); qy = 0.d0
    allocate(qz(maxval(np_g1k))); qz = 0.d0
    allocate(vlength(maxval(np_g1k))); vlength = 0.d0
    allocate(snl2(maxval(np_g1k))); snl2 = 0.d0
    allocate(wka(maxval(np_g1k)));  wka  = 0.d0
    allocate(wkb(maxval(np_g1k)));  wkb  = 0.d0
    allocate(wkc(maxval(np_g1k)));  wkc  = 0.d0
    allocate(wkd(maxval(np_g1k)));  wkd  = 0.d0
    allocate(ylm(maxval(np_g1k)));  ylm  = 0.d0
    allocate(snl3(maxval(np_g1k))); snl3 = 0.d0
    allocate(ylmd(maxval(np_g1k),3)); ylmd = 0.d0
    allocate(alinvt(3,3)); alinvt = 0.d0
  end subroutine innerPr1_allocate_3D

  subroutine innerPr1_deallocate_3D
    deallocate(alinvt)
    deallocate(ylmd)
    deallocate(snl3)
    deallocate(ylm)
    deallocate(wkd)
    deallocate(wkc)
    deallocate(wkb)
    deallocate(wka)
    deallocate(snl2)
!!$    deallocate(wos)
!!$    deallocate(radr)
    deallocate(vlength)
    deallocate(qz)
    deallocate(qy)
    deallocate(qx)
  end subroutine innerPr1_deallocate_3D

  subroutine m_NLP_betar_dot_PWs_diff_3D(nfout,kv3,vkxyz)

    integer,       intent(in)       :: nfout,kv3
    real(kind=DP), intent(in)       :: vkxyz(kv3,3,CRDTYP)

    real(kind=DP)       :: fac, facr
    integer             :: ik,iksnl,it,n,lmt1,lmtt1,il1,im1,tau1,nspher,j, ig
    integer             :: id_sname = -1

    call tstatc0_begin('m_NLP_betar_dot_PWs_diff ',id_sname,1)
    if(iprisnl >= 2) write(nfout,*) ' <<< m_NLP_betar_dot_PWs_diff >>>'
    call innerPr1_allocate_3D
    if(iprisnl >= 2) write(nfout,*) ' after innerPr1_allocate'

    alinvt = rltv / PAI2
    fac = PAI4/dsqrt(univol)
    do ik = 1, kv3, nspin
       if(map_k(ik) /= myrank_k) cycle             ! MPI

!       call k_plus_G_vectors_3D(ik,kgp,kg1,kv3,iba,nbase,vkxyz,ngabc,rltv&
!            &,qx,qy,qz,vlength)                            ! ->(bottom_Subr.)
       call k_plus_G_vectors_3D(ik,kg,kg1,kv3,iba,nbase,vkxyz,ngabc,rltv&
            &,qx,qy,qz,vlength)                            ! ->(bottom_Subr.)

       iksnl = (ik-1)/nspin + 1
       do it=1,ntyp
          call new_radr_and_wos(ik,it)                 ! --> radr, wos
          do lmt1 = 1,ilmt(it)
             call m_PP_tell_lmtt_l_m_tau(lmt1,it,lmtt1,il1,im1,tau1,nspher)
             ylm = 0.d0; ylmd = 0.d0
             call sphr(np_g1k(ik),nspher,qx,qy,qz,ylm)        ! -(bottom_Subr.)
             call sphr_diff(maxval(np_g1k),np_g1k(ik),nspher,qx,qy,qz,ylmd) ! -(bottom_Subr.)
             if(ipri >= 2) call wd_lmt_l_m_tau_etc &
                                (nfout,it,lmt1,il1,im1,tau1,lmtt1,nspher)
             snl2 = 0.d0; snl3 = 0.d0
             wkb = 0.d0; wkc = 0.d0; wkd = 0.d0
!xocl spread do/ind_kmesh
             do n = 1,nmesh(it)
                facr = fac*wos(n)*radr(n)*betar(n,il1,tau1,it)
                wka = vlength*radr(n)
                if(il1-1.ne.0) call dsjnv(il1-2,np_g1k(ik),wka,wkc)
                !                                            -(bottom_Subr.)
                call dsjnv(il1-1,np_g1k(ik),wka,wkb)     ! -(bottom_Subr.)
                call dsjnv(il1  ,np_g1k(ik),wka,wkd)     ! -(bottom_Subr.)
                do ig = 1, np_g1k(ik)
                   snl2(ig) = snl2(ig) + facr*wkb(ig)
                end do
!!$                snl2 = snl2 + facr*wkb
                if(il1-1 == 0) then
                   do ig = 1, np_g1k(ik)
                      snl3(ig) = snl3(ig) - facr*radr(n)/(2.d0*il1-1.d0)*il1*wkd(ig)
                   end do
                else
                   do ig =1, np_g1k(ik)
                      snl3(ig) = snl3(ig) + &
                           &  facr*radr(n)/(2.d0*il1-1.d0)*((il1-1)*wkc(ig)-il1*wkd(ig))
                   end do
                endif
             end do
!xocl end spread sum(snl2,snl3)
             snl(1:np_g1k(ik),lmtt1,iksnl) = snl2(1:np_g1k(ik)) *  &
    &                               ylm(1:np_g1k(ik))
             where( vlength > 1.d-15 )
                snl3 = - snl3 * ylm / vlength
             elsewhere
                snl3 = 0.d0
             end where

             do j = 1,3
                do ig = 1, np_g1k(ik)
                   snld(ig,lmtt1,iksnl,1,j) = &
                        & snl3(ig)*qx(ig)*(qx(ig)*alinvt(1,j) &
                        &                      +qy(ig)*alinvt(2,j) &
                        &                      +qz(ig)*alinvt(3,j)) &
                        & -snl2(ig)*qx(ig)*(ylmd(ig,1)*alinvt(1,j) &
                        &                       +ylmd(ig,2)*alinvt(2,j) &
                        &                       +ylmd(ig,3)*alinvt(3,j)) &
                        & -snl2(ig)*ylm(ig)/2.d0*alinvt(1,j)
                   snld(ig,lmtt1,iksnl,2,j) = &
                        & snl3(ig)*qy(ig)*(qx(ig)*alinvt(1,j) &
                        &                      +qy(ig)*alinvt(2,j) &
                        &                      +qz(ig)*alinvt(3,j)) &
                        & -snl2(ig)*qy(ig)*(ylmd(ig,1)*alinvt(1,j) &
                        &                       +ylmd(ig,2)*alinvt(2,j) &
                        &                       +ylmd(ig,3)*alinvt(3,j)) &
                        & -snl2(ig)*ylm(ig)/2.d0*alinvt(2,j)
                   snld(ig,lmtt1,iksnl,3,j) = &
                        & snl3(ig)*qz(ig)*(qx(ig)*alinvt(1,j) &
                        &                      +qy(ig)*alinvt(2,j) &
                        &                      +qz(ig)*alinvt(3,j)) &
                        & -snl2(ig)*qz(ig)*(ylmd(ig,1)*alinvt(1,j) &
                        &                       +ylmd(ig,2)*alinvt(2,j) &
                        &                       +ylmd(ig,3)*alinvt(3,j)) &
                        & -snl2(ig)*ylm(ig)/2.d0*alinvt(3,j)
                end do
             end do
          end do
       end do
    end do
    if(ipri >= 2) call wd_snld
    call innerPr1_deallocate_3D
    call tstatc0_end(id_sname)

  contains
    subroutine wd_snld
      integer :: i, ilmtt, ik, j, iksnl, k
      write(nfout,'(" << m_NLP_betar_dot_PWs_diff.wd_snl >>")')
      write(nfout,'(10(''('',3i2,'')''))') ((ngabc(i,j),j=1,3),i=1,30)
      do ik = 1, kv3, nspin
         if(map_k(ik) /= myrank_k) cycle   ! MPI
         iksnl = (ik-1)/nspin + 1
         write(nfout,'(" ik = ",i5)') iksnl
         write(nfout,'(8i3)') (nbase(i,ik),i=1,8)
         do ilmtt = 1, nlmtt
	    write(nfout,'('' ilmtt ='',i3)') ilmtt
            write(nfout,'(8f10.5)') (snl(i,ilmtt,iksnl),i=1,8)
              do i = 1,3
              do j = 1,3
              write(nfout,'(8f10.5)') (snld(k,ilmtt,IKSNL,i,j),k=1,8)
              end do
              end do
         end do
      end do
    end subroutine wd_snld
  end subroutine m_NLP_betar_dot_PWs_diff_3D

  subroutine m_NLP_phir_dot_PWs_3D(nfout,kv3,vkxyz)

    integer,       intent(in)       :: nfout,kv3
    real(kind=DP), intent(in)       :: vkxyz(kv3,3,CRDTYP)

    real(kind=DP)       :: fac, facr
    integer             :: ik,ikphig,it,n,lmt1,lmtt1,il1,im1,tau1,nspher
    integer             :: iopr
    integer             :: id_sname = -1

    call tstatc0_begin('m_NLP_phir_dot_PWs ',id_sname,1)
    if(ipriphig >= 2) &
         & write(nfout,*) ' <<< m_NLP_phir_dot_PWs >>> START'
    call innerPr_allocate_3D()

    fac = PAI4/dsqrt(univol)
    do ik = 1, kv3, nspin
       if(map_k(ik) /= myrank_k) cycle                     ! MPI
!!$       write(nfout,*) ' ik = ', ik
!!$       write(nfout,*) ' kgp,kg1,kv3 = ',kgp,kg1,kv3
!!$       write(nfout,*) ' allocated(iba)   = ',allocated(iba)
!!$       write(nfout,*) ' allocated(nbase) = ',allocated(nbase)
!!$       write(nfout,*) ' allocated(ngabc) = ',allocated(ngabc)
!!$       write(nfout,*) ' allocated(qx)    = ',allocated(qx)
!!$       write(nfout,*) ' allocated(vlength)=',allocated(vlength)

!       call k_plus_G_vectors_3D(ik,kgp,kg1,kv3,iba,nbase,vkxyz,ngabc,rltv&
!               &,qx,qy,qz,vlength)                            ! ->(bottom_Subr.)
       call k_plus_G_vectors_3D(ik,kg,kg1,kv3,iba,nbase,vkxyz,ngabc,rltv&
               &,qx,qy,qz,vlength)                            ! ->(bottom_Subr.)
       ikphig = (ik-1)/nspin + 1
       do it=1,ntyp
          call new_radr_and_wos(ik,it)                 ! --> radr, wos
          do lmt1 = 1,ilmt_phi(it)
             call m_PP_tell_lmtt_l_m_tau_phi(lmt1,it,lmtt1,il1,im1,tau1,nspher)
             call sphr(np_g1k(ik),nspher,qx,qy,qz,ylm)        ! -(bottom_Subr.)
             if(ipri >= 2) call wd_lmt_l_m_tau_etc &
                                (nfout,it,lmt1,il1,im1,tau1,lmtt1,nspher)
             snl2 = 0.d0

             if(.not.allocated(wos)) then
                write(nfout,'(" wos is not allocated")')
                stop ' wos is not allocated'
             end if
             if(.not.allocated(radr)) then
                write(nfout,'(" radr is not allocated")')
                stop ' wos is not allocated'
             end if
             if(ipri>=2) then
                write(nfout,'(" nmesh(it) = ",i8)') nmesh(it)
             end if
             if(.not.allocated(wka)) stop ' wka is not allocated'
             if(.not.allocated(wkb)) stop ' wkb is not allocated'
             if(.not.allocated(phirt)) stop ' phirt is not allocated'
             do n = 1,nmesh(it)
                facr = fac*wos(n)*radr(n)*phirt(n,il1,tau1,it)
                wka = vlength*radr(n)
!!$                call find_critical_point(1.d0,iba(ik),wka,idp)
!!$                call dsjnvn(il1-1,iba(ik),wka,idp,wkb)     ! -(bottom_Subr.)
                call dsjnv(il1-1,np_g1k(ik),wka,wkb)     ! -(bottom_Subr.)
                snl2 = snl2 + facr*wkb*ylm
             end do
             norm_phig(lmtt1,ikphig) = sum(snl2(1:np_g1k(ik))*snl2(1:np_g1k(ik)))
             phig(1:np_g1k(ik),lmtt1,ikphig) = snl2(1:np_g1k(ik))/sqrt(norm_phig(lmtt1,ikphig))
          end do
       end do
    end do

    if(ipriphig >= 2) call wd_phig

    call innerPr_deallocate_3D
    call tstatc0_end(id_sname)

  contains
    subroutine wd_phig
      integer :: i, ilmtt, ik, j, ikphig, iopr
      write(nfout,'(" << m_NLP_phir_dot_PWs.wd_phig >>")')
      write(nfout,'(" nlmtt_phi=",i3)') nlmtt_phi
      write(nfout,'(10("(",3i2,")"))') ((ngabc(i,j),j=1,3),i=1,30)
      do ik = 1, kv3, nspin
         if(map_k(ik) /= myrank_k) cycle        ! MPI
         ikphig = (ik-1)/nspin + 1
         write(nfout,'(" ik = ",i5)') ikphig
         write(nfout,'(" nbase(1:8,",i5,")",8i10)') ik,(nbase(i,ik),i=1,8)
         do ilmtt = 1, nlmtt_phi
            write(nfout,'("(ilmtt = ",i5,")",8f10.5,99(/15x,8f10.5))') ilmtt,(phig(i,ilmtt,ikphig),i=1,kg1)
         end do
         do ilmtt = 1, nlmtt_phi
            write(nfout,'("(ilmtt = ",i5,")",f10.5)') ilmtt,norm_phig(ilmtt,ikphig)
         end do
      end do
      write(nfout,'(" << m_NLP_phir_dot_PWs.wd_phig >> END")')
    end subroutine wd_phig
  end subroutine m_NLP_phir_dot_PWs_3D

  subroutine m_NLP_add_betar_dot_PWs_3D(nfout,kv3,vkxyz)

    integer,       intent(in)       :: nfout,kv3
    real(kind=DP), intent(in)       :: vkxyz(kv3,3,CRDTYP)

    real(kind=DP)       :: fac, facr
    integer             :: ik,iksnl,it,n,lmt1,lmtt1,il1,im1,tau1,nspher
    integer             :: id_sname = -1

    call tstatc0_begin('m_NLP_add_betar_dot_PWs ',id_sname,1)
!!$    write(nfout,*) ' <<< m_NLP_add_betar_dot_PWs >>>'
    call innerPr_allocate_3D()

    fac = PAI4/dsqrt(univol)
    do ik = 1, kv3, nspin
       if(map_k(ik) /= myrank_k) cycle                     ! MPI
!!$       write(nfout,*) ' ik = ', ik
!!$       write(nfout,*) ' kgp,kg1,kv3 = ',kgp,kg1,kv3
!!$       write(nfout,*) ' allocated(iba)   = ',allocated(iba)
!!$       write(nfout,*) ' allocated(nbase) = ',allocated(nbase)
!!$       write(nfout,*) ' allocated(ngabc) = ',allocated(ngabc)
!!$       write(nfout,*) ' allocated(qx)    = ',allocated(qx)
!!$       write(nfout,*) ' allocated(vlength)=',allocated(vlength)

!       call k_plus_G_vectors_3D(ik,kgp,kg1,kv3,iba,nbase,vkxyz,ngabc,rltv&
!            &,qx,qy,qz,vlength)                            ! ->(bottom_Subr.)
       call k_plus_G_vectors_3D(ik,kg,kg1,kv3,iba,nbase,vkxyz,ngabc,rltv&
            &,qx,qy,qz,vlength)                            ! ->(bottom_Subr.)
       iksnl = (ik-1)/nspin + 1
       do it=1,ntyp
          call new_radr_and_wos(ik,it)                 ! --> radr, wos
          do lmt1 = 1,ilmt_add(it)
             call m_PP_tell_lmtt_l_m_tau_add(lmt1,it,lmtt1,il1,im1,tau1,nspher)
             call sphr(np_g1k(ik),nspher,qx,qy,qz,ylm)        ! -(bottom_Subr.)
             if(ipri >= 2) call wd_lmt_l_m_tau_etc &
                                (nfout,it,lmt1,il1,im1,tau1,lmtt1,nspher)
             snl2 = 0.d0
             do n = 1,nmesh(it)
                facr = fac*wos(n)*radr(n)*betar_add(n,it)
                wka(1:np_g1k(ik)) = vlength(1:np_g1k(ik))*radr(n)
!!$                call find_critical_point(1.d0,np_g1k(ik),wka,idp)
!!$                call dsjnvn(il1-1,np_g1k(ik),wka,idp,wkb)     ! -(bottom_Subr.)
                call dsjnv(il1-1,np_g1k(ik),wka,wkb)     ! -(bottom_Subr.)
                snl2(1:np_g1k(ik)) = snl2(1:np_g1k(ik)) + facr*wkb(1:np_g1k(ik))*ylm(1:np_g1k(ik))
             end do
             snl_add(1:np_g1k(ik),lmtt1,iksnl) = snl2(1:np_g1k(ik))
          end do
       end do
    end do
    if(iprisnl >= 2) call wd_snl_add
    call innerPr_deallocate_3D
    call tstatc0_end(id_sname)

  contains
    subroutine wd_snl_add
      integer :: i, ilmtt, ik, j, iksnl
      write(nfout,'(" << m_NLP_add_betar_dot_PWs.wd_snl_add >>")')
      write(nfout,'(10("(",3i2,")"))') ((ngabc(i,j),j=1,3),i=1,30)
      do ik = 1, kv3, nspin
         if(map_k(ik) /= myrank_k) cycle        ! MPI
         iksnl = (ik-1)/nspin + 1
         write(nfout,'(" ik = ",i5)') iksnl
         write(nfout,'(" nbase(1:8,",i5,")",8i10)') ik,(nbase(i,ik),i=1,8)
         do ilmtt = 1, nlmtt_add
! === DEBUG by tkato 2013/10/30 ================================================
!           write(nfout,'("(ilmtt = ",i5,")",8f10.5,99(/15x,8f10.5))') ilmtt,(snl_add(i,ilmtt,iksnl),i=1,kg1)
            write(nfout,'("(ilmtt = ",i5,")",8f10.5,99(/15x,8f10.5))') ilmtt,(snl_add(i,ilmtt,iksnl),i=1,np_g1k(ik))
! ==============================================================================
         end do
      end do
    end subroutine wd_snl_add
  end subroutine m_NLP_add_betar_dot_PWs_3D

  subroutine m_NLP_paor_dot_PWs_3D(nfout,kv3,vkxyz)
    integer,       intent(in)       :: nfout,kv3
    real(kind=DP), intent(in)       :: vkxyz(kv3,3,CRDTYP)

    real(kind=DP)       :: fac, facr
    integer             :: ik,iksnl,it,n,lmt1,lmtt1,il1,im1,tau1,nspher
    integer             :: n1,n2,ig
    integer             :: id_sname = -1
    real(kind=DP), dimension(:,:), allocatable :: snl2_mpi, snl1

#ifndef _mNLP_no_loop_exchange_
    integer, parameter  :: lcmax = 4
    integer :: ip
    integer :: mil, mp  ! mp = maxval(np)
    integer, dimension(:),     allocatable :: nil  ! d(ntyp)
    integer, dimension(:,:),   allocatable :: nt   ! d(ntyp,mil)
    integer, dimension(:,:,:), allocatable :: tu2p ! d(ntau,ntyp,mil)
    integer, dimension(:),     allocatable :: np   ! d(mil), np=sum_{u=1}^{ntyp}(nt(u,mil))
    integer, dimension(:,:,:), allocatable ::  pm2lmtt1 ! d(mp,2*(mil-1)+1,mil)
    real(kind=DP), dimension(:,:), allocatable :: snl_t, snl_t_mpi ! d(iba(ik),mp)
    real(kind=DP), dimension(:,:), allocatable :: radr_p, wos_p ! d(n1:n2,ntyp)
    integer :: p, mradr_indp 
    logical, dimension(:,:), allocatable :: flag_radr !d(ntyp,mil)
    integer, dimension(:), allocatable   :: ip_radr !d(ntyp)
    real(kind=DP) :: r, w
#endif

    call tstatc0_begin('m_NLP_paor_dot_PWs ',id_sname,1)
!!$    write(nfout,*) ' <<< m_NLP_paor_dot_PWs >>>'
    call innerPr_allocate_3D()

    fac = PAI4/dsqrt(univol)
#ifndef _mNLP_no_loop_exchange_
    call set_index_arrays() ! mil, mp, nil, nt, tu2p, np, pm2lmtt1, contained here

    n = ceiling(dble(mmesh)/nrank_e)
    if(n == 0) n = 1
    n1 = n*myrank_e + 1
    n2 = n*(myrank_e+1)
    if(n2 > mmesh) n2 = mmesh

    allocate(flag_radr(ntyp,mil))
    allocate(ip_radr(ntyp))
!!$ASASASASAS
    flag_radr = .false. ;  ip_radr = 0
!!$ASASASASAS
    call set_flag_radr_and_ip_radr() ! -> mradr_indp,flag_radr, ip_radr

    if(n1 <= n2) then
       allocate(radr_p(n1:n2,mradr_indp))
       allocate(wos_p(n1:n2,mradr_indp))
!!$ASASASASAS
       radr_p = 0; wos_p = 0
!!$ASASASASAS
       call radr_and_wos_p(n1,n2,ntyp,mradr_indp,ip_radr,radr_p,wos_p) ! -> radr_p, wos_p
    end if

    do ik = 1, kv3, nspin
       if(map_k(ik) /= myrank_k) cycle                     ! MPI
!!$ASASASASAS
!!$       allocate(snl_t(iba(ik),mp))
!!$       if(nrank_e > 1) allocate(snl_t_mpi(iba(ik),mp))
       allocate(snl_t(np_g1k(ik),mp)); snl_t = 0
       if(nrank_e > 1) then
!!$          allocate(snl_t_mpi(maxval(np_g1k),mp)); snl_t_mpi = 0
          allocate(snl_t_mpi(np_g1k(ik),mp)); snl_t_mpi = 0
       endif
!!$ASASASASAS

!       call k_plus_G_vectors_3D(ik,kgp,kg1,kv3,iba,nbase,vkxyz,ngabc,rltv&
!            &,qx,qy,qz,vlength)                            ! ->(bottom_Subr.)
       call k_plus_G_vectors_3D(ik,kg,kg1,kv3,iba,nbase,vkxyz,ngabc,rltv&
            &,qx,qy,qz,vlength)                            ! ->(bottom_Subr.)
       iksnl = (ik-1)/nspin + 1

       do il1 = 1, mil
          snl_t = 0.d0
          do n = n1, n2
             do it = 1, ntyp
                if(il1 > nil(it)) cycle
                if(flag_radr(it,il1)) then
                   r = radr_p(n,ip_radr(it))
                   do ig = 1, np_g1k(ik)
                      wka(ig) = vlength(ig)*r
                   end do
                   call dsjnv(il1-1,np_g1k(ik),wka,wkb)     ! -(bottom_Subr.)
                end if

                w = fac * wos_p(n,ip_radr(it)) * radr_p(n,ip_radr(it))
                do tau1 = 1, nt(it,il1)
                   facr = w * paor(n,il1,tau1,it)
                   ip = tu2p(tau1,it,il1)
                   do ig = 1, np_g1k(ik)
                      snl_t(ig,ip) = snl_t(ig,ip) + facr*wkb(ig)
                   end do
                end do
             end do
          end do
          if(nrank_e > 1) then
             call mpi_allreduce(snl_t,snl_t_mpi,np_g1k(ik)*np(il1),mpi_double_precision,mpi_sum,mpi_kg_world,ierr)
             snl_t = snl_t_mpi
          end if

          do im1 = 1, 2*(il1-1)+1
             nspher = (il1-1)**2 + im1
             call sphr(np_g1k(ik),nspher,qx,qy,qz,ylm)        ! -(bottom_Subr.)
             do p = 1, np(il1)
                ip = pm2lmtt1(p,im1,il1)
                do ig = 1, np_g1k(ik)
                   paog(ig,ip,iksnl) = snl_t(ig,p)*ylm(ig)
                end do
             end do
          end do
       end do
       if(nrank_e > 1) deallocate(snl_t_mpi)
       deallocate(snl_t)
    end do

    if(n1 <= n2) deallocate(wos_p,radr_p)
    deallocate(ip_radr,flag_radr)
    call dealloc_index_arrays()

#else
    if(nrank_e > 1) then
       allocate(snl1(maxval(np_g1k),nlmtt_pao)); snl1 = 0.d0
       allocate(snl2_mpi(maxval(np_g1k),nlmtt_pao))
!!$ASASASASAS
        snl2_mpi = 0.d0
!!$ASASASASAS
    end if

    do ik = 1, kv3, nspin
       if(map_k(ik) /= myrank_k) cycle                     ! MPI

!       call k_plus_G_vectors_3D(ik,kgp,kg1,kv3,iba,nbase,vkxyz,ngabc,rltv&
!            &,qx,qy,qz,vlength)                            ! ->(bottom_Subr.)
       call k_plus_G_vectors_3D(ik,kg,kg1,kv3,iba,nbase,vkxyz,ngabc,rltv&
            &,qx,qy,qz,vlength)                            ! ->(bottom_Subr.)
       iksnl = (ik-1)/nspin + 1

       do it=1,ntyp

          n = ceiling(dble(nmesh(it))/nrank_e)
          if(n == 0) n = 1
          n1 = n*myrank_e + 1
          n2 = n*(myrank_e+1)
          if(n2 > nmesh(it)) n2 = nmesh(it)

          call new_radr_and_wos(ik,it)                 ! --> radr, wos
          do lmt1 = 1,ilmt_pao(it)
             call m_PP_tell_lmtt_l_m_tau_pao(lmt1,it,lmtt1,il1,im1,tau1,nspher)
             call sphr(np_g1k(ik),nspher,qx,qy,qz,ylm)        ! -(bottom_Subr.)
             if(ipri >= 2) call wd_lmt_l_m_tau_etc &
                                (nfout,it,lmt1,il1,im1,tau1,lmtt1,nspher)
             snl2 = 0.d0

             do n = n1, n2
                facr = fac*wos(n)*radr(n)*paor(n,il1,tau1,it)
                do ig = 1, np_g1k(ik)
                   wka(ig) = vlength(ig)*radr(n)
                end do
                call dsjnv(il1-1,np_g1k(ik),wka,wkb)     ! -(bottom_Subr.)
                do ig = 1, np_g1k(ik)
                   snl2(ig) = snl2(ig) + facr*wkb(ig)
                end do
             end do

             if(nrank_e == 1) then
                do ig = 1, np_g1k(ik)
                   paog(ig,lmtt1,iksnl) = snl2(ig)*ylm(ig)
                end do
             else
                do ig = 1, np_g1k(ik)
                   snl1(ig,lmtt1) = snl2(ig)*ylm(ig)
                end do
             end if
          end do
       end do

       if(nrank_e > 1) then
          call mpi_allreduce(snl1, snl2_mpi,maxval(np_g1k)*nlmtt_pao,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
          do lmtt1 = 1, nlmtt_pao
             do ig = 1, np_g1k(ik)
                paog(ig,lmtt1,iksnl) = snl2_mpi(ig,lmtt1)
             end do
          end do
       end if
    end do
    if(nrank_e > 1) deallocate(snl2_mpi,snl1)
#endif
    if(ipripao >= 2) call wd_paog
    call innerPr_deallocate_3D
    call tstatc0_end(id_sname)

  contains
#ifndef _mNLP_no_loop_exchange_
    subroutine set_flag_radr_and_ip_radr()
      integer :: it, il, ip, it2, is, it1

      mradr_indp = 1
      ip_radr(1) = 1
      do it = 2, ntyp
         is = 0
         search_loop: do it2 = 1, mradr_indp
            ip = ip_radr(it2)
            if((nmesh(ip) == nmesh(it) .and. dabs(xh(ip)-xh(it)) < DELTA .and. &
              & dabs(rmax(ip)-rmax(it)) < DELTA)) then
               is = it2
               exit search_loop
            end if
         end do search_loop
         if(is <= 0 .or. is > mradr_indp) then
            mradr_indp = mradr_indp+1
            is = mradr_indp
         end if
         ip_radr(it) = is
      end do

      if(ipri >= 2) then
         write(nfout,'(" !mNLP : mradr_indp = ", i5)') mradr_indp
         do it = 1, ntyp
            write(nfout,'(" !mNLP : ip_radr(",i5,") = ",i5)') it, ip_radr(it)
         end do
      end if

      do il = 1, mil
         flag_radr(1:ntyp,il) = .true.
         it1 = 0
         do it = 1, ntyp
            if(il > nil(it)) cycle
            it1 = it1+1
            if(it1 == 1) then
               flag_radr(it,il) = .true.
            else if(it1 >= 2) then
               if(ip_radr(ip) /= ip_radr(it)) then
                  flag_radr(it,il) = .true.
               else
                  flag_radr(it,il) = .false.
               end if
            end if
            ip = it
         end do
      end do

      if(ipri >= 2) then
         do il = 1, mil
            do it = 1, ntyp
               write(nfout,'(" !mNLP : flag_radr(",i5,",",i5,") = ",l3)') it,il,flag_radr(it,il)
            end do
         end do
      end if
    end subroutine set_flag_radr_and_ip_radr

    subroutine set_index_arrays()
      integer :: it, lmt1, n, il1, im1

      allocate(nil(ntyp)); nil = 0
      allocate(nt(ntyp,lcmax)); allocate(tu2p(ntau,ntyp,lcmax)); allocate(np(lcmax))
      nt = 0; tu2p = 0
      mil = 0
      if(ipri>=2) write(nfout,'(" !mNLP:    it, lmt1: lmtt1, il1, im1, tau1, nspher")')
      do it=1,ntyp
         do lmt1 = 1, ilmt_pao(it)
            call m_PP_tell_lmtt_l_m_tau_pao(lmt1,it,lmtt1,il1,im1,tau1,nspher)
            if(ipri>=2) write(nfout,'(" !mNLP: ",2i5," : ",5i5)') it,lmt1, lmtt1,il1,im1,tau1,nspher
            if(mil < il1) mil = il1
            if(nil(it) < il1) nil(it) = il1
            if(nt(it,il1) < tau1) nt(it,il1) = tau1
         end do
      end do

      do il1=1,mil
         n = 0
         np(il1) = 0
         do it=1,ntyp
            if(il1 > nil(it)) cycle
            np(il1) = np(il1)+nt(it,il1)
            do tau1=1,nt(it,il1)
               n = n+1
               tu2p(tau1,it,il1)= n
            end do
         end do
      end do

      mp = maxval(np(1:mil))
      allocate(pm2lmtt1(mp,2*(mil-1)+1,mil))
!!$ASASASASAS
      pm2lmtt1 = 0
!!$ASASASASAS
      do it = 1, ntyp
         do lmt1=1,ilmt_pao(it)
            call m_PP_tell_lmtt_l_m_tau_pao(lmt1,it,lmtt1,il1,im1,tau1,nspher)
            n = tu2p(tau1,it,il1)
            pm2lmtt1(n,im1,il1) = lmtt1
         end do
      end do

      if(ipri>=2) then
         write(nfout,'(" !mNLP: mil = ",i5)') mil
         do it = 1, ntyp
            write(nfout,'(" !mNLP: nil(",i3,") = ",i5)') it,nil(it)
         end do
         do it = 1, ntyp
            write(nfout,'(" !mNLP: nt(",i3,", : ) = ",5i5)') it,(nt(it,il1),il1=1,nil(it))
         end do

         write(nfout,'(" !mNLP: mp = ",i5)') mp
         do il1 = 1, mil
            write(nfout,'(" !mNLP: np(",i3,")=",i5)') il1, np(il1)
         end do
         do il1 = 1, mil
            do it = 1, ntyp
               if(il1 > nil(it)) cycle
               do tau1 = 1, nt(it,il1)
                  write(nfout,'(" !mNLP: tu2p(",i3,",",i3,",",i3,") = ",i5)') tau1,it,il1,tu2p(tau1,it,il1)
               end do
            end do
         end do
         do il1 = 1, mil
            do im1 = 1, 2*(il1-1)+1
               do n = 1, np(il1)
                  write(nfout,'(" !mNLP: il1 = ",i3," im1 = ",i3," n = ", i3, " pm2lmtt1 = ",i5)') &
                       & il1,im1, n,pm2lmtt1(n,im1,il1)
               end do
            end do
         end do
      end if
    end subroutine set_index_arrays

    subroutine dealloc_index_arrays()
      deallocate(pm2lmtt1,np,tu2p,nt,nil)
    end subroutine dealloc_index_arrays
#endif

    subroutine wd_paog
      integer :: i, ilmtt, ik, j, iksnl
      write(nfout,'(" << m_NLP_poor_dot_PWs.wd_paog >>")')
      write(nfout,'(10("(",3i2,")"))') ((ngabc(i,j),j=1,3),i=1,30)
      do ik = 1, kv3, nspin
         if(map_k(ik) /= myrank_k) cycle        ! MPI
         iksnl = (ik-1)/nspin + 1
         write(nfout,'(" ik = ",i5)') iksnl
         write(nfout,'(" nbase(1:8,",i5,")",8i10)') ik,(nbase(i,ik),i=1,8)
         do ilmtt = 1, nlmtt_pao
            write(nfout,'("(ilmtt = ",i5,")",8f10.5,99(/15x,8f10.5))') ilmtt,(paog(i,ilmtt,iksnl),i=1,kg1)
         end do
      end do
    end subroutine wd_paog
  end subroutine m_NLP_paor_dot_PWs_3D
!------
  subroutine m_NLP_wd_snl_3D(nfout,nfcntn_bin,F_CNTN_BIN_partitioned,kv3)
   use m_Parallelization,     only : mpi_ke_world, mpi_kg_world

    integer, intent(in) :: nfout,nfcntn_bin
    logical, intent(in) :: F_CNTN_BIN_partitioned
    integer, intent(in) :: kv3

    integer                                :: i,ik,iksnl,p,q,iend  ! MPI
    integer                                :: i1, i2
    real(kind=DP), allocatable, dimension(:,:) :: snl_wk  ! MPI
    real(kind=DP), allocatable, dimension(:,:) :: snl_mpi  ! MPI
    integer             :: id_sname = -1
#ifdef __TIMER_SUB__
  call timer_sta(1369)
#endif

    call tstatc0_begin('m_NLP_wd_snl ',id_sname)

!f    allocate(snl_wk(kg1,nlmtt))                      ! MPI
!!$ASASASASAS
!f    snl_wk = 0.d0
!!$ASASASASAS
    if(istress == 0) then
       iend = 0
    else 
       iend = 9
    end if
    do i = 0, iend
       if(F_CNTN_BIN_partitioned) then
          allocate(snl_wk(maxval(np_g1k),nlmtt))                      ! MPI
          snl_wk = 0.d0
          do iksnl = ista_snl, iend_snl
             if(i==0) then
                snl_wk = snl(:,:,iksnl)
             else
                p = mod(i,3); if(p == 0) p = 3
                q = (i-p)/3 + 1
                snl_wk = snld(:,:,iksnl,p,q)
             end if
#ifdef __TIMER_IODO__
  call timer_sta(1399)
#endif
             write(nfcntn_bin) snl_wk
#ifdef __TIMER_IODO__
  call timer_end(1399)
#endif
          end do
          deallocate(snl_wk)
       else
          allocate(snl_wk(kg1,nlmtt))                      ! MPI
          allocate(snl_mpi(kg1,nlmtt))                      ! MPI
          snl_wk = 0.d0
          do ik = 1, kv3, nspin                             ! MPI
             if(iprisnl >= 2) write(nfout,'(" ! ik = ",i5," <<m_NLP_wd_snl>>")') ik
             iksnl = (ik-1)/nspin + 1                       ! MPI
             if(map_k(ik) == myrank_k .and. myrank_e == 0 ) then  ! MPI
                if(i==0) then
!f                   snl_wk = snl(:,:,iksnl)                  ! MPI
#ifdef __TIMER_IODO__
  call timer_sta(1400)
#endif
                   do i2 = 1, nlmtt
                     do i1 = ista_g1k(ik), iend_g1k(ik)
                       snl_wk(i1,i2) = snl(i1-ista_g1k(ik)+1,i2,iksnl)                  ! MPI
                   enddo; enddo
#ifdef __TIMER_IODO__
  call timer_end(1400)
#endif
#ifdef __TIMER_IOCOMM__
  call timer_barrier(mpi_ke_world)
  call timer_sta(1401)
#endif
                   call mpi_allreduce(snl_wk,snl_mpi,kg1*nlmtt, &
                       &mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
#ifdef __TIMER_IOCOMM__
  call timer_end(1401)
#endif
                else
                   p = mod(i,3); if(p == 0) p = 3           ! MPI
                   q = (i-p)/3 + 1                          ! MPI
!f                   snl_wk = snld(:,:,iksnl,p,q)             ! MPI
#ifdef __TIMER_IODO__
  call timer_sta(1402)
#endif
                   do i2 = 1, nlmtt
                     do i1 = ista_g1k(ik), iend_g1k(ik)
                       snl_wk(i1,i2) = snld(i1-ista_g1k(ik)+1,i2,iksnl,p,q)                  ! MPI
                   enddo; enddo
#ifdef __TIMER_IODO__
  call timer_end(1402)
#endif
#ifdef __TIMER_IOCOMM__
  call timer_barrier(mpi_ke_world)
  call timer_sta(1403)
#endif
                   call mpi_allreduce(snl_wk,snl_mpi,kg1*nlmtt, &
                       &mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
#ifdef __TIMER_IOCOMM__
  call timer_end(1403)
#endif
                end if
!f                if(map_k(ik) /= 0) call mpi_send(snl_mpi,kg1*nlmtt,mpi_double_precision &
!f                     &         ,0,1,mpi_comm_group,ierr)    ! MPI
!f             else if(mype == 0 .and. map_k(ik) /= 0) then   ! MPI
!f                call mpi_recv(snl_wk,kg1*nlmtt,mpi_double_precision,map_k(ik)*nrank_e &
!f                     &            ,1,mpi_comm_group,istatus,ierr) !MPI
             end if                                         ! MPI
!f             if(mype == 0) write(nfcntn_bin) snl_wk         ! MPI
#ifdef __TIMER_IODO__
  call timer_sta(1404)
#endif
             if(mype == 0) write(nfcntn_bin) snl_mpi         ! MPI
#ifdef __TIMER_IODO__
  call timer_end(1404)
#endif
          end do
          deallocate(snl_wk)
          deallocate(snl_mpi)
       end if
    end do
    if(iprisnl >= 2) then
       write(nfout,'(" ! snl is written (m_NLP_wd_snl)")')
       if(F_CNTN_BIN_partitioned) then
          write(nfout,'(" ! snl size = ",i9)') kg1*nlmtt*(iend_snl-ista_snl+1)*8
       else
          write(nfout,'(" ! snl size = ",i9)') kg1*nlmtt*kv3*8
       end if
    end if
!f    deallocate(snl_wk)
    call tstatc0_end(id_sname)
#ifdef __TIMER_SUB__
  call timer_end(1369)
#endif
  end subroutine m_NLP_wd_snl_3D

  subroutine m_NLP_rd_snl_3D(nfout,nfcntn_bin,F_CNTN_BIN_partitioned,kv3)
   use m_Parallelization,     only : mpi_ke_world, mpi_kg_world

    integer, intent(in) :: nfout,nfcntn_bin
    logical, intent(in) :: F_CNTN_BIN_partitioned
    integer, intent(in) :: kv3

    integer                                :: i,ik,iksnl,p,q,iend  ! MPI
    integer                                :: i1, i2
    real(kind=DP), allocatable, dimension(:,:) :: snl_wk  ! MPI
    integer             :: id_sname = -1
#ifdef __TIMER_SUB__
  call timer_sta(1368)
#endif

    call tstatc0_begin('m_NLP_rd_snl ',id_sname)
!f    allocate(snl_wk(kg1,nlmtt))                      ! MPI
!!$ASASASASAS
!f    snl_wk = 0.d0
!!$ASASASASAS
    if(iprisnl >= 2) write(nfout,'(" kg1 = ",i6, " nlmtt = ",i6)') kg1,nlmtt
    if(iprisnl >= 2) write(nfout,'(" ! nfcntn_bin = ", i6)') nfcntn_bin
    if(istress == 0) then
       iend = 0
    else 
       iend = 9
    end if
    do i = 0, iend                                       ! MPI
       if(F_CNTN_BIN_partitioned) then
          allocate(snl_wk(maxval(np_g1k),nlmtt))                      ! MPI
          snl_wk = 0.d0
#ifdef __TIMER_IODO__
  call timer_sta(1395)
#endif
          do iksnl = ista_snl, iend_snl
             if(iprisnl >= 2) write(nfout,'(" iksnl = ",i6, " <<m_NLP_rd_snl>>")') iksnl
             read(nfcntn_bin) snl_wk
             if(i==0) then
                snl(:,:,iksnl) = snl_wk
             else
                p = mod(i,3); if(p == 0) p = 3           ! MPI
                q = (i-p)/3 + 1                          ! MPI
                snld(:,:,iksnl,p,q) = snl_wk             ! MPI
             end if
          end do
#ifdef __TIMER_IODO__
  call timer_end(1395)
#endif
          deallocate(snl_wk)
       else
          allocate(snl_wk(kg1,nlmtt))                      ! MPI
          snl_wk = 0.d0
          do ik = 1, kv3, nspin                             ! MPI
             if(iprisnl >= 2) write(nfout,'(" ik = ",i6, " <<m_NLP_rd_snl>>")') ik
             iksnl = (ik-1)/nspin + 1                       ! MPI
#ifdef __TIMER_IODO__
  call timer_sta(1396)
#endif
             if(mype == 0) read(nfcntn_bin) snl_wk          ! MPI
#ifdef __TIMER_IODO__
  call timer_end(1396)
#endif
             if(iprisnl >= 2) write(nfout,'(" snl_wk is read")')
!f             if(mype == 0 .and. map_k(ik) /= 0) then        ! MPI
!f                call mpi_send(snl_wk,kg1*nlmtt,mpi_double_precision,map_k(ik)*nrank_e,1 &
!f                     &            , mpi_comm_group,ierr)       ! MPI
!f             else if(map_k(ik) /= 0 .and. map_k(ik) == myrank_k .and. myrank_e == 0) then ! MPI
!f                call mpi_recv(snl_wk,kg1*nlmtt,mpi_double_precision,0,1 &
!f                     &            , mpi_comm_group,istatus,ierr) ! MPI
!f             end if
#ifdef __TIMER_IOCOMM__
  call timer_barrier(mpi_comm_group)
  call timer_sta(1397)
#endif
             call mpi_bcast(snl_wk,kg1*nlmtt &
               & ,mpi_double_precision,0,mpi_comm_group,ierr)
#ifdef __TIMER_IOCOMM__
  call timer_end(1397)
#endif

             if(map_k(ik) == myrank_k) then                 ! MPI
!f                call mpi_bcast(snl_wk,kg1*nlmtt,mpi_double_precision,0 &
!f                     &              ,mpi_k_world(myrank_k),ierr) ! MPI
#ifdef __TIMER_IODO__
  call timer_sta(1398)
#endif
                if(i==0) then
!f                   snl(:,:,iksnl) = snl_wk                  ! MPI
                   do i2 = 1, nlmtt
                     do i1 = ista_g1k(ik), iend_g1k(ik)
                       snl(i1-ista_g1k(ik)+1,i2,iksnl) = snl_wk(i1,i2)
                   enddo; enddo
                else
                   p = mod(i,3); if(p == 0) p = 3           ! MPI
                   q = (i-p)/3 + 1                          ! MPI
!f                   snld(:,:,iksnl,p,q) = snl_wk             ! MPI
                   do i2 = 1, nlmtt
                     do i1 = ista_g1k(ik), iend_g1k(ik)
                       snld(i1-ista_g1k(ik)+1,i2,iksnl,p,q) = snl_wk(i1,i2)
                   enddo; enddo
                end if
#ifdef __TIMER_IODO__
  call timer_end(1398)
#endif
             end if
          end do
          deallocate(snl_wk)
       end if
    end do
!f    deallocate(snl_wk)
    call tstatc0_end(id_sname)
#ifdef __TIMER_SUB__
  call timer_end(1368)
#endif
  end subroutine m_NLP_rd_snl_3D
! === For epsmain by tkato 2013/11/14 ==========================================
  subroutine m_NLP_epsmain_reallocate()
    if(allocated(snl)) deallocate(snl)
    allocate(snl(maxval(np_g1k),nlmtt,ista_snl:iend_snl)); snl = 0.d0
    if(allocated(snl_add)) deallocate(snl_add)
    allocate(snl_add(maxval(np_g1k),nlmtt_add,ista_snl:iend_snl)); snl_add = 0.d0
  end subroutine m_NLP_epsmain_reallocate
! ==============================================================================

end module m_NonLocal_Potential

!=======================================================================
!
!  PROGRAM  PHASE/0 2014.01 (rev.375)
!
!  "First-principles Electronic Structure Calculation Program"
!
!  SUBROUINE: Renewal_of_Hubbard_Potential
!
!  AUTHOR(S): T. Yamamoto   May/08/2005
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
! ==========================
!     patch 0.1 by K. Tagami @adv    2009/04/21
!
!     patch 0.1 : commented out an if sentence for band calculation with DFT+U
!=======================================================================
!
!   Since 2002, this program set had been intensively developed as a part of the following 
!  national projects supported by the Ministry of Education, Culture, Sports, Science and 
!  Technology (MEXT) of Japan; "Frontier Simulation Software for Industrial Science 
!  (FSIS)" from 2002 to 2005, "Revolutionary Simulation Software (RSS21)" from 2006 to 
!  2008. "Research and Development of Innovative Simulation Software (RISS)" from 2008 
!  to 2013. These projects is lead by the Center for Research on Innovative Simulation 
!  Software (CISS), the Institute of Industrial Science (IIS), the University of Tokyo.
!   Since 2013, this program set has been further developed centering on PHASE System 
!  Consortium. 
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
subroutine Renewal_of_Hubbard_Potential()
! $Id: Renewal_of_Hubbard_Potential.f90 285 2013-01-01 04:33:41Z ktagami $
  use m_ES_Intgr_VlhxcQlm,   only : m_ESiVQ_add_dhub_to_vlhxcQ
  use m_Files,               only : nfout
  use m_Hubbard,             only : m_Hubbard_Potential
  use m_Control_Parameters,  only : icond
  use m_Const_Parameters,    only : FIXED_CHARGE, FIXED_CHARGE_CONTINUATION

! ================================== K. Tagami ================== 5.0
  use m_Hubbard,             only : m_Hubbard_Potential2
! =============================================================== 5.0


! ============================ added by K. Tagami ================ 11.0
  use m_Control_Parameters,   only : noncol
  use m_Electronic_Structure,  only : vlhxcQ
! ===================================================================== 11.0

  implicit none
 
! =========================== Modified by K. Tagami ============= 0.1
!!!  if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) return
! ==============================================================

! =================================== modifed by K. Tagami ============- 5.0
!  call m_Hubbard_Potential(nfout)       ! -> dhub
  call m_Hubbard_Potential2(nfout)       ! -> dhub
! ====================================================================== 5.0
  

  call m_ESiVQ_add_dhub_to_vlhxcQ(nfout)! vlhxcQ = vlhxcQ + dhub
  

end subroutine Renewal_of_Hubbard_Potential

!=======================================================================
!
!  PROGRAM  PHASE/0 2014.01 (rev.375)
!
!  "First-principles Electronic Structure Calculation Program"
!
!  PROGRAM: vdW-Soler
!
!  AUTHOR(S): Y. Ono
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!   The original version of this set of the computer programs "PHASE" was developed by 
!  the members of the Theory Group of Joint Research Center for Atom Technology 
!  (JRCAT), based in Tsukuba, in the period 1993-2001.  
!   Since 2002, this program set had been intensively developed as a part of the following 
!  national projects supported by the Ministry of Education, Culture, Sports, Science and 
!  Technology (MEXT) of Japan; "Frontier Simulation Software for Industrial Science 
!  (FSIS)" from 2002 to 2005, "Revolutionary Simulation Software (RSS21)" from 2006 to 
!  2008. "Research and Development of Innovative Simulation Software (RISS)" from 2008 
!  to 2013. These projects is lead by the Center for Research on Innovative Simulation 
!  Software (CISS), the Institute of Industrial Science (IIS), the University of Tokyo.
!   Since 2013, this program set has been further developed centering on PHASE System 
!  Consortium. 
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!

!********************************** Note ******************************************
! This program calculates the non-local correlation energy (Ecnl) and 
! the local correlation energy (EcLDA) as the post calculation by utilizing
! the output files from the PHASE. By adding these correlation terms as
!    E_total = E_total(GGAx) + EcLDA + Ecnl,
! the van der Waals interaction will be included into the total energy.
!
! This program follows the Dion et al's 1-shot method (so called vdW-DF), and 
! the Roman-Perez et al's convolution algorithm. Because of this convolution,
! the CPU cost in this program is reduced to O(NlogN) from the original O(N**2).
!                                 (Reference; M.Dion et al. PRL 92 (2004) 246401.)
!                         (Reference; G.Roman-Perez et al. PRL 103 (2009) 096102.)
!
!
! Periodic systems are assumed.
! The atomic units (Hartree) are used.
!
!
!
! ++++++++ List of subroutines ++++++
! All subroutine files listed below are included in this file.
! In addition to the below list, it is necessary to link to a FFT library, for example FFTW3.
!
! CPU_TIME             : Check the calculation time.
! derivation           : Calculate the derivations of the electron density distribution.
! d_q0                 : Obtain q(rho(r)) from the electron density rho(r) and its derivations.
! spline               : Determine the function 'p(q)' for bi-cubic spline interpolation. 
!                        Here p(r) is defined as, phi(q1,q2,r12) = SUM_ab(p(qa)*p(qb)*phi(qa,qb,r12)).
! theta_ab             : Multiply theta(r) = p(r)*rho(r) by use of the given parameter qa or qb.
! RtoG                 : Calculate the Fourier transform of theta(r) within the FFT algorithm.
! phiab                : Calculate the Fourier transform of the kernel phi(r) by use of the given 
!                        parameter qa and qb. phi(r) does not depends on angular components,
!                        so that it can be done within the radial mesh.
! convolution_3d       : Calculate the integral SUM(dk*theta_a(k)*theta_b(k)*phi(k)).
! piDphi               : Calculate the local part of dr**2*rho(r1)*rho(r2)*phi(r1,r2,r12) directory.
!                        The local part includes the singular point, thus it is necessary to execute
!                        the 3D space integral directory.
! cLDA                 : Obtain the LDA version of correlation term EcLDA.
! outputs              : Output the results.
! kernel_phi           : Calculate the value of kernel phi(d1,d2).
! gauleg               : Prepare the grid points for the Gauss-Legendre integral.
!
!
!
! ++++++++ Input & Output +++++++++++
! Input files  (Both of the input files will be output by PHASE.)
!   nfchr.cube        : An electron density distribution file given by
!                       GGA(exchange only) calculation
!   nfefn.data        : The total energy given by GGA(exchange only) calculation
!
! Output   E_total(vdW-DF) = E_total(GGAx) + EcLDA + Ecnl
!   E_total(GGAx)     : Total energy given by GGA(exchange only) calculation
!   Ecnl              : Non-local Correlation energy
!   EcLDA             : LDA Correlation energy
!
!
!
! ++++++ Internal parameters ++++++++
! dq      (       )   : The smallest distance between the grid points for bi-cubic 
!                       spline interpolation. The grid points are plotted in logarithmic manner.
! lamda   (       )   : The power of dq
! nr12    (       )   : The number of the grid points for the kernel phi(r12)
! phi0    (       )   : One of the coefficients in the 'soft' function, 
!                       phi_s(r12) = phi0 + phi2*d**2 + phi4*d**4. phi2 and phi4 will be 
!                       eventually determined to match the value and the slope of phi_s and 
!                       those of phi at d=d_s, in the program.
! ds      (       )   : The connection point of phi_s and phi
! r12max  (       )   : The cutoff for r12
! rhomin  (       )   : Minimum value of electron density. 
!                       If the electron density was smaller than rhomin, then the program 
!                       will read as this minimum value in order to avoid a divergence.
! nk      (       )   : The number of the grid points plotted for the Fourier 
!                       transformed kernel phi(k)
! maxk    (       )   : The cutoff for k
!
!
!                                              Written by Youky Ono in June/2013
!**********************************************************************************


 Program vdW_Soler
 Implicit None


!++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
! Physical values
   Real(8) ExGGA,Ecnl,Ecnl_12,Ecnl_12_ab,Ecnl_3,Ecnl_3s,EcLDA

! Integers
   Integer i,j,k, cir,cia,cib,cic, cjr,cja,cjb,cjc, ckr,cka,ckb,ckc, ca,cb

! The unit cell and the electron density information
   Integer na,nb,nc,nabc
   Character*4   ::  acube,bcube
   Integer       ::  ncube
   Real(8) n1,n2,n3,dcube(3,3),aa(3,3),dv
   Real(8), Allocatable :: rho(:,:,:),dxrho(:,:,:),dyrho(:,:,:),dzrho(:,:,:),atom(:,:)


! Grid points
!!!! Spline curves
      Integer nq0,cqa,cqb
      Real(8) q0,qa,qb,q0max,q0min,lamda,dq,q0cut
      Parameter (dq=0.05, lamda=1.03, q0cut=3)
      Real(8), Allocatable :: mW(:,:)

!!!! The table of phidD
      Real(8) ds
      Parameter (ds=0.05)

!!!! The function phi_ab
      Integer nr12,cr12
      Parameter (nr12=4500)
      Real(8) r12,r12max,phi0,phi_ab(0:nr12)
      Parameter (phi0=2.77, r12max=15)
! End Grid points


! Internal parameters
   Real(8) rhomin 
   Parameter (rhomin=1d-9)

! Real-space and reciprocal-space Functions
   Complex*16, Allocatable :: theta_G(:,:,:),     &
&                             theta_G_ab(:,:,:,:),theta_G_a(:,:,:),theta_G_b(:,:,:)
   Real(8), Allocatable :: theta_R(:,:,:)

! Variables for check
   Real(8) term1,term2,term3,term4,term5,q1,q2,n,nnx,nny,nnz

! Estimate running time
   Real(8) time
   Integer hh,mm,ss
!++++++++++++++++++++++++ end VARIABLES ++++++++++++++++++++++++



!++++++++++++++ Read the file nfefn.data and nfchr.cube ++++++++
!++++++++++++++ and be ready for the calculation +++++++++++++++
   Call CPU_TIME(time)

   i = 0
   Open(7,FILE='nfefn.data',status='old')
   Do
     Read(7,'()',END=999)
     i = i + 1
   Enddo
   999 close(7)
   Open(6,file='nfefn.data')
   Read(6,*) acube
   Do j = 1,i-1
     Read(6,*) n1,n2,n3
   Enddo
   ExGGA = n3
   Close(6)

   Open(5,file='nfchr.cube')
   Read(5,*) acube
   Read(5,*) bcube

   Read(5,*) ncube,n1,n2,n3
   Read(5,*) na,aa(1,1),aa(1,2),aa(1,3)
   Read(5,*) nb,aa(2,1),aa(2,2),aa(2,3)
   Read(5,*) nc,aa(3,1),aa(3,2),aa(3,3)
   Allocate(atom(ncube,5))

   Read(5,*) ((atom(i,j),j=1,5),i=1,ncube)
   Allocate(rho(na,nb,nc))
      Read(5,*) (((rho(i,j,k),k=1,nc),j=1,nb),i=1,na)
   Close(5)

   Allocate(dxrho(na,nb,nc))
   Allocate(dyrho(na,nb,nc))
   Allocate(dzrho(na,nb,nc))
   Allocate(theta_G(-(na/2-1):na/2,-(nb/2-1):nb/2,-(nc/2-1):nc/2))
   Allocate(theta_R(na,nb,nc))
   Allocate(theta_G_a(-(na/2-1):na/2,-(nb/2-1):nb/2,-(nc/2-1):nc/2))
   Allocate(theta_G_b(-(na/2-1):na/2,-(nb/2-1):nb/2,-(nc/2-1):nc/2))

   Call derivation(na,nb,nc,aa,rho,dv,dxrho,dyrho,dzrho)

   q0max = q0cut*1.01
   q0min = 0.09

   nq0 = NINT(LOG((q0max-q0min)*(lamda-1.0)/dq+1.0)/LOG(lamda))+1
!   write(*,*) q0max,q0min,nq0

   Allocate(mW(nq0,nq0))
   Allocate(theta_G_ab(nq0,-(na/2-1):na/2,-(nb/2-1):nb/2,-(nc/2-1):nc/2))

   Call spline(nq0,dq,lamda,mW)
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++



!!! HOT Spot !!!
!+++++++++++++++ Execute FFT for theta_R_ab ++++++++++++++++++++
   Do cqa = 1,nq0
      Call theta_ab(na,nb,nc,cqa,nq0,q0min,q0max,dq,lamda,rho,dxrho,dyrho,dzrho,rhomin,mW,theta_R)
      Call RtoG(na,nb,nc,theta_R,theta_G)
      Do cia = -(na/2-1),na/2
      Do cib = -(nb/2-1),nb/2
      Do cic = -(nc/2-1),nc/2
         theta_G_ab(cqa,cia,cib,cic) = theta_G(cia,cib,cic)
      Enddo
      Enddo
      Enddo
   Enddo
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++



!+++++++++++++++ Start double-roop cqa and cqb +++++++++++++++++
   Ecnl_12 = 0.0
! When cqa < cqb
   Do cqa = 1,nq0-1
      Do cia = -(na/2-1),na/2
      Do cib = -(nb/2-1),nb/2
      Do cic = -(nc/2-1),nc/2
         theta_G_a(cia,cib,cic) = theta_G_ab(cqa,cia,cib,cic)
      Enddo
      Enddo
      Enddo

      Do cqb = cqa+1,nq0
         Do cia = -(na/2-1),na/2
         Do cib = -(nb/2-1),nb/2
         Do cic = -(nc/2-1),nc/2
            theta_G_b(cia,cib,cic) = theta_G_ab(cqb,cia,cib,cic)
         Enddo
         Enddo
         Enddo

         Call phiab(cqa,cqb,nr12,r12max,ds,nq0,q0min,dq,lamda,phi0,phi_ab)
         Call convolution_3d(nq0,na,nb,nc,cqa,cqb,aa,nr12,r12max,theta_G_a,theta_G_b,phi_ab,Ecnl_12_ab)

         Ecnl_12 = Ecnl_12 + Ecnl_12_ab

      Enddo
   Enddo

   Ecnl_12 = Ecnl_12 * 2.0


! When cqa = cqb
   Do cqa = 1,nq0
      cqb = cqa
      Do cia = -(na/2-1),na/2
      Do cib = -(nb/2-1),nb/2
      Do cic = -(nc/2-1),nc/2
         theta_G_a(cia,cib,cic) = theta_G_ab(cqa,cia,cib,cic)
         theta_G_b(cia,cib,cic) = theta_G_ab(cqb,cia,cib,cic)
      Enddo
      Enddo
      Enddo

      Call phiab(cqa,cqb,nr12,r12max,ds,nq0,q0min,dq,lamda,phi0,phi_ab)
      Call convolution_3d(nq0,na,nb,nc,cqa,cqb,aa,nr12,r12max,theta_G_a,theta_G_b,phi_ab,Ecnl_12_ab)

      Ecnl_12 = Ecnl_12 + Ecnl_12_ab

   Enddo
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++



!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   Call piDphi(na,nb,nc,rho,dxrho,dyrho,dzrho,rhomin,q0min,q0max,dv,ds,Ecnl_3,Ecnl_3s,phi0)
   Call cLDA(na,nb,nc,rho,rhomin,dv,EcLDA)
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++



!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   Call outputs(ExGGA,EcLDA,Ecnl_12,Ecnl_3,Ecnl_3s)
   Call CPU_TIME(time)
      ss=time
      hh=time/3600
      ss=Mod(ss,3600)
      mm=ss/60
      ss=Mod(ss,60)
      time=time-3600*hh-60*mm-ss
      Write(*,16) hh,mm,ss+time
 16    Format('# Calculation time ',I5,':',I2,':',F7.4)
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


 End Program vdW_Soler
!*******************************************************************************************************
!*** End of the main program  **************************************************************************
!*******************************************************************************************************





!** SUBROUTINE CPU_TIME ********************************************************************************
 Subroutine CPU_TIME(time)
   REAL(8) time
   Integer count,count_rate,hh,mm,ss

   Call System_clock(count,count_rate)
   If(count_rate.Eq.0) Then
      time=REAL(count)/count_rate
   Else
      time=-1
   End If

 End Subroutine CPU_TIME
!** End SUBROUTINE CPU_TIME ****************************************************************************



!** SUBROUTINE gauleg **********************************************************************************
 Subroutine gauleg(x1,x2,n,xi,wi)
 Implicit none


!++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
   Integer  m,j,i,n
   REAL(8)  x1,x2,z1,z,xm,xl,pp,p3,p2,p1,pi,eta
   Parameter (pi=3.1415926535897932 , eta=0.0000000001)

   REAL(8)  ::  xi(n),wi(n)
!++++++++++++++++++++++++ end VARIABLES ++++++++++++++++++++++++



!---------------------- Calculation Start ----------------------
   m=(n+1)/2
   xm=0.5*(x2+x1)
   xl=0.5*(x2-x1)
   Do i=1,m
      z=COS(pi*(i-0.25)/(n+0.5))
      z1=1.d+10
      Do While (ABS(z-z1).GT.eta)
         p1=1.0
         p2=0.0

         Do j=1,n
            p3=p2
            P2=p1
            p1=((2.0*j-1.0)*z*p2-(j-1.0)*p3)/j
         Enddo

         pp=n*(z*p1-p2)/(z*z-1.0)
         z1=z
         z=z1-p1/pp

      Enddo

      xi(i) = xm-xl*z
      xi(n+1-i) = xm+xl*z
      wi(i) = 2.0*xl/((1.0-z*z)*pp*pp)
      wi(n+1-i) = wi(i)

   Enddo
 End Subroutine gauleg
!** End SUBROUTINE gauleg ******************************************************************************



!** SUBROUTINE piDphi **********************************************************************************
 Subroutine piDphi(nx,ny,nz,rho,dxrho,dyrho,dzrho,rhomin,q0min,q0max,dv,ds,Ecii,Ecii_s,phi0)
 implicit none


!++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
   Integer  nx,ny,nz,nspin
   Real(8) da,db,a1,a2,dr
   Parameter (dr = 0.001)
   Integer  ci,cj,ck,ca,cb

! Gauss-Legendre integration
   Integer cD,nD
   Parameter (nD=10)
   Real(8) rhomin,maxD,minD,dD,LD,PLD,LDxi(nD),LDwi(nD)
   Parameter (minD=0)

   Integer  cix,ciy,ciz,cir,cjx,cjy,cjz,cjr
   Real(8)  di,dj,dk,d_di,d_dj,d_dk,eta,dx,dy,dz,dv,n,ni,nj,nk
   Integer  i,j,k,zxp,zxm,zyp,zym,zzp,zzm
!   Parameter (eta=0.00000001)

   Real(8) x,nnx,nny,nnz,nn2,r,r12
   Real(8) nxp,nxm,nyp,nym,nzp,nzm
   Real(8) zx(-3:3),zy(-3:3),zz(-3:3),rn(3,-3:3)
   Real(8)  ::  rho(nx,ny,nz) &
&            ,dxrho(nx,ny,nz),dyrho(nx,ny,nz),dzrho(nx,ny,nz)

   Real(8) pi,q0,term,term1,term2,q0min,q0max
   Parameter (pi=3.1415926535897932)

   Real(8) phi

   Real(8) Ecii,Ecii_s,temp,ds,rs,phid_s,phid_s1,d_phid_s,phi0,phi2,phi4

! The table of phi1D
      Integer c1D,n1D
      Parameter(n1D = 1000)
      Real(8) d1D,max1D,D,phix,phiy
      Real(8) phi1D(0:n1D+1)
!++++++++++++++++++++++++ end VARIABLES ++++++++++++++++++++++++



!---------------------- Calculation Start ----------------------
! Make the table of phi1D
 max1D = ds
 d1D = max1D/REAL(n1D)
 Do c1D = 0,n1D+1
    D = REAL(c1D)*d1D
    Call kernel_phi(D,D,phi)
    phi1D(c1D) = phi
 Enddo


 Ecii = 0
 Do cjr = 1,nx*ny*nz
    cjx = 1+(cjr-1-MOD(cjr-1+ny*nz,ny*nz))/(ny*nz)
    cjy = 1+(cjr-ny*nz*(cjx-1)-1-MOD(cjr-1+nz,nz))/nz
    cjz = cjr-nz*(ny*(cjx-1)-1+cjy)

    n = MAX(rho(cjx,cjy,cjz),rhomin)

    nnx = dxrho(cjx,cjy,cjz)
    nny = dyrho(cjx,cjy,cjz)
    nnz = dzrho(cjx,cjy,cjz)

    Call d_q0(n,nnx,nny,nnz,q0min,q0max,q0)
    maxD=ds

    Call gauleg(minD,maxD,nD,LDxi,LDwi)

    temp = 0
    Do cD=1,nD
       LD = LDxi(cD)

        c1D = AINT(LD/d1D)
        phix = LD - d1D*REAL(c1D)
        phiy = 1.0 - phix
        temp = temp + LDwi(cD)*4*pi*(LD**2) * (phiy*phi1D(c1D) + phix*phi1D(c1D+1))

    Enddo

    Ecii = Ecii + dv*0.5*(n**2)*temp/(q0**3)

 Enddo


 Ecii_s = 0
 Do cjr = 1,nx*ny*nz
    cjx = 1+(cjr-1-MOD(cjr-1+ny*nz,ny*nz))/(ny*nz)
    cjy = 1+(cjr-ny*nz*(cjx-1)-1-MOD(cjr-1+nz,nz))/nz
    cjz = cjr-nz*(ny*(cjx-1)-1+cjy)

    n = MAX(rho(cjx,cjy,cjz),rhomin)

    nnx = dxrho(cjx,cjy,cjz)
    nny = dyrho(cjx,cjy,cjz)
    nnz = dzrho(cjx,cjy,cjz)

! Coefficients phi2 and phi4 in the local part is determined to
! match the non-local part in value and slope at d=d_s.

    Call d_q0(n,nnx,nny,nnz,q0min,q0max,q0)
    rs = ds/SQRT(q0**2+q0**2)
    di = q0*rs
    dk = q0*rs
    c1D = AINT(di/d1D)
    phix = di - d1D*REAL(c1D)
    phiy = 1.0 - phix
    phid_s = phiy*phi1D(c1D) + phix*phi1D(c1D+1)

    di = q0*(rs+dr)
    dk = q0*(rs+dr)
    c1D = AINT(di/d1D)
    phix = di - d1D*REAL(c1D)
    phiy = 1.0 - phix
    phid_s1 = phiy*phi1D(c1D) + phix*phi1D(c1D+1)

    d_phid_s = (phid_s1- phid_s)/dr

    phi2 = ( 2.0/ds**2)*(phid_s-phi0) - (rs/(2.0*ds**2))*d_phid_s
    phi4 = (-1.0/ds**4)*(phid_s-phi0) + (rs/(2.0*ds**4))*d_phid_s

    Ecii_s = Ecii_s + 0.5*4*pi*dv*(n**2)*                   &
&                    (phi0*(rs**3)*(q0**0)/3.0 +            &
&                     phi2*(rs**5)*(q0**2)/5.0 +            &
&                     phi4*(rs**7)*(q0**4)/7.0)


 Enddo

 End Subroutine piDphi
!** End SUBROUTINE piDphi **********************



!** SUBROUTINE cLDA ****************************
 Subroutine cLDA(nx,ny,nz,rho,rhomin,dv,EcLDA)
 Implicit none

!************************ Note *********************************
! This Algorism follows Dion's 1-shot method.
!
! This program is a subroutine.
! This program calculates the correlation energy from LDA.
! The formula is given at Eq.(58) (p.93) of 'Theory of the
!   Inhomogeneous Electron Gas' Lundqvist, March.
!
!
! Input
!   rho(nrxyz,nsipn) : Total density
!
! Output
!   EcLDA : Corrilation energy from LDA.
!
!
!                            Written by Youky Ono in 2009/Jul.
!***************************************************************



!++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
      integer  nx,ny,nz,nspin
      integer  ci,cj,ck,cjx,cjy,cjz
      real(8)  dx,dy,dz,dv,eta
      integer  i,j,k
      parameter (eta=0.00000001)

      real(8) rs,x,aB,ec,EcLDA,n,rhomin
      real(8)  ::  rho(nx,ny,nz)
      parameter (aB=1) ! aB=1[a.u.]

      real(8)  pi,e,m
      parameter (pi=3.1415926535897932)
      parameter (e=1,m=1) ! Hatree atomic unit
!++++++++++++++++++++++++ end VARIABLES ++++++++++++++++++++++++



!---------------------- Calculation Start ----------------------
      EcLDA=0
   Do cjx=1,nx
   Do cjy=1,ny
   Do cjz=1,nz
      n = MAX(rho(cjx,cjy,cjz),rhomin)

      rs = ((3/(4*pi*n))**0.3333333333333333)/aB
      x = rs/11.4
      ec = -0.0666*0.5*((1+x**3)*LOG(1+1/x)-x**2+x/2-1/3)

      EcLDA = EcLDA + dv*n*ec

   Enddo
   Enddo
   Enddo


 End Subroutine cLDA
!** End SUBROUTINE cLDA **********************



!** SUBROUTINE RtoG ***************************************************************************
! Execute FFT and transform theta_R to theta_G
  Subroutine RtoG(na,nb,nc,theta_R,theta_G)
  Implicit none

  include "fftw3.f"


!++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
  Integer  na,nb,nc,cix,ciy,ciz,ca,cb,cc
  Real(8) rx,ry,rz,kx,ky,kz,ra,rb,rc,ka,kb,kc,rk,r12,x,y,z,term,term1

  Real(8) theta_R(na,nb,nc)
  Complex*16 theta_G(-(na/2-1):na/2,-(nb/2-1):nb/2,-(nc/2-1):nc/2)

! FFTW3 !!!
  integer(8) :: plan
!  Integer(8) plan,FFTW_FORWARD,FFTW_ESTIMATE
!  Parameter(FFTW_FORWARD=-1, FFTW_ESTIMATE=64)
!!$  Complex*16 temp_R(na,nb,nc),temp_G(0:na-1,0:nb-1,0:nc-1)
  Complex*16,allocatable :: temp_R(:,:,:),temp_G(:,:,:)
!+++++++++++++++++++++ End VARIABLES +++++++++++++++++++++++++++

  allocate(temp_R(na,nb,nc))
  allocate(temp_G(0:na-1,0:nb-1,0:nc-1))

!***** FFT **************************************************
  Do cix = 1,na
  Do ciy = 1,nb
  Do ciz = 1,nc
     temp_R(cix,ciy,ciz) = CMPLX(theta_R(cix,ciy,ciz))
  Enddo
  Enddo
  Enddo

! FFTW3 !!!
  call dfftw_plan_dft_3d(plan,na,nb,nc,temp_R,temp_G,FFTW_FORWARD,FFTW_ESTIMATE)
  call dfftw_execute_dft(plan,temp_R,temp_G)
  call dfftw_destroy_plan(plan)

  Do ca = -(na/2-1),na/2
  Do cb = -(nb/2-1),nb/2
  Do cc = -(nc/2-1),nc/2
     cix = MOD(ca+na,na)
     ciy = MOD(cb+nb,nb)
     ciz = MOD(cc+nc,nc)
     theta_G(ca,cb,cc) = temp_G(cix,ciy,ciz) / REAL(na*nb*nc)
  Enddo
  Enddo
  Enddo
!***** END of FFT ******************************************

  deallocate(temp_R)
  deallocate(temp_G)
End subroutine RtoG
!** End SUBROUTINE RtoG ***********************************************************************



!** SUBROUTINE convolution_3d *****************************************************************
  Subroutine convolution_3d(nq0,na,nb,nc,cqa,cqb,aa,nr12,r12max,theta_G_a,theta_G_b,phi_ab,Ecnl_12_ab)

  Implicit none


!++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
  Integer i,j,k,cx1,nx1,cx2,nx2,cx,nx,nx3,nx4,cx12,nk,cr,ck,cqa,cqb,nq0
  Real(8) dx,dx1,dx2,maxk,x1,x2,x12,pi,T,s,func,dk
  Parameter(pi=3.14159265358979)
  Parameter(nk=7000, maxk=10)

  Complex*16 theta_G_a(-(na/2-1):na/2,-(nb/2-1):nb/2,-(nc/2-1):nc/2)
  Complex*16 theta_G_b(-(na/2-1):na/2,-(nb/2-1):nb/2,-(nc/2-1):nc/2)
  Complex*16 temp_c

  Integer  nabc,na,nb,nc,ncube
  Real(8)  n1,n2,n3,aa(3,3),bb(3,3),ak(3,3),dv,dvk,phix,phiy,Ta,Tb,Tc

  Integer cix,ciy,ciz,cir,cjx,cjy,cjz,cjr,ckx,cky,ckz,ckr,nkx,nky,nkz,ca,cb,cc
  Real(8) rx,ry,rz,kx,ky,kz,ra,rb,rc,ka,kb,kc,rk,r12,x,y,z,term,term1

  Integer nr12
!  Real(8) theta_a(na,nb,nc),theta_b(na,nb,nc),phi_ab(0:nr12),dr12,r12max,Ecnl_12_ab
  Real(8) phi_ab(0:nr12),dr12,r12max,Ecnl_12_ab
!  Real(8) core_G(0:nk-1)
  Real(8),allocatable :: core_G(:)
!+++++++++++++++++++++ End VARIABLES +++++++++++++++++++++++++++


  allocate(core_G(0:nk-1))

  nabc = na*nb*nc

  dv = aa(1,1)*(aa(2,2)*aa(3,3)-aa(2,3)*aa(3,2)) &
&    + aa(1,2)*(aa(2,3)*aa(3,1)-aa(2,1)*aa(3,3)) &
&    + aa(1,3)*(aa(2,1)*aa(3,2)-aa(2,2)*aa(3,1))

  Ta = na*SQRT(aa(1,1)**2 + aa(1,2)**2 + aa(1,3)**2)
  Tb = nb*SQRT(aa(2,1)**2 + aa(2,2)**2 + aa(2,3)**2)
  Tc = nc*SQRT(aa(3,1)**2 + aa(3,2)**2 + aa(3,3)**2)


!***** Make the core function and execute 3d-FFT by hand *****
  dr12 = r12max/REAL(nr12)
  dk = maxk/REAL(nk-1)

  Do ck = 0,0
     rk = dk * Real(ck)
     term = 0
     Do cr = 0,nr12
        r12 = dr12*Real(cr)
        term = term + phi_ab(cr) * (r12**2)
     Enddo
     core_G(ck) = 4.0*pi*dr12 * term
  End do

  Do ck = 1,nk-1
     rk = dk * Real(ck)
     term = 0
     Do cr = 0,nr12
        r12 = dr12*Real(cr)
        term = term + phi_ab(cr) * r12 * SIN(2.0*pi*rk*r12)
     Enddo
     core_G(ck) = 2.0 * dr12 * term / rk
  End do
!***** END of Make the core function *************************



!***** Calculate 'theta_G_a*core_G*theta_G_b'  ***************
  dk = maxk/REAL(nk-1)
  temp_c = (0.0,0.0)
  Do cix = -(na/2-1),na/2
  Do ciy = -(nb/2-1),nb/2
  Do ciz = -(nc/2-1),nc/2

     rk = SQRT((REAL(cix)/Ta)**2 + (REAL(ciy)/Tb)**2 + (REAL(ciz)/Tc)**2)

     If(rk.LT.maxk) Then
        ck = AINT(rk/dk)
        phix = rk - dk*REAL(ck)
        phiy = 1.0 - phix
        term = phiy*core_G(ck) + phix*core_G(ck+1)
     Else
        term = 0.0
     Endif

     temp_c = temp_c +                       &
&           CONJG(theta_G_a(cix,ciy,ciz)) *  &
&                 theta_G_b(cix,ciy,ciz)  *  &
&                 term

  Enddo
  Enddo
  Enddo

  temp_c = temp_c * dv*nabc
  Ecnl_12_ab = 0.5*REAL(temp_c)
!***** End Calculate 'theta_G_a*core_G*theta_G_b'  ***********

  deallocate(core_G)


End subroutine convolution_3d
!** End SUBROUTINE convolution_3d *************************************************************



!** SUBROUTINE d_q0 ***************************************************************************
   Subroutine d_q0(n,nnx,nny,nnz,q0min,q0max,q0)
      Implicit None


!************************ Note *********************************
! This program calculates q0.
!
! Input
!   rho(nrxyz,nsipn) : Total density
!
! Output
!   q0               : 
!
!
!
!                            Written by Youky Ono
!***************************************************************



!++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
      Double Precision n,rs,x,nnx,nny,nnz,nn2,r,term1,term2,term3

      Double precision  kF,exc0,exLDA,excLDA,pi,Zab,q0,m,h,e,GxcLDA,eta,q0min,q0max
      Parameter (pi=3.1415926535897932)
      Parameter (e=1.0,m=1.0)
      Parameter (Zab=-0.8491)

!++++++++++++++++++++++++ end VARIABLES ++++++++++++++++++++++++



!---------------------- Calculation Start ----------------------
      nn2 = (nnx**2)+(nny**2)+(nnz**2)

      rs = (3/(4*pi*n))**0.3333333333333333

! Eq.(58), (59) (p.93-94) of Theory of the Inhomogeneous Electron gas.
! S.Lundqvist and N.H.March 1983 Plenum Press, NY
      x = rs/11.4
      GxcLDA = 0.5*((1+x**3)*Log(1+1/x)-x**2+x/2-1/3)
      excLDA = -0.458/rs-0.0666*GxcLDA

      kF = (3*pi*pi*n)**0.3333333333333333
      exLDA = -3*e*kF/(4*pi)

! Eq.(12) of Dion PRL92,246401
      term1 = exLDA*Zab*nn2/(6*kF*n)
      term2 = term1/(6*kF*n)

      exc0 = excLDA - term2


! Eq.(11) of Dion PRL92,246401
      q0 = MIN(exc0*kF/exLDA,q0max)
      q0 = MAX(q0,q0min)

   End Subroutine d_q0
!** End SUBROUTINE d_q0 ***********************************************************************



!** SUBROUTINE derivation *********************************************************************
 Subroutine derivation(na,nb,nc,aa,rho,dv,dxrho,dyrho,dzrho)
 Implicit none


!++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
! Integers
   Integer i,j,k,cx,cy,cz

! The unit cell and the electron density information
   Integer na,nb,nc,nabc
   Real(8) dv,aa(3,3),rho(na,nb,nc),dxrho(na,nb,nc),dyrho(na,nb,nc),dzrho(na,nb,nc)

! Internal valuables
   Integer zx(-3:3),zy(-3:3),zz(-3:3)
   Real(8) rn(3,-3:3),detr,bb(3,3)
!!$   Real(8) darho(na,nb,nc),dbrho(na,nb,nc),dcrho(na,nb,nc)
   Real(8),allocatable ::  darho(:,:,:),dbrho(:,:,:),dcrho(:,:,:)
!+++++++++++++++++++++ End VARIABLES +++++++++++++++++++++++++++

   allocate(darho(na,nb,nc));darho=0.d0
   allocate(dbrho(na,nb,nc));dbrho=0.d0
   allocate(dcrho(na,nb,nc));dcrho=0.d0
   dv = aa(1,1)*(aa(2,2)*aa(3,3)-aa(2,3)*aa(3,2)) &
&     + aa(1,2)*(aa(2,3)*aa(3,1)-aa(2,1)*aa(3,3)) &
&     + aa(1,3)*(aa(2,1)*aa(3,2)-aa(2,2)*aa(3,1))

   Do cx = 1,na
   Do cy = 1,nb
   Do cz = 1,nc

   Do j = -3,3
      zx(j) = MOD(2*na+(cx+j)-1,na)+1
      zy(j) = MOD(2*nb+(cy+j)-1,nb)+1
      zz(j) = MOD(2*nc+(cz+j)-1,nc)+1

      rn(1,j) = rho(zx(j),cy,cz)
      rn(2,j) = rho(cx,zy(j),cz)
      rn(3,j) = rho(cx,cy,zz(j))
   Enddo

   darho(cx,cy,cz) = &
&     (rn(1,3)-9.0*rn(1,2)+45.0*rn(1,1)-45.0*rn(1,-1)+9.0*rn(1,-2)-rn(1,-3))/(60.0)
   dbrho(cx,cy,cz) = &
&     (rn(2,3)-9.0*rn(2,2)+45.0*rn(2,1)-45.0*rn(2,-1)+9.0*rn(2,-2)-rn(2,-3))/(60.0)
   dcrho(cx,cy,cz) = &
&     (rn(3,3)-9.0*rn(3,2)+45.0*rn(3,1)-45.0*rn(3,-1)+9.0*rn(3,-2)-rn(3,-3))/(60.0)
   Enddo
   Enddo
   Enddo

   detr = (aa(1,1)*aa(2,2)*aa(3,3)+aa(1,2)*aa(2,3)*aa(3,1)+aa(1,3)*aa(2,1)*aa(3,2)) &
&       - (aa(1,1)*aa(2,3)*aa(3,2)+aa(1,2)*aa(2,1)*aa(3,3)+aa(1,3)*aa(2,2)*aa(3,1))

   bb(1,1) =  (aa(2,2)*aa(3,3)-aa(2,3)*aa(3,2))/detr
   bb(2,1) = -(aa(2,1)*aa(3,3)-aa(2,3)*aa(3,1))/detr
   bb(3,1) =  (aa(2,1)*aa(3,2)-aa(2,2)*aa(3,1))/detr
   bb(1,2) = -(aa(1,2)*aa(3,3)-aa(1,3)*aa(3,2))/detr
   bb(2,2) =  (aa(1,1)*aa(3,3)-aa(1,3)*aa(3,1))/detr
   bb(3,2) = -(aa(1,1)*aa(3,2)-aa(1,2)*aa(3,1))/detr
   bb(1,3) =  (aa(1,2)*aa(2,3)-aa(1,3)*aa(2,2))/detr
   bb(2,3) = -(aa(1,1)*aa(2,3)-aa(1,3)*aa(2,1))/detr
   bb(3,3) =  (aa(1,1)*aa(2,2)-aa(1,2)*aa(2,1))/detr

   Do cx = 1,na
   Do cy = 1,nb
   Do cz = 1,nc

   dxrho(cx,cy,cz) = &
&    (bb(1,1)*darho(cx,cy,cz) + bb(1,2)*dbrho(cx,cy,cz) + bb(1,3)*dcrho(cx,cy,cz))
   dyrho(cx,cy,cz) = &
&    (bb(2,1)*darho(cx,cy,cz) + bb(2,2)*dbrho(cx,cy,cz) + bb(2,3)*dcrho(cx,cy,cz))
   dzrho(cx,cy,cz) = &
&    (bb(3,1)*darho(cx,cy,cz) + bb(3,2)*dbrho(cx,cy,cz) + bb(3,3)*dcrho(cx,cy,cz))

   Enddo
   Enddo
   Enddo

   deallocate(darho)
   deallocate(dbrho)
   deallocate(dcrho)

 End subroutine derivation
!** End SUBROUTINE derivation *****************************************************************



!** SUBROUTINE kernel_phi *********************************************************************
      Subroutine kernel_phi(di,dk,phi)
      implicit none

!************************ Note *********************************
! This Algorism follows Dion's 1-shot method.
!
! This program is a subroutine.
! This program calculates the kernel function phi.
!
! Input
!
!
! Output
!   phi              : 
!                      
!
!
!                            Written by Youky Ono in 2013/Jan.
!***************************************************************



!++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
      Integer ca,na_gl,cb,nb
      Real(8) a,b,di,dk,h,gamma,v1,v2,v3,v4,W,T,phi
      Real(8) e,pi,m,a1,a2
      parameter (pi=3.1415926535897932)
      parameter (e=1,m=1)
      Parameter (na_gl=30, a1=0, a2=60)


! Gauss-Legendre integration
      Real(8) xi(na_gl),wi(na_gl)
!++++++++++++++++++++++++ end VARIABLES ++++++++++++++++++++++++



!---------------------- Calculation Start ----------------------
! Call gauleg for Gauss-Legendre integral
   Call gauleg(a1,a2,na_gl,xi,wi)


  gamma = 4*pi/9
  phi = 0
  Do ca=1,na_gl
  Do cb=1,ca

     a = xi(ca)
     b = xi(cb)

     h = 1-EXP(-gamma*((a/di)**2))
     v1 = (a**2)/(2*h)

     h = 1-EXP(-gamma*((b/di)**2))
     v2 = (b**2)/(2*h)

     h = 1-EXP(-gamma*((a/dk)**2))
     v3 = (a**2)/(2*h)

     h = 1-EXP(-gamma*((b/dk)**2))
     v4 = (b**2)/(2*h)

     W = 2*((3-a*a)*b*COS(b)*SIN(a) + (3-b*b)*a*COS(a)*SIN(b) &
&        + (a*a+b*b-3)*SIN(a)*SIN(b) &
&        -3*a*b*COS(a)*COS(b))/((a*b)**3)

! ((a*b)**2)*T
     T = ((a*b)**2) &
&        * 0.5*(1/(v1+v2) + 1/(v3+v4) ) &
&        * (1/((v1+v3)*(v2+v4)) + 1/((v1+v4)*(v2+v3)))

     phi = phi + wi(ca)*wi(cb)*W*T

  End Do
  End Do

  phi = phi * 2

  Do ca=1,na_gl
     cb=ca
     a = xi(ca)
     b = xi(cb)

     h = 1-EXP(-gamma*((a/di)**2))
     v1 = (a**2)/(2*h)

     h = 1-EXP(-gamma*((b/di)**2))
     v2 = (b**2)/(2*h)

     h = 1-EXP(-gamma*((a/dk)**2))
     v3 = (a**2)/(2*h)

     h = 1-EXP(-gamma*((b/dk)**2))
     v4 = (b**2)/(2*h)

     W = 2*((3-a*a)*b*COS(b)*SIN(a) + (3-b*b)*a*COS(a)*SIN(b) &
&        + (a*a+b*b-3)*SIN(a)*SIN(b) &
&        -3*a*b*COS(a)*COS(b))/((a*b)**3)

! ((a*b)**2)*T
     T = ((a*b)**2) &
&        * 0.5*(1/(v1+v2) + 1/(v3+v4) ) &
&        * (1/((v1+v3)*(v2+v4)) + 1/((v1+v4)*(v2+v3)))

     phi = phi - wi(ca)*wi(cb)*W*T

  End Do

  phi = phi * 2*m*(e**4)/(pi**2)


      end Subroutine kernel_phi
!** End SUBROUTINE kernel_phi *****************************************************************



!** SUBROUTINE outputs ************************************************************************
 Subroutine outputs(ExGGA,EcLDA,Ecnl_12,Ecnl_3,Ecnl_3s)
 Implicit none

  Real(8) ExGGA,EcLDA,Ecnl_12,Ecnl_3,Ecnl_3s,Ecnl

  Ecnl = Ecnl_12 + Ecnl_3 - Ecnl_3s

   Write(*,*)  ' '
   Write(*,11) ExGGA
   Write(*,*)  ' '
   Write(*,12) EcLDA
   Write(*,13) Ecnl
   Write(*,14) EcLDA + Ecnl
   Write(*,*)  ' '
   Write(*,15) EcLDA + Ecnl + ExGGA
   Write(*,*)  ' '
 11    Format('E_total(GGA exchange)      = ',F19.13)

 12    Format('Ec(LDA)                    = ',F19.13)
 13    Format('Ec(nl)                     = ',F19.13)
 14    Format('Ec (= Ec(LDA) + Ec(nl) )   = ',F19.13)

 15    Format('E_total(vdW-DF)            = ',F19.13)

   Write(*,*)  '                  Given in Hartree atomic units'
   Write(*,*)  ' '


 End Subroutine outputs
!** End SUBROUTINE outputs ********************************************************************



!** SUBROUTINE phiab **************************************************************************
 Subroutine phiab(ca,cb,nr12,r12max,ds,nq0,q0min,dq,lamda,phi0,phi_ab)
 Implicit none



!++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
   Integer ca,cb,nq0,nr12
   Real(8) dq,dq0,q0min,q0max,r12max,ds,phi0,lamda
   Real(8) phi_ab(0:nr12)

! Internal valuables
   Integer cr12,i
   Real(8) qab,qa,qb,r12,rs,phiD,dr12,phi2,phi4,phid_s,phid_s1,d_phid_s,d1,d2,abs_d
   Real(8) di,dk,tmp,dr
   Parameter(dr=0.001)
!+++++++++++++++++++++ End VARIABLES +++++++++++++++++++++++++++

  dr12 = r12max/REAL(nr12)
  qa = q0min + dq*(lamda**REAL(ca-1)-1.0)/(lamda-1.0)
  qb = q0min + dq*(lamda**REAL(cb-1)-1.0)/(lamda-1.0)
  qab = SQRT(qa**2+qb**2)

! Coefficients phi2 and phi4 in the local part is determined to
! match the non-local part in value and slope at d=d_s.

  rs = ds/qab

  di = qa*rs
  dk = qb*rs
  Call kernel_phi(di,dk,phid_s)

  di = qa*(rs+dr)
  dk = qb*(rs+dr)
  Call kernel_phi(di,dk,phid_s1)

  d_phid_s = (phid_s1 - phid_s)/dr

  phi2 = ( 2.0/ds**2)*(phid_s-phi0) - (rs/(2.0*ds**2))*d_phid_s
  phi4 = (-1.0/ds**4)*(phid_s-phi0) + (rs/(2.0*ds**4))*d_phid_s

  i = AINT((ds/qab)/dr12)

! Non-local part of phi_ab(r12)
  Do cr12 = i+1,nr12
     r12 = REAL(cr12)*dr12

     di = qa*r12
     dk = qb*r12

     Call kernel_phi(di,dk,tmp)
     phi_ab(cr12) = tmp

  Enddo

! Local part of phi_ab(r12)
  Do cr12 = 0,i
     r12 = REAL(cr12)*dr12

     d1 = qa*r12
     d2 = qb*r12
     phiD = qab*r12
     phi_ab(cr12) = phi0 + phi2*phiD**2 + phi4*phiD**4

  Enddo


 End subroutine phiab
!** End SUBROUTINE phiab **********************************************************************



!** SUBROUTINE spline *************************************************************************
 Subroutine spline(nq0,dq,lamda,mW)

   Implicit none

!************************ Note *********************************
! This Algorism follows Dion's 1-shot method.
! This program is a subroutine.
!
! Input
!   nq0               : Number of grid points
!   dq0               : Maximum and minimum of the variable q0
!
! Output
!   mW(nq0,nq0)       : Matrix elements of W
!
!                            Written by Youky Ono in 2012/Sep.
!***************************************************************



!++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
  Integer nq0
  Real(8) n,q0,dq0,dq,lamda

  Integer  i,j,k,m
  Real(8) mW(nq0,nq0)
  Real(8) temp

!  T=LU
  Real(8), Allocatable  ::  mT(:,:),mL(:,:),mU(:,:),miT(:,:),miL(:,:),miU(:,:), &
&                           mA(:),mB(:),mC(:),mV(:,:)
!++++++++++++++++++++++++ end VARIABLES ++++++++++++++++++++++++



!---------------------- Calculation Start ----------------------
!!! Prepare the matrix elements T=LU
  Allocate(mT(nq0,nq0))
  Allocate(mL(nq0,nq0))
  Allocate(mU(nq0,nq0))
  Allocate(mV(nq0,nq0))
  Allocate(miT(nq0,nq0))
  Allocate(miL(nq0,nq0))
  Allocate(miU(nq0,nq0))
  Allocate(mA(nq0))
  Allocate(mB(nq0))
  Allocate(mC(nq0))

  mT = 0.0
  mL = 0.0
  mU = 0.0
  mV = 0.0
  miT = 0.0
  miL = 0.0
  miU = 0.0
  mA = 0.0
  mB = 0.0
  mC = 0.0

!  dq0 = (q0max - q0min)/(REAL(nq0-1))
!  dq0 = 1.0

  Do i=1,nq0
  Do j=1,nq0
     mT(i,j) = 0.0
     mL(i,j) = 0.0
     mU(i,j) = 0.0
     mV(i,j) = 0.0
  End do
  End do
  Do i=1,nq0
     dq0 = dq*(lamda**REAL(i-1))
     mT(i,i) = (1.0/3.0)*dq0
       mA(i) = (1.0/3.0)*dq0
     mV(i,i) = -2.0*dq0**(-1.0)
  End do
  Do i=1,nq0-1
     dq0 = dq*(lamda**REAL(i-1))
     mT(i,i+1) = (1.0/6.0)*dq0
         mB(i) = (1.0/6.0)*dq0
     mV(i,i+1) = dq0**(-1.0)
     mT(i+1,i) = (1.0/6.0)*dq0
       mC(i+1) = (1.0/6.0)*dq0
     mV(i+1,i) = dq0**(-1.0)
  End do

  Do i=2,nq0
     mC(i) = -mC(i)/mA(i-1)
     mA(i) = mA(i) + mC(i)*mB(i-1)
  End do

  Do i=1,nq0
     mL(i,i) = 1.0
     mU(i,i) = mA(i)
  End do
  Do i=1,nq0-1
     mL(i+1,i) = -1.0*mC(i+1)
     mU(i,i+1) = mB(i)
  End do


!!! Calculate inverse matrix of L and U.
  Do i=1,nq0
  Do k=1,nq0

     If(i.EQ.k) then
        miL(i,k) = 1.0
        miU(i,k) = (mU(i,k))**(-1.0)
     Else if(i.LT.k) then
        miL(i,k) = 0.0

        temp = 1.0
        Do j = i,k
           temp = temp * (mU(j,j)**(-1.0))
        End do
        Do j = i,k-1
           temp = temp * mU(j,j+1)
        End do

        miU(i,k) = ((-1.0)**(k-i))*temp

     Else if(i.GT.k) then
        temp = 1.0
        Do j = k,i-1
           temp = temp * mL(j+1,j)
        End do
        miL(i,k) = ((-1.0)**(i-k))*temp
     End if

  End do
  End do


!!! iU*iL = iT
  Do i=1,nq0
  Do k=1,nq0
     temp = 0.0
     Do j=1,nq0
        temp = temp + miU(i,j)*miL(j,k)
     End do
     miT(i,k) = temp
  End do  
  End do


!!! iT*V = W
  Do i=1,nq0
  Do k=1,nq0
     temp = 0.0
     Do j=1,nq0
        temp = temp + miT(i,j)*mV(j,k)
     End do
     mW(i,k) = temp
  End do
  End do

  DeAllocate(mT)
  DeAllocate(mL)
  DeAllocate(mU)
  DeAllocate(mV)
  DeAllocate(miT)
  DeAllocate(miL)
  DeAllocate(miU)
  DeAllocate(mA)
  DeAllocate(mB)
  DeAllocate(mC)


  End Subroutine spline
!** End SUBROUTINE spline *********************************************************************



!** SUBROUTINE theta_ab ***********************************************************************
 Subroutine theta_ab(nx,ny,nz,ca,nq0,q0min,q0max,dq,lamda,rho,dxrho,dyrho,dzrho,rhomin,mW,theta_R)
 Implicit none


!++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
   Integer nx,ny,nz,ca,nq0
   Real(8) dq,dq0,q0min,q0max,rhomin,lamda
   Real(8) rho(nx,ny,nz),mW(nq0,nq0),dxrho(nx,ny,nz),  &
&          dyrho(nx,ny,nz),dzrho(nx,ny,nz),theta_R(nx,ny,nz)

! Internal valuables
   Integer cir,cix,ciy,ciz,i
   Real(8) ni,nnx,nny,nnz,q0,qi,qi1,A,B,C,D,del_ia,del_i1a,p
!+++++++++++++++++++++ End VARIABLES +++++++++++++++++++++++++++

! For the functions theta_R
  Do cir = 1,nx*ny*nz
     cix = 1+(cir-1-MOD(cir-1+ny*nz,ny*nz))/(ny*nz)
     ciy = 1+(cir-ny*nz*(cix-1)-1-MOD(cir-1+nz,nz))/nz
     ciz = cir-nz*(ny*(cix-1)-1+ciy)

     ni = MAX(rho(cix,ciy,ciz),rhomin)
     nnx = dxrho(cix,ciy,ciz)
     nny = dyrho(cix,ciy,ciz)
     nnz = dzrho(cix,ciy,ciz)

     q0 = q0max
     Call d_q0(ni,nnx,nny,nnz,q0min,q0max,q0)

     i = 1 + AINT(LOG(1.0+(lamda-1)*(q0-q0min)/dq)/LOG(lamda))
     qi  = q0min + dq*(lamda**REAL(i-1)-1.0)/(lamda-1.0)
     qi1 = q0min + dq*(lamda**REAL(i)-1.0)/(lamda-1.0)
     dq0 = dq*(lamda**REAL(i-1))

     A = (qi1 - q0)/dq0
     B = (q0 - qi)/dq0
     C = (A**3 - A)*(dq0**2)/6.0
     D = (B**3 - B)*(dq0**2)/6.0

     del_ia  = 0.0
     del_i1a = 0.0
     If(i.EQ.ca) Then
        del_ia  = 1.0
     Else if(i+1.EQ.ca) Then
        del_i1a = 1.0
     End if

     p = A*del_ia + B*del_i1a + C*mW(i,ca) + D*mW(i+1,ca)

     theta_R(cix,ciy,ciz) = p*ni

  End do


 End subroutine theta_ab
!** End SUBROUTINE theta_ab *******************************************************************

!=======================================================================
!
!  PROGRAM  PHASE/0 2014.01 (rev.375)
!
!  "First-principles Electronic Structure Calculation Program"
!
!  SUBROUINE:  Preparation_for_mpi
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!   The original version of this set of the computer programs "PHASE" was developed by 
!  the members of the Theory Group of Joint Research Center for Atom Technology 
!  (JRCAT), based in Tsukuba, in the period 1993-2001.  
!   Since 2002, this program set had been intensively developed as a part of the following 
!  national projects supported by the Ministry of Education, Culture, Sports, Science and 
!  Technology (MEXT) of Japan; "Frontier Simulation Software for Industrial Science 
!  (FSIS)" from 2002 to 2005, "Revolutionary Simulation Software (RSS21)" from 2006 to 
!  2008. "Research and Development of Innovative Simulation Software (RISS)" from 2008 
!  to 2013. These projects is lead by the Center for Research on Innovative Simulation 
!  Software (CISS), the Institute of Industrial Science (IIS), the University of Tokyo.
!   Since 2013, this program set has been further developed centering on PHASE System 
!  Consortium. 
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
subroutine Preparation_for_mpi(prepare_communicators)
! $Id: Preparation_for_mpi.F90 324 2013-06-24 11:32:23Z yamasaki $
!                           @(#)Preparation_for_mpi.F90 1.10 03/02/19 00:49:14
  use m_Const_Parameters,     only : INITIAL, CONTINUATION &
       &                           , FIXED_CHARGE, FIXED_CHARGE_CONTINUATION,OFF &
       &                           , ALL_AT_ONCE, ON, COORDINATE_CONTINUATION
  use m_Kpoints,              only : kv3
  use m_Files,                only : nfout
  use m_Control_Parameters,   only : ipriparallel,nspin,neg,printable,ngnode_nbmx &
       &                           , flag_mpi_g_dot_r,flag_mpi_g_dot_r_k &
       &                           , icond, ekmode, fixed_charge_k_parallel &
       &                           , m_CtrlP_flag_mpi_G_dot_R
  use m_PlaneWaveBasisSet,    only : kg1, kgpm, nbmx, iba, kgp
#ifndef PARAMSET
  use m_Charge_Density,       only : m_CD_alloc_chgq
  use m_XC_Potential,         only : m_XC_alloc_vxc
  use m_Parallelization,      only : m_Parallel_init_mpi_mix, m_Parallel_init_mpi_snl &
       &                           , m_Parallel_init_mpi_atm, m_Parallel_init_mpi_atm2 &
       &                           , m_Parallel_init_mpi_iba, m_Parallel_init_mpi_elec
!$$F  use m_Parallelization,      only : m_Parallel_init_mpi_elec, m_Parallel_init_mpi_gga &
!$$F       &                           , m_Parallel_init_mpi_nbmx, m_Parallel_init_mpi_iba
  use m_Parallelization,      only : m_Parallel_init_mpi_gga &
       &                           , m_Parallel_init_mpi_nbmx
  use m_FFT,                  only : nfftp, nfftps
  use m_Ionic_System,         only : natm, natm2, m_IS_alloc_fxyzew
  use m_Ionic_System,         only : m_IS_alloc_zfm3
  use m_Force,                only : m_Force_alloc
#endif

! ============================== added by K. Tagami ================== 11.0
  use m_Control_Parameters,   only : noncol, ndim_spinor
! ==================================================================== 11.0

  implicit none

  integer, intent(in) :: prepare_communicators

#ifndef PARAMSET
  call m_IS_alloc_fxyzew()
  call m_Force_alloc()
!$$#ifndef PARA3D
  call m_IS_alloc_zfm3()
  call m_CD_alloc_chgq()
  call m_XC_alloc_vxc()
!$$#endif

  if(prepare_communicators==ON)then
! ================================ modified by K. Tagami =================== 11.0
!     call m_Parallel_init_mpi_elec(nfout,ipriparallel,printable,neg,kv3,nspin,kg1)
!     call m_Parallel_init_mpi_snl(nfout,ipriparallel,printable,nspin)
! -
     if ( noncol ) then
        call m_Parallel_init_mpi_elec( nfout, ipriparallel, printable, neg, &
             &                             kv3, ndim_spinor, kg1 )
        call m_Parallel_init_mpi_snl( nfout, ipriparallel, printable, ndim_spinor )
     else
        call m_Parallel_init_mpi_elec( nfout, ipriparallel, printable, neg, &
             &                             kv3, nspin, kg1 )
        call m_Parallel_init_mpi_snl( nfout, ipriparallel, printable, nspin )
     endif
! ========================================================================== 11.0 
     call m_Parallel_init_mpi_mix(nfout,ipriparallel,printable,kgpm)
     call m_Parallel_init_mpi_atm(nfout,ipriparallel,printable,natm)
     call m_Parallel_init_mpi_atm2(nfout,ipriparallel,printable,natm2)

!!!  call m_CtrlP_flag_mpi_G_dot_R(nfout,nbmx) ! -> flag_mpi_g_dot_r
     call m_Parallel_init_mpi_nbmx(nfout,ipriparallel,printable,nbmx,kg1,ngnode_nbmx,flag_mpi_g_dot_r,flag_mpi_g_dot_r_k)
     call m_Parallel_init_mpi_gga(nfout,ipriparallel,printable,nfftp,nfftps)

  endif

  if((icond == INITIAL .or. icond == CONTINUATION .or.  icond==COORDINATE_CONTINUATION) &
       & .or.((icond==FIXED_CHARGE.or.icond==FIXED_CHARGE_CONTINUATION).and.ekmode==OFF &
       & .and. fixed_charge_k_parallel == ALL_AT_ONCE)) then
     call m_Parallel_init_mpi_iba(nfout,ipriparallel,printable,kv3,iba) ! -> np_g1k, mp_g1k
  end if


#endif

end subroutine Preparation_for_mpi

subroutine Preparation_for_mpi_ek
! $Id: Preparation_for_mpi.F90 324 2013-06-24 11:32:23Z yamasaki $
!                           @(#)Preparation_for_mpi.F90 1.10 03/02/19 00:49:14
  use m_Kpoints,              only : kv3
  use m_Files,                only : nfout
  use m_Control_Parameters,   only : ipriparallel, printable
  use m_PlaneWaveBasisSet,    only : iba
  use m_Parallelization,      only : m_Parallel_init_mpi_iba

  call m_Parallel_init_mpi_iba(nfout,ipriparallel,printable,kv3,iba) !  -> np_g1k, mp_g1k

end subroutine Preparation_for_mpi_ek

!=======================================================================
!
!  PROGRAM  PHASE/0 2014.01 (rev.375)
!
!  "First-principles Electronic Structure Calculation Program"
!
!  SUBROUINE: Ewald_and_Structure_Factor
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
subroutine Ewald_and_Structure_Factor
! $Id: Ewald_and_Structure_Factor.F90 334 2013-07-18 14:15:28Z yamasaki $
  use m_Const_Parameters, only : ON,Valence_plus_PC_Charge,VXC_AND_EXC,DP
  use m_Files,            only : nfout
  use m_PseudoPotential,  only : ival
#ifndef ENABLE_ESM
  use m_Control_Parameters,only : skip_alloc_phonon,printable,sw_wf_predictor,sw_charge_predictor &
    &                           , m_CtrlP_in_initialization,sw_extrapolate_charge
#else
  use m_Control_Parameters,only : skip_alloc_phonon &
    &                           , sw_esm, printable,sw_wf_predictor,sw_charge_predictor,sw_extrapolate_charge &
    &                           , m_CtrlP_in_initialization
#endif
  use m_PlaneWaveBasisSet,only : kgp,ngabc,kg,gr_l
!$$#ifdef PARA3D
  use m_Ionic_System,     only : m_IS_structure_factor_3D, m_IS_ewald_3D,m_IS_get_extpl_factor
  use m_PlaneWaveBasisSet,   only : ngabc_kngp_l, ngabc_kngp_B_l
!$$#endif
  use m_IterationNumbers, only : iteration_ionic

  use m_Charge_Density,   only : m_CD_predictor_pre,m_CD_predictor_post,chgq_l
  use m_ES_ortho,             only : m_ES_modified_gram_schmidt
  use m_XC_Potential,         only : m_XC_cal_potential_3D,vxc_l
  use m_Electronic_Structure, only : m_ES_energy_eigen_values_3D
  use m_ES_LHXC,              only : m_ESlhxc_potential_3D
  use m_ES_Intgr_VlhxcQlm,    only : m_ESiVQ_integrate_VlhxcQlm_3D
  implicit none

  real(kind=DP) :: alpha,beta,rms
  integer :: nextpl

!$$#ifdef PARA3D
!  call m_IS_structure_factor_3D(nfout,kgp,ngabc)
!  call m_IS_ewald_3D(nfout,kg,gr_l,kgp,ngabc,ival)
  if(.not.m_CtrlP_in_initialization().and.sw_charge_predictor==ON) &
  & call m_CD_predictor_pre(nfout,printable)
  call m_IS_structure_factor_3D(nfout,kgp,ngabc_kngp_l)
  if(.not.m_CtrlP_in_initialization().and.&
    & (sw_charge_predictor==ON .or.  sw_wf_predictor==on)) then
    if(sw_extrapolate_charge==ON.or.sw_wf_predictor==ON) call m_IS_get_extpl_factor(alpha,beta,rms,nextpl)
    if(sw_charge_predictor==ON) call m_CD_predictor_post(alpha,beta,rms,nextpl,nfout,printable)
     call m_XC_cal_potential_3D(nfout,Valence_plus_PC_Charge,chgq_l, VXC_AND_EXC)  ! -> vxc_l
     call m_ESlhxc_potential_3D(nfout,chgq_l,vxc_l) ! (stlhxc) ->vlhxc_l
     call m_ES_modified_gram_schmidt(nfout)
     call m_ESiVQ_integrate_VlhxcQlm_3D(nfout) ! (lclchh) -> vlhxcQ
     call m_ES_energy_eigen_values_3D(nfout)   ! (eigen0) -> eko_l,neordr
  endif
  call m_IS_ewald_3D(nfout,kg,gr_l,kgp,ngabc,ival,ngabc_kngp_l)
!$$#endif
  if(skip_alloc_phonon) call Initial_Electronic_Structure

end subroutine Ewald_and_Structure_Factor

!=======================================================================
!
!  PROGRAM  PHASE/0 2014.01 (rev.375)
!
!  "First-principles Electronic Structure Calculation Program"
!
!  PROGRAM: EK
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!      Further modification by T. Yamasaki   Feb. 2004
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!   The original version of this set of the computer programs "PHASE" was developed by 
!  the members of the Theory Group of Joint Research Center for Atom Technology 
!  (JRCAT), based in Tsukuba, in the period 1993-2001.  
!   Since 2002, this program set had been intensively developed as a part of the following 
!  national projects supported by the Ministry of Education, Culture, Sports, Science and 
!  Technology (MEXT) of Japan; "Frontier Simulation Software for Industrial Science 
!  (FSIS)" from 2002 to 2005, "Revolutionary Simulation Software (RSS21)" from 2006 to 
!  2008. "Research and Development of Innovative Simulation Software (RISS)" from 2008 
!  to 2013. These projects is lead by the Center for Research on Innovative Simulation 
!  Software (CISS), the Institute of Industrial Science (IIS), the University of Tokyo.
!   Since 2013, this program set has been further developed centering on PHASE System 
!  Consortium. 
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
! $Id: ekmain.f90 238 2012-11-12 04:11:13Z yamasaki $
!
program EK
! This program was coded by T. Yamasaki(FUJITSU Laboratories Ltd.), 17th Feb. 2003.
!
  implicit none
  logical  :: EigenValues_are_Converged, AllKpoints_are_Calculated
  logical  :: Already_Converged
  logical  :: Ending_Time

  call Initialization_set_ekmode_ON  ! set `ekmode' ON in m_Control_Parameters
  call Initialization(1)             ! Initialization of mpi and file-setting
  call InputData_Analysis
  call Preparation                   ! Basis set, symmetry check etc.
  call Preparation_for_mpi(1)        ! mpi
  call PseudoPotential_Construction
  call Ewald_and_Structure_Factor    ! Calculate Structure Factor
  call Initial_Electronic_Structure()! read Charge Density, (lclchh)

  KPOINTS: do
     call KpointNumber_Setting()
     call Preparation_ek             ! (basnum)
     call Preparation_for_mpi_ek     ! mpi  -> np_g1k, mp_g1k
     call PseudoPotential_ek         ! (kbint)
     call Initial_WaveFunctions_ek   ! (rndzaj|rdzaj),(fsrfsi),(lclchh)
     if(.not.Already_Converged()) then
        SolveWaveFunctions: do
           if(Ending_Time())                 exit KPOINTS
           call IterationNumber_Setting()
           call Renewal_of_WaveFunctions()
           if(EigenValues_are_Converged())   exit SolveWaveFunctions
        enddo SolveWaveFunctions
        call Postprocessing_k()
        if(AllKpoints_are_Calculated())     exit KPOINTS
     else
        exit KPOINTS
     end if
  enddo KPOINTS
!!$  else
!!$     write(6,'(" Already_Converged")')
!!$     call KpointNumber_Setting()
!!$     call Preparation_ek             ! (basnum)
!!$     call PseudoPotential_ek         ! (kbint)
!!$     call Initial_WaveFunctions_ek   ! (rndzaj|rdzaj),(fsrfsi),(lclchh)
!!$  end if

  call Postprocessing(.false.)
  call WriteDownData_onto_Files_ek()
  call Finalization_of_mpi           ! mpi
end program EK

!=======================================================================
!
!  PROGRAM  PHASE/0 2014.01 (rev.375)
!
!  "First-principles Electronic Structure Calculation Program"
!
!  AUTHOR(S): T. Hamada
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!   The original version of this set of the computer programs "PHASE" was developed by 
!  the members of the Theory Group of Joint Research Center for Atom Technology 
!  (JRCAT), based in Tsukuba, in the period 1993-2001.  
!   Since 2002, this program set had been intensively developed as a part of the following 
!  national projects supported by the Ministry of Education, Culture, Sports, Science and 
!  Technology (MEXT) of Japan; "Frontier Simulation Software for Industrial Science 
!  (FSIS)" from 2002 to 2005, "Revolutionary Simulation Software (RSS21)" from 2006 to 
!  2008. "Research and Development of Innovative Simulation Software (RISS)" from 2008 
!  to 2013. These projects is lead by the Center for Research on Innovative Simulation 
!  Software (CISS), the Institute of Industrial Science (IIS), the University of Tokyo.
!   Since 2013, this program set has been further developed centering on PHASE System 
!  Consortium. 
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!#========================================================================
!#                                                                       #
!# Software Name : UVSOR ver. 3.00                                       #
!#                                                                       #
!#      Sub Routine : PseudoPotential_ek_Epsilon                         #
!#                                                                       #
!#                                Written by T. Hamada 2007/5/8          #
!#                                                                       #
!#      Contact address :  IIS,The University of Tokyo CISS              #
!#                                                                       #
!#"Multiscale Simulation System for Functional Analysis of Nanomaterials"#
!#                                                                       #
!#========================================================================
!
! $Id: PseudoPotential_ek_Epsilon.f90 238 2012-11-12 04:11:13Z yamasaki $
subroutine PseudoPotential_ek_Epsilon
!
! Pseudopotential_ek for ek_Epsilon
! The original program is Pseudopotential_ek in PseudoPotential_Construction
!
  use m_Const_Parameters,     only : FIXED_CHARGE, FIXED_CHARGE_CONTINUATION, ON
  use m_Control_Parameters,   only : icond, sw_pdos, sw_use_add_proj
  use m_Kpoints,              only : kv3, vkxyz, kv3_previous
  use m_NonLocal_Potential,   only : m_NLP_rd_snl, m_NLP_betar_dot_PWs &
       &                           , m_NLP_betar_dot_PWs_diff &
       &                           , m_NLP_phir_dot_PWs &
       &                           , m_NLP_add_betar_dot_PWs
  use m_PseudoPotential,      only : m_PP_alloc_NLP, m_PP_dealloc_NLP, m_PP_betar_calculated
  use m_IterationNumbers,     only : iteration_electronic,nk_in_the_process
  use m_Files,                only : nfout, nfcntn_bin, m_Files_open_nfcntn_bin &
       &                           , F_CNTN_BIN_in_partitioned
  implicit none

  if(icond == FIXED_CHARGE &
       & .or. (icond == FIXED_CHARGE_CONTINUATION &
       &           .and.( iteration_electronic == 0 .or. kv3_previous /= kv3))) then
     call m_PP_alloc_NLP()
     call m_NLP_betar_dot_PWs(nfout,kv3,vkxyz) !(kbint) --> snl
     if(sw_pdos == ON) then
        call m_NLP_phir_dot_PWs(nfout,kv3,vkxyz) !(kbint) --> phig
     end if
     if(sw_use_add_proj == ON) then
        call m_NLP_add_betar_dot_PWs(nfout,kv3,vkxyz) !(kbint) --> snl_add
     end if
!    call m_PP_dealloc_NLP()
!!$     if(nk_in_the_process == 3) stop 'PseudoPotential_ek'
  else if(icond == FIXED_CHARGE_CONTINUATION) then
!!$     call m_Files_open_nfcntn_bin()
     call m_NLP_rd_snl(nfout,nfcntn_bin,F_CNTN_BIN_in_partitioned,kv3)
  end if
end subroutine PseudoPotential_ek_Epsilon

! =================================== added by K. Tagami =========== 5.0
subroutine Renewal_of_Chg_Ctrl_Param

  use m_Const_Parameters,    only  : DP, ON, OFF, YES
  use m_Total_Energy,         only : m_TE_what_is_edeltb_now
  use m_Ionic_System,        only : natm
  use m_Control_Parameters,  only : sw_eval_energy_before_charge, &
       &                            sw_update_charge_total, spin_density_mixfactor
!
  use m_Const_Parameters,  only : MSD, CG, SD, LMSD, LMCG,lmeazyCG, lmmsd
  use m_Control_Parameters,  only :  m_CtrlP_solver_for_WFs_now, intzaj

  use  m_IterationNumbers,    only : iteration, iteration_ionic, iteration_electronic

  use m_Control_Parameters,       only : sw_update_charge_hsr, eval_energy_before_charge
  use m_Control_Parameters,     only : sw_recomposing, sw_force_simple_mixing
  use m_Control_Parameters,     only : sw_recomposing_hsr, sw_force_simple_mixing_hsr

  use m_Files,               only : nfout
  use m_Control_Parameters,   only : printable

! =========================== KT_Test ============================== 12.5Exp
  use m_Control_Parameters,   only : sw_hybrid_functional, &
       &                             truncate_vxw_updating, sw_update_vxw, &
       &                             edelta_for_hyb_chgfix, edelta_for_hyb_convgd
! ================================================================== 12.5Exp

  implicit none

  real(kind=DP) :: edeltab_per_atom, edeltb_per_atom, edelta
!
  edeltab_per_atom = m_TE_what_is_edeltb_now() / natm
  edeltab_per_atom = abs(edeltab_per_atom )

!
!  call update_or_fix_charge
!  call update_or_fix_charge_hardpart
!
! =========================== KT_Test ============================== 12.5Exp
  edelta = m_TE_what_is_edeltb_now()
  if ( sw_hybrid_functional == ON ) then
     if ( truncate_vxw_updating ) call update_or_fix_charge_hybrid
  endif
! ================================================================== 12.5Exp
    
  if ( eval_energy_before_charge == YES ) then
    call order_energy_chg_construction
  endif

!  call update_spin_density_mixfactor
!   call update_spin_recomposing

contains

  subroutine update_spin_recomposing
    logical, save :: first = .true.
    integer :: nstep_threshold = 15 

    integer :: sw_recomposing0 = OFF
    integer :: sw_force_simple_mixing0 = OFF
!
    if ( first ) then
       sw_recomposing0 = sw_recomposing
       sw_force_simple_mixing0 = sw_force_simple_mixing
       first = .false.
    endif
!
    if ( sw_recomposing0 == ON ) then
       if ( iteration <= nstep_threshold ) then
          sw_recomposing = ON
          sw_force_simple_mixing = ON
          sw_recomposing_hsr = ON
          sw_force_simple_mixing_hsr = ON
       else
          sw_recomposing = OFF
          sw_force_simple_mixing = OFF
          sw_recomposing_hsr = OFF
          sw_force_simple_mixing_hsr = OFF
       endif
    end if
  end subroutine update_spin_recomposing

  subroutine update_spin_density_mixfactor
    logical, save :: first = .true.
    real(kind=DP),save ::  spin_dens_mixfactor_0

    if ( first ) then
       spin_dens_mixfactor_0 = spin_density_mixfactor
       first = .false.
    endif
!
    if ( iteration <= 5 ) then
       spin_density_mixfactor = 4.0
    else
       spin_density_mixfactor = spin_dens_mixfactor_0
    endif
!
    if ( printable ) then
       write(nfout,*) '*** spin_density_mixfacotr now = ', &
            & iteration, spin_density_mixfactor
    end if
! --------------------------------------
  end subroutine update_spin_density_mixfactor

  subroutine order_energy_chg_construction
!
    real(kind=DP) :: edeltb_now
    integer :: isolver, sw_submat
    
    integer :: nsteps_for_transition = 3
    
    edeltb_now = edeltab_per_atom
    isolver = m_CtrlP_solver_for_WFs_now(iteration_electronic,iteration_ionic,intzaj &
         &                              ,edeltb_now, sw_submat)
!
    select case(isolver)
    case (SD,MSD)       
       sw_eval_energy_before_charge = OFF
    case (lmSD, lmMSD, lmCG, lmeazyCG)
       sw_eval_energy_before_charge = OFF
    case default
       if ( iteration <= nsteps_for_transition ) then
          sw_eval_energy_before_charge = OFF
       else
          sw_eval_energy_before_charge = ON
       endif
    end select
!    
    if ( printable ) then
       write(nfout,*) '*-- sw_eval_ene_before_charge now = ',  &
            &               iteration, sw_eval_energy_before_charge
    endif
  end subroutine order_energy_chg_construction

  subroutine update_or_fix_charge
    integer, save :: counter = 0

    real(kind=DP) :: ene_threshold1
    integer :: nsteps_for_fixing_charge = -2

    ene_threshold1 = 1.0E-3
    if ( iteration_electronic == 0 &
         & .or. iteration_electronic <= nsteps_for_fixing_charge ) then
       sw_update_charge_total = ON
    else
       if ( edeltab_per_atom > ene_threshold1 ) then
          sw_update_charge_total = OFF
       else
          sw_update_charge_total = ON
       endif
    endif
!
    if ( iteration <= 1 ) then
       sw_update_charge_total = ON
    else if ( iteration_electronic <= nsteps_for_fixing_charge ) then
       sw_update_charge_total = OFF
    else
       sw_update_charge_total = ON
    endif
! 
  end subroutine update_or_fix_charge

  subroutine update_or_fix_charge_hardpart
    if ( sw_update_charge_total == OFF ) then
       sw_update_charge_hsr = OFF
    else

    endif

  end subroutine update_or_fix_charge_hardpart

! =========================  KT_Test ===================== 12.5Exp
  subroutine update_or_fix_charge_hybrid
    integer :: count1 = 0
    integer :: count2 = 0

    if ( abs(edelta) < edelta_for_hyb_chgfix ) then
       count1 = count1 + 1
       if ( count1 == 3 ) then
          sw_update_charge_total = OFF
          if ( printable ) write(nfout,*) '*----- sw_update_charge_total is set OFF --'
       endif
    endif
       !
    if ( abs(edelta) < edelta_for_hyb_convgd ) then
       count2 = count2 + 1
       if ( count2 == 3 ) then
          sw_update_vxw = OFF
          if ( printable ) write(nfout,*) '*----- sw_update_vxw is set OFF --'
       endif
    endif

!
  end subroutine update_or_fix_charge_hybrid
! ========================================================= 12.5Exp

end subroutine Renewal_of_Chg_Ctrl_Param

!=======================================================================
!
!  PROGRAM  PHASE/0 2014.01 (rev.375)
!
!  "First-principles Electronic Structure Calculation Program"
!
!  MODULE: m_Const_Parameters
!
!  AUTHOR(S): T. Yamasaki and K. Mae   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
module m_ErrorMessages
! $Id: $
  implicit none

  integer,parameter :: NO_ERROR = 0
  integer,parameter :: EOF_REACHED  = 1103
  integer,parameter :: FILE_NOT_EXIST = 1200
  integer,parameter :: F_POT_FILE_NOT_EXIST = 1203
! ---
  integer,parameter :: FORMAT_ERROR = 1101
  integer,parameter :: len_format_error = 37
  character(len=len_format_error) :: msg_format_error = "Input data format error when reading."
!!$                                                      1234567890123456789012345678901234567  
! ---
  integer,parameter :: ERROR_IN_INPUTFILE_OPENING = 1208
  integer,parameter :: len_1208_error = 35
  character(len=len_1208_error) :: msg_1208_error     = "Error in opening of the inputfile: "
! ---
  integer,parameter :: len_6100_error = 29
  character(len=len_6100_error) :: msg_6100_error     = "A CPP defintion is not proper"
  integer,parameter :: CPP_DEFINE_ERROR_1 = 6101
  integer,parameter :: len_6101_error = 31
  character(len=len_6101_error) :: msg_6101_error     = "TRANSPOSE_WITHOUT_REARRANGEMENT"
!!$                                                      1234567890123456789012345678901234567  

contains
  subroutine m_EMsg_abort01()

  end subroutine m_EMsg_abort01
end module m_ErrorMessages
  

!=======================================================================
!
!  PROGRAM  PHASE/0 2014.01 (rev.375)
!
!  "First-principles Electronic Structure Calculation Program"
!
!  MAIN PROGRAM: PHASE
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  FURTHER MODIFICATION: T. Yamasaki, January/13/2004
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!   Since 2002, this program set had been intensively developed as a part of the following 
!  national projects supported by the Ministry of Education, Culture, Sports, Science and 
!  Technology (MEXT) of Japan; "Frontier Simulation Software for Industrial Science 
!  (FSIS)" from 2002 to 2005, "Revolutionary Simulation Software (RSS21)" from 2006 to 
!  2008. "Research and Development of Innovative Simulation Software (RISS)" from 2008 
!  to 2013. These projects is lead by the Center for Research on Innovative Simulation 
!  Software (CISS), the Institute of Industrial Science (IIS), the University of Tokyo.
!   Since 2013, this program set has been further developed centering on PHASE System 
!  Consortium. 
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!  $Id: mdmain0.F90 238 2012-11-12 04:11:13Z yamasaki $
!
program PHASE
#ifdef NEC_TIMER
  use nec_timer
#endif
  use m_Const_Parameters, only : DRIVER_CONSTRAINT, DRIVER_NEB, DRIVER_MTD
#ifdef PAW3D
  use m_Files,                only : nfout
  use m_Ionic_System,         only : natm
  use m_PseudoPotential,      only : mmesh
  use m_Parallelization,      only : m_Parallel_init_mpi_paw_3D
#endif
  implicit none
  logical  :: ChargeDensity_is_Converged, TotalEnergy_is_Divergent
  logical  :: Already_Converged, Already_Converged2
  logical  :: Positron_bulk, Positron_defect
  logical  :: Hubbard_model
  logical  :: Forces_are_Converged, Ending_Time, Force_errors_are_tolerable,UnitCell_Converged
!!$  logical  :: ChargeDensity_is_Fixed
#ifdef NEC_ITER_REG
  integer  :: count_for_ftrace
#endif

  integer :: initmpi
  logical :: confpara
  integer :: driver
  logical :: ending_t,force_conv,mpi_initialized,uconv
  logical :: initialization_required
  
#ifdef NEC_ITER_REG
     count_for_ftrace = 0
     call FTRACE_REGION_BEGIN("INITIAL")
#endif

  confpara = Resolve_Config_Parallel()
  initmpi=1
  if(confpara) initmpi=0
  mpi_initialized = .false.

  do

  ending_t = .false.
  if (mpi_initialized) initmpi=0
  call Initialization(initmpi)
  mpi_initialized = .true.
  call InputData_Analysis
  driver   = Resolve_Driver()

  if(driver == DRIVER_NEB) then
    call do_neb()
  else if(driver==DRIVER_CONSTRAINT) then
#ifndef DISABLE_CONSTRAINTS
    call constrained_dynamics()
#endif
  else if(driver==DRIVER_MTD) then
#ifndef DISABLE_CONSTRAINTS
    call meta_dynamics()
#endif
  else

  call Preparation                          ! Basis set, symmetry check etc.
  if(initialization_required())then
     call Preparation_for_mpi(1)     ! mpi
  endif
  call PseudoPotential_Construction
#ifdef PAW3D
  call  m_Parallel_init_mpi_paw_3D(nfout,natm,mmesh)
#endif
#ifdef ENABLE_ESM
  if(initialization_required())then
     call Preparation_for_ESM
  endif
#endif

  call Ewald_and_Structure_Factor
  call Initial_Electronic_Structure

  if(ChargeDensity_is_Fixed() .and. One_by_one_in_each_rank_k()) then ! icond=2, 3
     call ekcal  ! contained here
  else
     call Initial_MD_Condition
#ifdef NEC_ITER_REG
     call FTRACE_REGION_END("INITIAL")
#endif
     force_conv = Already_Converged()
     if(.not.force_conv) then
#ifdef NEC_ITER_REG
        call FTRACE_REGION_BEGIN("SOLVE-FIRST")
#endif
        StressLoop: do
           AtomicConfiguration: do
              ChargeDensity:    do
                 force_conv=.false.
#ifdef NEC_ITER_REG
                 count_for_ftrace = count_for_ftrace + 1
                 if(count_for_ftrace .eq. 2) then
                    call FTRACE_REGION_END("SOLVE-FIRST")
                    call FTRACE_REGION_BEGIN("SOLVE-CORE")
                 end if
#endif
                 call IterationNumber_Setting

! ============================ added by K. Tagami ============- 5.0
                 call Renewal_of_Chg_Ctrl_Param
! ============================================================ 5.0

                 call Renewal_of_WaveFunctions
                 call ChargeDensity_Construction(0)
                 call ChargeDensity_Mixing
                 ending_t = Ending_Time()
                 if(ending_t)                      exit StressLoop
                 if(TotalEnergy_is_Divergent())    exit StressLoop
                 call Renewal_of_Potential
                 if(Hubbard_model()) then
                    call Renewal_of_Hubbard_Parameters
                    call Renewal_of_Hubbard_Potential
                 end if
                 if(ChargeDensity_is_Converged())  exit ChargeDensity
              enddo ChargeDensity
              call Forces
              force_conv = Forces_are_Converged()
              if(force_conv) exit AtomicConfiguration
              if(Force_errors_are_tolerable()) then
                 call Postprocessing_during_MD()
                 call Move_Ions
                 call MDIterationNumber_Setting
                 call Ewald_and_Structure_Factor
!!$                 call MDIterationNumber_Setting
              end if
              if(BreakMD(force_conv))then
                 exit AtomicConfiguration
              endif
           enddo AtomicConfiguration
           call Stress
           exit StressLoop
        end do StressLoop
#ifdef NEC_ITER_REG
        if(count_for_ftrace .eq. 1) then
           call FTRACE_REGION_END("SOLVE-FIRST")
        else
           call FTRACE_REGION_END("SOLVE-CORE")
        end if
#endif
     end if

     if(Already_Converged2() .and. .not.Positron_defect() .and. Positron_bulk()) then
#ifdef NEC_ITER_REG
        call FTRACE_REGION_BEGIN("POSITRON")
#endif
        call Renewal_of_pPotential()
        call Solve_pWaveFunctions()
#ifdef NEC_ITER_REG
        call FTRACE_REGION_END("POSITRON")
#endif
     end if

#ifdef NEC_ITER_REG
     call FTRACE_REGION_BEGIN("FINAL")
#endif
  end if
  uconv = UnitCell_Converged(force_conv)
  if(.not.uconv.and..not.ending_t)then
     call MDIterationNumber_Setting2()
     call WriteDownData_onto_Files(.false.)
  else
     if(ChargeDensity_is_Fixed() .and. One_by_one_in_each_rank_k()) then ! icond=2, 3
        call WriteDownData_onto_Files_ek()
     else
        if(uconv) call Postprocessing(.false.)
        call WriteDownData_onto_Files(ending_t.or.uconv)
        if(uconv) exit
     end if
  endif

  if(.not.ending_t) then
     call Array_Deallocate()
     call Continuation_Mode()
  endif

  endif

  if (ending_t.or.OneShot()) exit

  enddo
#ifdef NEC_TIMER
  call print_timer()
#endif
  if(driver/=DRIVER_NEB) call Finalization_of_mpi           ! mpi
#ifdef NEC_ITER_REG
  call FTRACE_REGION_END("FINAL")
#endif
contains
  subroutine ekcal()
    logical :: AllKpoints_are_Calculated2, Already_Converged_for_Kgroup
    logical :: EigenValues_are_Converged, AllKpoints_are_Converged
    integer :: nk
    nk = 0
    KPOINT_GROUP: do
       call KpointNumber_Setting2()
       if(AllKpoints_are_Converged()) exit KPOINT_GROUP
       call Preparation_ek()
       call Preparation_for_mpi_ek
       call PseudoPotential_ek
       call Initial_WaveFunctions_ek
       if(.not.Already_Converged_for_kgroup()) then
          SolveWaveFunctions: do
             if(Ending_Time())                 exit KPOINT_GROUP
             call IterationNumber_Setting()
             call Renewal_of_WaveFunctions()
             if(EigenValues_are_Converged())   exit SolveWaveFunctions
          enddo SolveWaveFunctions
!!$          call Postprocessing_k()
          if(AllKpoints_are_Calculated2(nk))     exit KPOINT_GROUP
       else
          exit KPOINT_GROUP
       end if
    enddo KPOINT_GROUP
  end subroutine ekcal

  subroutine Continuation_Mode()
    use m_Const_Parameters,   only : COORDINATE_CONTINUATION,ON,OFF
    use m_Control_Parameters, only : icond, sw_optimize_lattice,sw_rebuild_pws
    if(sw_optimize_lattice==ON .and. sw_rebuild_pws==OFF) return
    icond = COORDINATE_CONTINUATION
  end subroutine continuation_mode

  subroutine Postprocessing_during_MD()
    use m_IterationNumbers, only : iteration_ionic
    use m_Control_Parameters, only : postproc_frequency
    if(postproc_frequency<=0) return
    if(mod(iteration_ionic,postproc_frequency)==0)then
       call Postprocessing(.true.)
    endif
  end subroutine Postprocessing_during_MD

  logical function BreakMD(conv)
    use m_IterationNumbers, only : iteration_ionic
    use m_Ionic_System, only : addition_frequency,m_IS_natm_can_change
    logical, intent(in) :: conv
    if(.not.m_IS_natm_can_change())then
       BreakMD = conv
       return
    endif
    BreakMD = mod(iteration_ionic,addition_frequency)==0
  end function BreakMD

  logical function OneShot()
    use m_Ionic_System, only : m_IS_natm_can_change
    use m_Control_Parameters, only : sw_optimize_lattice
    use m_Const_Parameters, only : OFF
    OneShot = .not.m_IS_natm_can_change()
    if(OneShot) then
        OneShot = sw_optimize_lattice==OFF
    endif
  end function OneShot

  logical function ChargeDensity_is_Fixed()
    use m_Control_Parameters, only : icond
    use m_Const_Parameters,   only : FIXED_CHARGE, FIXED_CHARGE_CONTINUATION
    if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) then
       ChargeDensity_is_Fixed = .true.
    else
       ChargeDensity_is_Fixed = .false.
    end if
  end function ChargeDensity_is_Fixed

  logical function One_by_one_in_each_rank_k()
    use m_Control_Parameters, only : fixed_charge_k_parallel
    use m_Const_Parameters,   only : ONE_BY_ONE
    if(fixed_charge_k_parallel == ONE_BY_ONE) then
       One_by_one_in_each_rank_k = .true.
    else
       One_by_one_in_each_rank_k = .false.
    end if
  end function One_by_one_in_each_rank_k

  integer function Resolve_Driver()
    use m_Control_Parameters, only : driver
    Resolve_Driver = driver
  end function Resolve_Driver

  logical function Resolve_Config_Parallel()
    use m_Parallelization, only : m_Parallel_resolve_conf_para
    implicit none
    Resolve_Config_Parallel = m_Parallel_resolve_conf_para()
  end function Resolve_Config_Parallel

  subroutine Array_Deallocate()
   end subroutine Array_Deallocate
end program PHASE

!=======================================================================
!
!  PROGRAM  PHASE/0 2014.01 (rev.375)
!
!  "First-principles Electronic Structure Calculation Program"
!
!  AUTHOR(S): T. Hamada
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!   The original version of this set of the computer programs "PHASE" was developed by 
!  the members of the Theory Group of Joint Research Center for Atom Technology 
!  (JRCAT), based in Tsukuba, in the period 1993-2001.  
!   Since 2002, this program set had been intensively developed as a part of the following 
!  national projects supported by the Ministry of Education, Culture, Sports, Science and 
!  Technology (MEXT) of Japan; "Frontier Simulation Software for Industrial Science 
!  (FSIS)" from 2002 to 2005, "Revolutionary Simulation Software (RSS21)" from 2006 to 
!  2008. "Research and Development of Innovative Simulation Software (RISS)" from 2008 
!  to 2013. These projects is lead by the Center for Research on Innovative Simulation 
!  Software (CISS), the Institute of Industrial Science (IIS), the University of Tokyo.
!   Since 2013, this program set has been further developed centering on PHASE System 
!  Consortium. 
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!#========================================================================
!#                                                                       #
!# Software Name : UVSOR ver. 3.00                                       #
!#                                                                       #
!#      Sub Routine : Reset_Kpoint                                       #
!#                                                                       #
!#                                Written by T. Hamada 2006/4/28         #
!#                                                                       #
!#      Contact address :  IIS,The University of Tokyo RSS21 project     #
!#                                                                       #
!#"Multiscale Simulation System for Functional Analysis of Nanomaterials"#
!#                                                                       #
!#========================================================================
!
! $Id: Reset_Kpoint.f90 238 2012-11-12 04:11:13Z yamasaki $
   subroutine Reset_Kpoint
     use m_Files,                 only : nfout
     use m_Kpoints,               only : kv3_ek, vkxyz_ek
     use m_Epsilon_ek,            only : sw_mass, ikshift, vkxyz_ek_org
     use m_Control_Parameters,    only : printable
     implicit none
     if(sw_mass==0.or.ikshift==0.0d0) return
     vkxyz_ek(1:kv3_ek,1:3,1:2) = vkxyz_ek_org(1:kv3_ek,1:3,1:2)
     if(printable) write(nfout,'(1x,"!* k-points are reseted")')
   end subroutine Reset_Kpoint

!=======================================================================
!
!  PROGRAM  PHASE/0 2014.01 (rev.375)
!
!  "First-principles Electronic Structure Calculation Program"
!
!  AUTHOR(S): K. Tagami
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!   The original version of this set of the computer programs "PHASE" was developed by 
!  the members of the Theory Group of Joint Research Center for Atom Technology 
!  (JRCAT), based in Tsukuba, in the period 1993-2001.  
!   Since 2002, this program set had been intensively developed as a part of the following 
!  national projects supported by the Ministry of Education, Culture, Sports, Science and 
!  Technology (MEXT) of Japan; "Frontier Simulation Software for Industrial Science 
!  (FSIS)" from 2002 to 2005, "Revolutionary Simulation Software (RSS21)" from 2006 to 
!  2008. "Research and Development of Innovative Simulation Software (RISS)" from 2008 
!  to 2013. These projects is lead by the Center for Research on Innovative Simulation 
!  Software (CISS), the Institute of Industrial Science (IIS), the University of Tokyo.
!   Since 2013, this program set has been further developed centering on PHASE System 
!  Consortium. 
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
module m_ES_Mag_Constraint
! $Id: m_ES_Mag_Constraint.f90 254 2012-11-16 07:15:25Z ktagami $
  use m_Parallelization,    only : mype, mpi_comm_group, npes, ierr
  
  use m_PseudoPotential,    only : ilmt, nlmt, dl2p

  use m_Control_Parameters,    only : neg, ndim_spinor, ndim_magmom
  use m_Const_Parameters,  only : DP, CMPLDP, yes

  use m_Charge_Density,        only : chgq_l, chgqo_l, hsr
  use m_Ionic_System,         only : natm, ityp,  mag_direction0_atomtyp, &
       &                             magmom_local_now

  use m_Crystal_Structure,  only : univol, &
       &                           mag_constraint_type, &
       &                           mag_moment_tag_global, &
       &                           mag_direc_tag_global, &
       &                           mag_constraint_lambda, &
       &                           duration_for_mag_constraint

  use m_IterationNumbers,  only : iteration_electronic
  use m_Electronic_Structure,  only : vlhxc_l, vlhxcQ

  implicit none

  include 'mpif.h'
  integer istatus(mpi_status_size)

  real(kind=DP) :: MagField_constrain_global(3)
  real(kind=DP), allocatable :: MagField_constrain_local(:,:,:,:)

contains

  subroutine m_ES_add_MagConstraintPot_globl
    select case ( mag_constraint_type )
    case (1)
       call case_constraint_moment_global
    case (2)
       call case_constraint_direc_global
    end select

  contains

    subroutine case_constraint_moment_global
      real(kind=DP) :: MagMom(3)
      integer :: is, ia, it, lmt1

      if ( mype == 0 ) then
         Do is=2, ndim_magmom
            MagMom(is-1) = chgq_l( 1,1,is ) *univol
         End do

         MagField_constrain_global(:) = &
              &  mag_constraint_lambda *( MagMom(:) -mag_moment_tag_global(:) )

         Do is=2, ndim_magmom
            vlhxc_l(1,1,is) = vlhxc_l(1,1,is) + MagField_constrain_global(is-1)
         End do
      endif

    end subroutine case_constraint_moment_global

    subroutine case_constraint_direc_global
      real(kind=DP) :: MagMom(3), MagDirec(3)
      real(kind=DP) :: c1, c2, cnorm, cnorm2
      integer :: is, ia, it, ixyz, lmt1

      real(kind=DP), parameter :: cnorm_lower_limit = 1.0D-10

      if ( mype == 0 ) then
         Do is=2, ndim_magmom
            MagMom(is-1) = chgq_l( 1,1,is ) *univol
         End do

         cnorm2 = 0.0d0
         Do ixyz=1, 3
            cnorm2 = cnorm2 + MagMom(ixyz)**2
         End do
         cnorm = sqrt( cnorm2 )

         if ( cnorm < cnorm_lower_limit ) then
            MagField_constrain_global = 0.0d0
            return
         endif

         MagDirec = MagMom / cnorm

         Do ixyz=1, 3
            c1 = cnorm2 - MagMom(ixyz)**2
            c2 = cnorm**3
            MagField_constrain_global(ixyz) = &
                 &  mag_constraint_lambda *c1 /c2 &
                 & *( MagDirec(ixyz) - mag_direc_tag_global(ixyz) )
         End do

         Do is=2, ndim_magmom
            vlhxc_l(1,1,is) = vlhxc_l(1,1,is) + MagField_constrain_global(is-1)
         End do
      endif

    end subroutine case_constraint_direc_global

  end subroutine m_ES_add_MagConstraintPot_globl

  subroutine m_ES_add_MagConstraintPot_local
    select case ( mag_constraint_type )
    case (4)
       !          stop "kt : constrain_type4 does not work properly....."
       call case_constraint_direc_local
    end select

  contains

    subroutine case_constraint_direc_local
      real(kind=DP) :: MagMom(3), MagDirec(3)
      real(kind=DP) :: c1, c2, cnorm, cnorm2
      integer :: ia, it, lmt1, lmt2, is, ixyz

      real(kind=DP), parameter :: cnorm_lower_limit = 1.0D-10
!
      if ( .not. allocated( MagField_constrain_local ) ) then
         allocate( MagField_constrain_local(nlmt,nlmt,natm,3 ) );
      endif
!
      MagField_constrain_local = 0.0d0
!
      Do ia=1, natm
         it = ityp(ia)
         Do ixyz=1, 3
            MagMom( ixyz ) = magmom_local_now( ia,ixyz )
         End do

         cnorm2 = 0.0d0
         Do ixyz=1, 3
            cnorm2 = cnorm2 + MagMom(ixyz)**2
         End do
         cnorm = sqrt( cnorm2 )

         if ( cnorm < cnorm_lower_limit ) then
            MagField_constrain_local(:,:,ia,:) = 0.0d0
            cycle
         endif

         MagDirec = MagMom / cnorm

         Do lmt1=1, ilmt(it)
            Do lmt2=1, ilmt(it)

               Do ixyz=1, 3
                  c1 = cnorm2 - MagMom(ixyz)**2
                  c2 = cnorm**3
                  MagField_constrain_local(lmt1,lmt2,ia,ixyz) = &
                       &  mag_constraint_lambda *c1 /c2 &
                       & *( MagDirec(ixyz) -mag_direction0_atomtyp(it,ixyz) ) &
                       & *dl2p(lmt1,lmt2,1,it)             ! approx
               End do
            End do
         End do

         Do lmt1=1, ilmt(it)
            Do lmt2=1, ilmt(it)
               Do is=2, ndim_magmom
                  vlhxcQ(lmt1,lmt2,ia,is) = vlhxcQ(lmt1,lmt2,ia,is) &
                       &       + MagField_constrain_local(lmt1,lmt2,ia,is-1)
               End do
            End do
         End Do

      end Do

    end subroutine case_constraint_direc_local

  end subroutine m_ES_add_MagConstraintPot_local


  subroutine m_ES_calc_MagConstraint_Energy( ene_double_counting, ene_mag_constraint )
    real(kind=DP), intent(out) :: ene_double_counting
    real(kind=DP), intent(out) :: ene_mag_constraint

    ene_double_counting = 0.0d0
    ene_mag_constraint = 0.0d0

    select case ( mag_constraint_type )
    case (1)
       call case_constraint_moment_global
    case (2)
       call case_constraint_direc_global
    case (4)
       call case_constraint_direc_local
    end select

  contains

    subroutine case_constraint_moment_global
      real(kind=DP) :: MagMom(3), c1, c2
      real(kind=DP) :: MagMomOld(3)
      integer :: is, ixyz

      if ( mype == 0 ) then
         Do is=2, ndim_magmom
            MagMom(is-1) = chgq_l(  1,1,is ) *univol
            MagMomOld(is-1) = chgqo_l(  1,1,is ) *univol
         End do

         c1 = 0.0d0;  c2 = 0.0d0
         Do ixyz=1, 3
            c1 = c1 + MagField_constrain_global(ixyz) *MagMom(ixyz)
            c2 = c2 + ( MagMom(ixyz) -mag_moment_tag_global(ixyz) )**2
         End do
         ene_double_counting = c1
         ene_mag_constraint = c2 *mag_constraint_lambda / 2.0d0
      endif

      if (npes > 1) then
         call mpi_allreduce( ene_double_counting, c1, 1, mpi_double_precision, &
              &              mpi_sum, mpi_comm_group, ierr )
         call mpi_allreduce( ene_mag_constraint, c2, 1, mpi_double_precision, &
              &              mpi_sum, mpi_comm_group, ierr )
         ene_double_counting = c1
         ene_mag_constraint = c2
      end if

    end subroutine case_constraint_moment_global

    subroutine case_constraint_direc_global
      real(kind=DP) :: MagMom(3), MagDirec(3), c1, c2
      integer :: is, ixyz

      real(kind=DP) :: cnorm, cnorm2
      real(kind=DP), parameter :: cnorm_lower_limit = 1.0D-10

      if ( mype == 0 ) then
         Do is=2, ndim_magmom
            MagMom(is-1) = chgq_l(  1,1,is ) *univol
         End do

         cnorm2 = 0.0d0
         Do ixyz=1, 3
            cnorm2 = cnorm2 + MagMom(ixyz)**2
         End do
         cnorm = sqrt( cnorm2 )

         if ( cnorm > cnorm_lower_limit ) then
            MagDirec = MagMom / cnorm

            c1 = 0.0d0;  c2 = 0.0d0
            Do ixyz=1, 3
               c1 = c1 + MagField_constrain_global(ixyz) *MagMom(ixyz)
               c2 = c2 + ( MagDirec(ixyz) -mag_direc_tag_global(ixyz) )**2
            End do

            ene_double_counting = c1
            ene_mag_constraint = c2 *mag_constraint_lambda /2.0d0
         endif
      endif

      if (npes > 1) then
         call mpi_allreduce( ene_double_counting, c1, 1, mpi_double_precision, &
              &              mpi_sum, mpi_comm_group, ierr )
         call mpi_allreduce( ene_mag_constraint, c2, 1, mpi_double_precision, &
              &              mpi_sum, mpi_comm_group, ierr )
         ene_double_counting = c1
         ene_mag_constraint = c2
      end if

    end subroutine case_constraint_direc_global

    subroutine case_constraint_direc_local
      real(kind=DP) :: MagMom(3), MagDirec(3), c1, c2
      integer :: ia, it, lmt1, lmt2, is, ixyz

      real(kind=DP) :: csum1, csum2
      real(kind=DP) :: cnorm, cnorm2
      real(kind=DP), parameter :: cnorm_lower_limit = 1.0D-10

      csum1 = 0.0d0; csum2 = 0.0d0

      Do ia=1, natm
         it = ityp(ia)
         Do ixyz=1, 3
            MagMom(ixyz) = magmom_local_now( ia,ixyz )
         End do

         cnorm2 = 0.0d0
         Do ixyz=1, 3
            cnorm2 = cnorm2 + MagMom(ixyz)**2
         End do
         cnorm = sqrt( cnorm2 )

         if ( cnorm > cnorm_lower_limit ) then
            MagDirec = MagMom / cnorm

            Do lmt1=1, ilmt(it)
               Do lmt2=1, ilmt(it)

                  Do ixyz=1, 3
                     csum1 = csum1 + MagField_constrain_local(lmt1,lmt2,ia,ixyz) &
                          &          *hsr(ia,lmt1,lmt2,ixyz +1)
                  End do
               End do
            End do

            Do ixyz=1, 3
               csum2 = csum2 + ( MagDirec(ixyz)-mag_direction0_atomtyp(it,ixyz) )**2
            End do
         endif

      End do

      ene_double_counting = csum1
      ene_mag_constraint = csum2 *mag_constraint_lambda/ 2.0d0

    end subroutine case_constraint_direc_local

  end subroutine m_ES_calc_MagConstraint_Energy

end module m_ES_Mag_Constraint

!=======================================================================
!
!  PROGRAM  PHASE/0 2014.01 (rev.375)
!
!  "First-principles Electronic Structure Calculation Program"
!
!  AUTHOR(S): K. Tagami
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!   The original version of this set of the computer programs "PHASE" was developed by 
!  the members of the Theory Group of Joint Research Center for Atom Technology 
!  (JRCAT), based in Tsukuba, in the period 1993-2001.  
!   Since 2002, this program set had been intensively developed as a part of the following 
!  national projects supported by the Ministry of Education, Culture, Sports, Science and 
!  Technology (MEXT) of Japan; "Frontier Simulation Software for Industrial Science 
!  (FSIS)" from 2002 to 2005, "Revolutionary Simulation Software (RSS21)" from 2006 to 
!  2008. "Research and Development of Innovative Simulation Software (RISS)" from 2008 
!  to 2013. These projects is lead by the Center for Research on Innovative Simulation 
!  Software (CISS), the Institute of Industrial Science (IIS), the University of Tokyo.
!   Since 2013, this program set has been further developed centering on PHASE System 
!  Consortium. 
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
module m_SpinOrbit_RadInt
! $Id: m_SpinOrbit_RadInt.f90 285 2013-01-01 04:33:41Z ktagami $
  use m_Const_Parameters,    only : DP, CMPLDP, PAI4, &
       &                             SphericalHarmonicsExpansion, &
       &                             BUILTIN, ByPawPot, ZeffApprox, yes
  use m_Files,               only : nfout

  use m_Control_Parameters,  only : nspin ,ndim_magmom, noncol, ndim_chgpot, &
       &                            SpinOrbit_MassCorrection, &
       &                            SpinOrbit_Mode

  use m_PseudoPotential,   only : ipaw, nlmt, ilmt, ltp, mtp, taup, &
       &                          lppw, tppw, wf_mnrc, radr_paw, &
       &                          iltpw, psirpw, ival, mmesh, nmesh, xh, &
       &                          lpsmax, nloc, ntau, &
       &                          pot_has_soc, ntyp

  use m_Ionic_System,          only : ityp, natm, iwei, iatomn, &
       &                              scaling_so, magmom_local_now

  use m_PAW_XC_Potential,    only : vxc_ae_k

  use m_PAW_ChargeDensity,    only : paw_dnr, surface_integral_method, &
       &                             m_PAWCD_set_ae_cd_sphex2, &
       &                             m_PAWCD_ae_cd_sphex2_nonclA

  use m_SpinOrbit_Potential,         only : Mat_LS_with_real_ylm_L0, &
       &                             Mat_LS_with_real_ylm_L1, &
       &                             Mat_LS_with_real_ylm_L2, &
       &                             Mat_LS_with_real_ylm_L3, dsoc

  use m_SpinOrbit_Potential,           only :  Mat_SOC_Strength

  use m_PseudoPotential,   only : flg_paw, Mat_SOC_Strength_nonpaw


  implicit none
  include 'mpif.h'

  integer max_sph_expansion
  parameter( max_sph_expansion = 25 )

  real(kind=DP), allocatable :: vtot_rad(:)
  real(kind=DP), allocatable :: dV_rad(:)

!
contains

  subroutine alloc_vtot_and_dV
    allocate( vtot_rad( mmesh ) ); vtot_rad = 0.0d0
    allocate( dV_rad( mmesh ) )  ; dV_rad = 0.0d0
  end subroutine alloc_vtot_and_dV
  
  subroutine dealloc_vtot_and_dV
    deallocate( vtot_rad );  deallocate( dV_rad )
  end subroutine dealloc_vtot_and_dV
    
  subroutine m_SO_calc_SOC_strength_pawpot

    integer :: ia, it, nrc, mesh_t
    real(kind=DP), allocatable :: nae_sph(:,:,:)
    real(kind=DP), allocatable :: rho_00(:)

    call alloc_nae_sph
    call alloc_rho_for_poisson

    call alloc_vtot_and_dV

    Mat_SOC_Strength = 0.0d0

    do ia = 1, natm
       it = ityp(ia)

!       if( ipaw(it)/=1 .or. &
!              & surface_integral_method(it).ne.SphericalHarmonicsExpansion) cycle

       call calc_radial_charge_Y00( ia, it, nrc, rho_00 )

       call set_rho_for_poisson_eq( it, nrc, rho_00 ) 

       call set_size_mesht( it, nrc, rho_00, mesh_t )
       call calc_Hartree_pot_Y00( 5, mesh_t, radr_paw(:,it), rho_00, vtot_rad )    
!
       call calc_total_potential_Y00( ia, it, vtot_rad )
!
       call calc_central_potential( it, nrc, vtot_rad, dV_rad )

       call integrate_central_potential2( it, nrc, dV_rad, Mat_SOC_Strength(:,:,:,ia) )

    End Do

    call dealloc_nae_sph
    call dealloc_rho_for_poisson

    call dealloc_vtot_and_dV

  contains

    subroutine alloc_nae_sph
      if ( noncol ) then
         allocate( nae_sph(mmesh,ndim_magmom,max_sph_expansion) )
      else
         allocate( nae_sph(mmesh,nspin,max_sph_expansion) )
      endif
      nae_sph = 0.0d0
    end subroutine alloc_nae_sph
    
    subroutine dealloc_nae_sph
      deallocate( nae_sph )
    end subroutine dealloc_nae_sph
    
    subroutine alloc_rho_for_poisson
      allocate( rho_00( mmesh ) ); rho_00 = 0.0d0
    end subroutine alloc_rho_for_poisson
    
    subroutine dealloc_rho_for_poisson
      deallocate( rho_00 ) 
    end subroutine dealloc_rho_for_poisson


    subroutine calc_central_potential( it, nrc, vtot_rad, dV_rad )        !  dV/dr *1/r
      integer, intent(in) :: it, nrc
      real(kind=DP), intent(in) :: vtot_rad(mmesh)
      real(kind=DP), intent(out) :: dV_rad(mmesh)
!
      real(kind=DP), parameter :: InvHyperFineConst = 137.035999679D0
      real(kind=DP) :: HyperFineConst
      real(kind=DP) :: fac1, fac2
      integer :: ir, ier
!
      HyperFineConst = 1.0d0 / InvHyperFineConst
!
      dV_rad = 0.0d0
      call calc_diff_exp( ier, 4, nrc, radr_paw(:,it), vtot_rad, dV_rad )
!
      fac1 = 0.5d0 * HyperFineConst**2
!
      if ( SpinOrbit_MassCorrection == 0 ) then
         Do ir=1, nrc
            dV_rad(ir) = fac1 *dV_rad(ir) / radr_paw(ir,it)
         End do

      else if ( SpinOrbit_MassCorrection == 1 ) then
         Do ir=1, nrc
            fac2 = 1.0d0 - vtot_rad(ir) *HyperFineConst **2
            dV_rad(ir) = fac1 *dV_rad(ir) / radr_paw(ir,it) /fac2
         End do

      else if ( SpinOrbit_MassCorrection == 2 ) then
         Do ir=1, nrc
            fac2 = 1.0d0 - vtot_rad(ir) *HyperFineConst **2 /2.0d0
            dV_rad(ir) = fac1 *dV_rad(ir) / radr_paw(ir,it) /fac2
         End do
      endif
!
      dV_rad(:) = dV_rad(:) *scaling_so(it)
!
    end subroutine calc_central_potential

    subroutine calc_total_potential_Y00( ia, it, vtot_rad )
      integer, intent(in) :: ia, it
      real(kind=DP) :: vtot_rad(mmesh)

      integer :: ir
      real(kind=DP) :: factor, c1, c2, c3

      factor = sqrt(PAI4)

!      Do ir=1, nrc
      Do ir=1, nmesh(it)
         if ( nspin==2 ) then
            c1 = vxc_ae_k( ir,1,1,ia ) + vxc_ae_k( ir,2,1,ia )
            c1 = c1 / 2.0d0
         else
            c1 = vxc_ae_k( ir,1,1,ia )
         endif
!
         c2 = -dble(iatomn(it)) / radr_paw(ir,it)
         c3 = ( c2 + vtot_rad(ir) ) *factor

         vtot_rad(ir) = c1 + c3
      End do
      vtot_rad = vtot_rad /factor
!
    end subroutine calc_total_potential_Y00

    subroutine calc_radial_charge_Y00( ia, it, nrc, rho_00 )
      integer, intent(in) :: ia, it
      integer, intent(out) :: nrc
      real(kind=DP), intent(out) :: rho_00(mmesh)

      real(kind=DP) :: wos(mmesh), factor

      integer :: ier, ir
      integer :: nrc0, dnr, zz
      
      integer :: msphmx, msph
      integer :: msphmx_chg
      integer :: num_isph_chg, isph_chg(max_sph_expansion)
      integer        :: id_sname = -1
!
      real(kind=DP), allocatable :: dummy1(:,:)
      real(kind=DP), allocatable :: dummy2(:,:,:)
!
      
      factor = sqrt(PAI4)

      dnr = paw_dnr(it)
!      dnr = 1

      rho_00 = 0.0d0

      if (dnr.gt.1) then
         nrc0 = wf_mnrc(it)
         nrc = 1 +int((nrc0-1)/dnr)*dnr
         zz = dble(nrc0-nrc)/dble(dnr)
         nrc = nrc +2*dnr                                                 ! 3rd
         call set_weight_exp3(ier,1,nrc,dnr,radr_paw(:,it),zz,wos)     !  3rd
      else
         nrc=wf_mnrc(it)
         call set_weight_exp(ier,1,nrc,radr_paw(:,it),wos)
      end if
      
      do ir=1,nrc,dnr
         wos(ir) = wos(ir)*radr_paw(ir,it)**2
      end do
      wos = wos*iwei(ia)

      msphmx_chg = 0
      msph = max_sph_expansion


      if ( noncol ) then
         allocate( dummy1(3,msph) );  allocate( dummy2(nrc,ndim_magmom,msph) )

         call m_PAWCD_ae_cd_sphex2_nonclA( ia, nspin, nrc, dnr, &
              &                           msph, nae_sph(1:nrc,:,:), msphmx_chg, &
              &                           num_isph_chg, isph_chg, wos, &
              &                           1, &
              &                           dummy1, dummy2 )

         deallocate( dummy1 );  deallocate( dummy2 )
      else
         call m_PAWCD_set_ae_cd_sphex2( ia, nspin, nrc, dnr, &
              &                         msph, nae_sph(1:nrc,:,:), msphmx_chg, &
              &                         num_isph_chg, isph_chg )
      endif
         
      if ( noncol ) then
         rho_00(:) = nae_sph( :,1,1 ) + nae_sph(:,2,1)
      else
         if ( nspin==1 ) then
            rho_00(:) = nae_sph(:,1,1)
         else if ( nspin==2 ) then
            rho_00(:) = nae_sph(:,1,1) + nae_sph(:,2,1)
         endif
      end if
!  ---------
!      if ( SpinOrbit_MassCorrection == 2 ) then
!!!         rho_00 = rho_00 *factor
!      endif
! ---
    end subroutine calc_radial_charge_Y00

    subroutine set_rho_for_poisson_eq( it, nrc, rho ) 
                                     ! 4 *pi *r**2 *rho_lm( r,l=0,ispin=1 )
      integer, intent(in) :: it, nrc
      real(kind=DP), intent(inout) :: rho(mmesh)

      integer :: ir
      Do ir=1, nrc
         rho(ir) = PAI4 *radr_paw(ir,it)**2 * rho(ir)
      End Do
    end subroutine set_rho_for_poisson_eq

    subroutine set_size_mesht( it, nrc, rho, mesh_t )
      integer, intent(in) :: it, nrc
      integer, intent(out) :: mesh_t
      real(kind=DP), intent(in) :: rho(mmesh)

      integer     :: i
      real(kind=DP), parameter :: CRDAMP = 1.d0
      real(kind=DP), parameter :: CRDIST = 10.d0

      mesh_t = nrc
      return

      do i = 10, nmesh(it)-1
         if ( rho(i) - rho(i+1) > CRDAMP .and. radr_paw(i,it) < CRDIST) then
            mesh_t = i
!            if(iprippex>=1) write(nfout,'(" LMTO pot. r_ws=",i5,f12.6)') i, radr(i)

            write(*,*) 'mesht nrc = ', mesh_t, nrc, nmesh(it)

            return
         end if
      enddo
      mesh_t = nmesh(it)

    end subroutine set_size_mesht

    subroutine calc_Hartree_pot_Y00( nsize, mesh_t, radr, rhvr, vvv )    
      integer, intent(in) :: nsize, mesh_t
      real(kind=DP), intent(in) :: radr( mmesh )
      real(kind=DP), intent(in) :: rhvr( mmesh )
      real(kind=DP), intent(out) :: vvv( mmesh )

      real(kind=DP)       :: s2, rhs, rhs1, bm
      real(kind=DP),allocatable,dimension(:) :: da, db ! d(nsize)
      real(kind=DP), allocatable :: wkx(:), wky(:), wkz(:)

      integer             :: i

      real(kind=DP) ::   hh

      hh = 1.0 / xh(it)
      allocate(wkx(mmesh)); wkx = 0.d0
      allocate(wky(mmesh)); wky = 0.d0
      allocate(wkz(mmesh)); wkz = 0.d0

     !+++++++++++++++++++++++++++++++
      allocate(da(nsize)); da = 0.d0
      allocate(db(nsize)); db = 0.d0
     !+++++++++++++++++++++++++++++++
      s2 = dlog(rhvr(2)/rhvr(1))/ hh
      rhs = rhvr(1)
      wkx(1)  = rhs*radr(1)/(s2+1)
      wky(1)  = rhs/s2
      db(1)   = hh*rhs*3.d0
      da(1)   = db(1)*radr(1)
      rhs1    = rhs
      do i = 2,3
         rhs     = rhvr(i)
         wkx(i)  = wkx(i-1) + hh *(rhs*radr(i)+rhs1*radr(i-1))*0.5d0
         wky(i)  = wky(i-1) + hh *(rhs        +rhs1          )*0.5d0
         db(i)   = hh *rhs*3.d0
         da(i)   = db(i)*radr(i)
         rhs1    = rhs
      enddo
      do i = 4,mesh_t
         rhs    = rhvr(i)
         db(4)  = hh *rhs*3.d0
         da(4)  = db(4)*radr(i)
         wkx(i)=(9*wkx(i-1)-wkx(i-3)+da(4)+2.d0*da(3)-da(2))/8.d0
         wky(i)=(9*wky(i-1)-wky(i-3)+db(4)+2.d0*db(3)-db(2))/8.d0
         da(1)  = da(2)
         db(1)  = db(2)
         da(2)  = da(3)
         db(2)  = db(3)
         da(3)  = da(4)
         db(3)  = db(4)
      enddo
      bm               = wky(mesh_t)
     !C--*--COULOMB POTENTIAL RVC
      vvv = 0.d0
      do i = 1,mesh_t
!!!         vvv(i) = wkx(i) + radr(i)*(bm-wky(i))        ! r *Vh(r)
         vvv(i) = wkx(i) + (bm-wky(i))                   ! Vh(r)
      enddo
     !+++++++++++++++++++++++++++++++
      deallocate(da); deallocate(db)
      deallocate(wkx)
      deallocate(wky)
      deallocate(wkz)
     !+++++++++++++++++++++++++++++++

    end subroutine Calc_Hartree_pot_Y00

  end subroutine m_SO_calc_SOC_strength_pawpot

  subroutine integrate_central_potential2( it, nrc, dV_rad, Mat )
    integer, intent(in) :: nrc, it
    real(kind=DP), intent(in) :: dV_rad(mmesh)
    real(kind=DP), intent(out) :: Mat( nloc, ntau, ntau )
    
    integer :: ier, ir
    integer :: ilt1, ilt2
    integer :: il1, il2, it1, it2
    real(kind=DP) :: csum, tmp1
    real(kind=DP) :: wos(mmesh)
    
    call set_weight_exp( ier, 1, nrc, radr_paw(:,it), wos )

!      write(*,*) "ilmt, iltpw, nlmt = ", ilmt(it), iltpw(it), nlmt
!      stop

    Mat = 0.0d0
    
    Do ilt1=1, iltpw(it)
       il1 = lppw(ilt1,it)
       it1 = tppw(ilt1,it)
       Do ilt2=1, iltpw(it)
          il2 = lppw(ilt2,it)
          it2 = tppw(ilt2,it)
          
          if ( il1 /= il2 ) cycle
          
          csum = 0.0d0
          Do ir=1, nrc
             tmp1 = dV_rad(ir) *psirpw( ir, il1, it1, it )  &
                  &            *psirpw( ir, il2, it2, it )  &
                  &            *wos(ir)
             
             csum  = csum + tmp1
          End do
          Mat( il1, it1, it2 ) = csum
       End do
    End Do

  end subroutine integrate_central_potential2

  subroutine m_SO_check_mode_Builtin
    integer it
!
    Do it=1, 1
       if ( pot_has_soc(it) ) then
          
          if ( SpinOrbit_Mode /= BUILTIN ) then
             SpinOrbit_Mode = BUILTIN
             write(nfout,*) '** ------------------------- **'
             write(nfout,*) '** SpinOrbit mode is force to set to BUILTIN'
          endif
       else
          if ( SpinOrbit_Mode == BUILTIN ) then
             write(nfout,*) '** ------------------------- **'
             write(nfout,*) &
                  & '** Please use the spin-orbit splitted pseudopotential '
             write(nfout,*) &
                  & '** for atom type ', it
             stop
          endif
       endif
    End do

    if ( SpinOrbit_Mode == BUILTIN ) then
       Do it=2, ntyp
          if ( .not. pot_has_soc(it) ) then
             write(nfout,*) '** ------------------------- **'
             write(nfout,*) &
                  & '** Please use the spin-orbit splitted pseudopotential '
             write(nfout,*) &
                  & '** for atom type ', it
             stop
          endif
       End do
    end if
!
  end subroutine m_SO_check_mode_Builtin

  subroutine m_SO_check_mode_Pawpot
    integer it
!
    if ( SpinOrbit_Mode == BUILTIN ) return
    if ( SpinOrbit_Mode == ByPawPot ) then
       Do it=1, ntyp
          if ( ipaw(it) /= yes ) then
             write(nfout,*) '** ------------------------- **'
             write(nfout,*) &
                  & '** Please use the paw pseudopotential for atom type ', it
             write(nfout,*) '*** and confirm that "paw = off" is commeted out in the accuracy tag '
             stop
          endif
       End Do
    endif
!
  end subroutine m_SO_check_mode_Pawpot

  subroutine m_SO_check_mode_Zeff
    integer it
!
    if ( SpinOrbit_Mode == BUILTIN ) return
    if ( SpinOrbit_Mode == ByPawPot ) return

    if ( SpinOrbit_Mode == ZeffApprox ) then

    endif
!
  end subroutine m_SO_check_mode_Zeff

  subroutine m_SO_calc_SOC_strength_zeff
    integer :: ia, it, nrc

    Mat_SOC_Strength = 0.0d0

    if ( flg_paw ) then
       call alloc_vtot_and_dV

       do ia = 1, natm
          it = ityp(ia)
          nrc = wf_mnrc(it)
          call calc_central_pot_zeff( it, nrc, dV_rad )
          call integrate_central_potential2( it, nrc, dV_rad, &
               &                              Mat_SOC_Strength(:,:,:,ia) )
       End Do

       call dealloc_vtot_and_dV
    else
       Do ia=1, natm
          it = ityp(ia)
          Mat_SOC_Strength(:,:,:,ia) = Mat_SOC_Strength_nonpaw(:,:,:,it)  &
               &                       * scaling_so(it)
       End do
    endif 

  contains

    subroutine calc_central_pot_zeff( it, nrc, dV_rad )        !  dV/dr *1/r
      integer, intent(in) :: it, nrc
      real(kind=DP), intent(out) :: dV_rad(mmesh)
!
      real(kind=DP), parameter :: InvHyperFineConst = 137.035999679D0
      real(kind=DP) :: HyperFineConst
      real(kind=DP) :: fac1, fac2
      integer :: ir, ier
!
      HyperFineConst = 1.0d0 / InvHyperFineConst
!
      dV_rad = 0.0d0
      fac1 = 0.5d0 * HyperFineConst**2

      if ( SpinOrbit_MassCorrection == 0 ) then
         Do ir=1, nrc
            dV_rad(ir) = fac1 *dble(iatomn(it)) / radr_paw(ir,it)**3
         End do

      else if ( SpinOrbit_MassCorrection == 1 ) then
         Do ir=1, nrc
            fac2 = 1.0d0 + HyperFineConst**2 &
                 &         *dble(iatomn(it))/ radr_paw(ir,it) 
            dV_rad(ir) = fac1 *dble(iatomn(it)) / radr_paw(ir,it)**3 /fac2
         End do

      else if ( SpinOrbit_MassCorrection == 2 ) then
         Do ir=1, nrc
            fac2 = 1.0d0 + HyperFineConst**2 /2.0d0 &
                 &         *dble(iatomn(it))/ radr_paw(ir,it) 
            dV_rad(ir) = fac1 *dble(iatomn(it)) / radr_paw(ir,it)**3 /fac2
         End do

      end if
!
      dV_rad(:) = dV_rad(:) * scaling_so(it)
!
    end subroutine calc_central_pot_zeff

  end subroutine m_SO_calc_SOC_strength_zeff

end module m_SpinOrbit_RadInt

module m_OP_Moment
! $Id: m_OP_Moment.F90 287 2013-01-01 15:21:08Z ktagami $

  use m_Control_Parameters,  only : proj_attribute, proj_group, num_proj_elems, &
       &                            max_projs, ndim_spinor, ndim_magmom, ndim_chgpot, &
       &                            iprimagmom

  use m_Const_Parameters,     only : DP, CMPLDP, zi
  use m_Ionic_System,         only : natm, iproj_group

  use m_SpinOrbit_Potential,  only :  MatU_ylm_RC_L0,  MatU_ylm_RC_L1, &
       &                              MatU_ylm_RC_L2,  MatU_ylm_RC_L3
  use m_Orbital_Population,   only :  om, om_aimag, ommix, ommix_aimag, i2lp
  use m_Parallelization,       only : mype

  use m_ES_NonCollinear,       only :  m_ES_MagMom_To_DensMat_porb, &
       &                               m_ES_set_Pauli_Matrix
  use m_Files,                 only : nfout

  implicit none
  include 'mpif.h'

  complex(kind=CMPLDP) :: Mat_L_with_cmplx_ylm_L0(  0:0, 0:0, 3 )
  complex(kind=CMPLDP) :: Mat_L_with_cmplx_ylm_L1( -1:1,-1:1, 3 )
  complex(kind=CMPLDP) :: Mat_L_with_cmplx_ylm_L2( -2:2,-2:2, 3 )
  complex(kind=CMPLDP) :: Mat_L_with_cmplx_ylm_L3( -3:3,-3:3, 3 )
!
  complex(kind=CMPLDP) :: Mat_L_with_real_ylm_L0( 1, 1, 3 )
  complex(kind=CMPLDP) :: Mat_L_with_real_ylm_L1( 3, 3, 3 )
  complex(kind=CMPLDP) :: Mat_L_with_real_ylm_L2( 5, 5, 3 )
  complex(kind=CMPLDP) :: Mat_L_with_real_ylm_L3( 7, 7, 3 )

contains

  subroutine m_OP_calc_orbmom_from_OCC           ! From occupation marix
    integer :: ia, it, i, ig, ie, ip, l, m1, m2
    integer :: is1, is2, istmp, size1
!
    real(kind=DP) :: orbmom(3), spinmom(3)
    complex(kind=CMPLDP) :: ztmp(3)
    complex(kind=CMPLDP) :: PauliMatrix( ndim_magmom, ndim_spinor, ndim_spinor )
!
    real(kind=DP), allocatable :: dmmat_r_magmom( :,:,: )
    real(kind=DP), allocatable :: dmmat_i_magmom( :,:,: )
    complex(kind=CMPLDP), allocatable :: dmmat_ssrep( :,:,: )

    logical :: FirstFlag = .true.
    logical :: print_header
! -----------
    if ( iprimagmom < 3 ) return

    if ( FirstFlag ) then
       call m_OP_calc_MatL_orb_s_to_f
       FirstFlag = .false.
    endif
    print_header = .true.

    call m_ES_set_Pauli_Matrix( PauliMatrix )

    do ia=1, natm
       ig = iproj_group(ia)
       if ( ig <1 ) cycle

       do i=1,num_proj_elems(ig)
          ip = proj_group(i,ig)
          it = proj_attribute(ip)%ityp
          ie = proj_attribute(ip)%ielem
          l  = proj_attribute(ip)%l

          size1 = i2lp(ip)
          allocate( dmmat_r_magmom(size1,size1,ndim_magmom) ); dmmat_r_magmom = 0.0d0
          allocate( dmmat_i_magmom(size1,size1,ndim_magmom) ); dmmat_i_magmom = 0.0d0
          allocate( dmmat_ssrep(size1,size1,ndim_chgpot) );  dmmat_ssrep = 0.0d0

!          dmmat_r_magmom(:,:,:) = om(:,:,ie,ia,:)
!          dmmat_i_magmom(:,:,:) = om_aimag(:,:,ie,ia,:)
          dmmat_r_magmom(:,:,:) = ommix(:,:,ie,ia,:)
          dmmat_i_magmom(:,:,:) = ommix_aimag(:,:,ie,ia,:)

          call m_ES_MagMom_To_DensMat_porb( size1**2, dmmat_r_magmom, dmmat_i_magmom, &
               &                            dmmat_ssrep )

          orbmom = 0.0d0; spinmom = 0.0d0

          Do is1=1, ndim_spinor
             Do is2=1, ndim_spinor
                if ( is1 /= is2 ) cycle

                istmp = ( is1 -1 )*ndim_spinor + is2

                Do m1=1, size1
                   Do m2=1, size1
                      ztmp = 0.0d0
                      if ( l == 1 ) then
                         ztmp(:) = Mat_L_with_real_ylm_L1( m2, m1, : )
                      else if ( l == 2 ) then
                         ztmp(:) = Mat_L_with_real_ylm_L2( m2, m1, : )
                      else if ( l == 3 ) then
                         ztmp(:) = Mat_L_with_real_ylm_L3( m2, m1, : )
                      endif

                      orbmom(1) = orbmom(1) +dmmat_ssrep(m1,m2,istmp) *ztmp(1)
                      orbmom(2) = orbmom(2) +dmmat_ssrep(m1,m2,istmp) *ztmp(2)
                      orbmom(3) = orbmom(3) +dmmat_ssrep(m1,m2,istmp) *ztmp(3)
                   End do
                End do
             End do
          End do

          Do is1=1, ndim_spinor
             Do is2=1, ndim_spinor
                istmp = ( is1 -1 )*ndim_spinor + is2
                Do m1=1, size1
                   Do m2=1, size1
                      spinmom(1) = spinmom(1) +dmmat_ssrep(m1,m2,istmp) &
                           &                  *PauliMatrix(2,is2,is1)
                      spinmom(2) = spinmom(2) +dmmat_ssrep(m1,m2,istmp) &
                           &                  *PauliMatrix(3,is2,is1)
                      spinmom(3) = spinmom(3) +dmmat_ssrep(m1,m2,istmp) &
                           &                  *PauliMatrix(4,is2,is1)
                   End do
                End do
             End do
          End do
!
          deallocate( dmmat_r_magmom ); deallocate( dmmat_i_magmom )
          deallocate( dmmat_ssrep )
! --
          call  print_spin_orb_mom_local( ia, l, spinmom, orbmom, print_header )
          print_header = .false.
       end do
    End do

  contains

    subroutine print_spin_orb_mom_local( ia, l, spinmom, orbmom, print_header )
      integer, intent(in) :: ia, l
      real(kind=DP), intent(in) :: spinmom(3), orbmom(3)
      logical, intent(in) :: print_header

      if (print_header) then
         write(nfout,*) '! ------------ Local Momemnt ( occmat )  --- '
      endif

      write(nfout,*) '!   ia   l   type          mx             my             mz  '
!
      write(nfout,'(I7,I4,3X,A5,3F15.8)') ia, l, "orb  ", orbmom(1), orbmom(2), orbmom(3)
      write(nfout,'(14X,     A5,3F15.8)')     "spin ", spinmom(1), spinmom(2), spinmom(3)
!
      write(nfout,*) '! ------ '

    end subroutine print_spin_orb_mom_local

  end subroutine m_OP_calc_orbmom_from_OCC


! ------------------
  subroutine m_OP_calc_MatL_orb_s_to_f
    real(kind=DP) :: theta, phi

    theta = 0.0; phi = 0.0d0
    call m_OP_calc_MatL_with_Cmplx_ylm( 0, theta, phi, &
         &                              Mat_L_with_cmplx_ylm_L0 )
    call m_OP_calc_MatL_with_Real_ylm( 0, MatU_ylm_RC_L0, &
         &                             Mat_L_with_cmplx_ylm_L0, &
         &                             Mat_L_with_real_ylm_L0 )
!
    call m_OP_calc_MatL_with_Cmplx_ylm( 1, theta, phi, &
         &                              Mat_L_with_cmplx_ylm_L1 )
    call m_OP_calc_MatL_with_Real_ylm( 1, MatU_ylm_RC_L1, &
         &                             Mat_L_with_cmplx_ylm_L1, &
         &                             Mat_L_with_real_ylm_L1 )
!
    call m_OP_calc_MatL_with_Cmplx_ylm( 2, theta, phi, &
         &                              Mat_L_with_cmplx_ylm_L2 )
    call m_OP_calc_MatL_with_Real_ylm( 2, MatU_ylm_RC_L2, &
         &                              Mat_L_with_cmplx_ylm_L2, &
         &                              Mat_L_with_real_ylm_L2 )
!
    call m_OP_calc_MatL_with_Cmplx_ylm( 3, theta, phi, &
         &                              Mat_L_with_cmplx_ylm_L3 )
    call m_OP_calc_MatL_with_Real_ylm( 3, MatU_ylm_RC_L3, &
         &                             Mat_L_with_cmplx_ylm_L3, &
         &                             Mat_L_with_real_ylm_L3 )
  end subroutine m_OP_calc_MatL_orb_s_to_f


  subroutine m_OP_calc_MatL_with_Real_ylm( l_in, MatU_ylm_RC, &
       &                                   Mat_L_with_cmplx_ylm, &
       &                                   Mat_L_with_real_ylm )
    integer, intent(in) :: l_in
    Complex(kind=CMPLDP), intent(in) :: MatU_ylm_RC( 2*l_in+1, -l_in:l_in )
    complex(kind=CMPLDP), intent(in) :: &
         &    Mat_L_with_cmplx_ylm( -l_in:l_in, -l_in:l_in, 3 )
    complex(kind=CMPLDP), intent(out) :: &
         &    Mat_L_with_real_ylm( 2*l_in+1, 2*l_in+1, 3 )

    integer :: m_min, m_max
    !
    integer :: ixyz
    integer :: m1, m2, ma, mb
!
    Complex(kind=CMPLDP) :: ztmp( 3 )
!
    m_min = -l_in;  m_max = l_in
!
    Do m1=1, 2 *l_in +1
       Do m2=1, 2 *l_in +1

          ztmp = 0.0d0

          Do ma = m_min, m_max
             Do mb = m_min, m_max
                Do ixyz=1, 3
#if 1
                   ztmp(ixyz) = ztmp(ixyz) + conjg(MatU_ylm_RC( m1,ma ))&
                        &                *Mat_L_with_cmplx_ylm( ma,mb,ixyz ) &
                        &                *( MatU_ylm_RC( m2,mb ) )
#else
!                   ztmp(is) = ztmp(is) + MatU_ylm_RC( m1,ma )&
!                        &                *Mat_LS_with_cmplx_ylm( ma,mb,is ) &
!                        &                *conjg( MatU_ylm_RC( m2,mb ) )
#endif

                End do
             End do
          End do
          Mat_L_with_real_ylm( m1,m2,: ) = ztmp(:)
       End do
    End do
  end subroutine m_OP_calc_MatL_with_Real_ylm

  subroutine m_OP_calc_MatL_with_Cmplx_ylm( l_in, theta, phi, Mat_L_term )
    integer, intent(in) :: l_in
    real(kind=DP), intent(in) :: theta, phi
    complex(kind=CMPLDP), intent(out) :: &
         &          Mat_L_term( -l_in:l_in, -l_in:l_in, 3 )

    real(kind=DP) :: cos_th, sin_th, cos2_th_h, sin2_th_h
    real(kind=DP) :: ctmp_m, ctmp_p, ctmp_0

    integer :: m1, m2

    Do m1=-l_in, l_in
       Do m2=-l_in, l_in

          if ( m2 == m1 +1 ) then
             ctmp_m = sqrt( (l_in +m1 +1.0d0) *( l_in -m1 ) )
          else
             ctmp_m = 0.0d0
          endif

          if ( m2 == m1 -1 ) then
             ctmp_p = sqrt( (l_in -m1 +1.0d0) *( l_in +m1 ) )
          else
            ctmp_p = 0.0d0
          endif
          !
          if ( m1 == m2 ) then
             ctmp_0 = dble(m1)
          else
             ctmp_0 = 0.0d0
          endif

          Mat_L_term( m1,m2,1 ) =  ( ctmp_p +ctmp_m ) /2.0d0
          Mat_L_term( m1,m2,2 ) =  ( ctmp_p -ctmp_m ) /2.0d0 /zi
          Mat_L_term( m1,m2,3 ) =  ctmp_0

       End do
    End Do

  end subroutine m_OP_calc_MatL_with_Cmplx_ylm

end module m_OP_Moment

!=======================================================================
!
!  PROGRAM  PHASE/0 2014.01 (rev.375)
!
!  "First-principles Electronic Structure Calculation Program"
!
!  AUTHOR(S): K. Tagami
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!   The original version of this set of the computer programs "PHASE" was developed by 
!  the members of the Theory Group of Joint Research Center for Atom Technology 
!  (JRCAT), based in Tsukuba, in the period 1993-2001.  
!   Since 2002, this program set had been intensively developed as a part of the following 
!  national projects supported by the Ministry of Education, Culture, Sports, Science and 
!  Technology (MEXT) of Japan; "Frontier Simulation Software for Industrial Science 
!  (FSIS)" from 2002 to 2005, "Revolutionary Simulation Software (RSS21)" from 2006 to 
!  2008. "Research and Development of Innovative Simulation Software (RISS)" from 2008 
!  to 2013. These projects is lead by the Center for Research on Innovative Simulation 
!  Software (CISS), the Institute of Industrial Science (IIS), the University of Tokyo.
!   Since 2013, this program set has been further developed centering on PHASE System 
!  Consortium. 
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
module m_CD_Mag_Moment
! $Id: m_CD_Mag_Moment.f90 266 2012-11-25 11:54:22Z ktagami $
  use m_Control_Parameters,    only : noncol, ndim_magmom, kimg, iprimagmom
  use m_Const_Parameters,     only : DP, PAI4, Bohr

  use m_Ionic_System,         only : ntyp, natm, ityp, pos, cps, &
       &                             magmom_local_now, iatomn
  use m_Crystal_Structure,    only : rltv, altv

  use m_PlaneWaveBasisSet,    only : ngabc, kgp
  use m_Parallelization,      only : ista_kngp, iend_kngp, ierr, npes, mype, &
       &                             mpi_comm_group
  use m_PseudoPotential,      only : dl2p, ilmt

  use m_Charge_Density,       only : chgq_l, hsr

  use m_Files,                only : nfout

  implicit none

  include 'mpif.h'
!  integer istatus(mpi_status_size)

  real(kind=DP), allocatable :: rad_cov(:)
  real(kind=DP), allocatable :: RhoMag_on_atom(:,:)

contains
  
  subroutine m_CD_alloc_rad_cov
    allocate( rad_cov(ntyp) ); rad_cov = 0.0d0
  end subroutine m_CD_alloc_rad_cov

  subroutine m_CD_set_rad_cov_default
    integer :: it, inum
    real(kind=DP) :: rad_cov_default(120)

! -------------------
!  Ref. "Molecular Single-Bond Covalent Radii for Elements 1-118". 
!        Chemistry: A European Journal 15 (2009) 186.
! -------------------

    call set_table_rad_cov(   1,  32,  46, 133, 102,  85,  75,  71,  63,  64,  67 )
    call set_table_rad_cov(  11, 155, 139, 126, 116, 111, 103,  99,  96, 196, 171 )
    call set_table_rad_cov(  21, 148, 136, 134, 122, 119, 116, 111, 110, 112, 118 )
    call set_table_rad_cov(  31, 124, 124, 121, 116, 114, 117, 210, 185, 163, 154 )
    call set_table_rad_cov(  41, 147, 138, 128, 125, 125, 120, 128, 136, 142, 140 )
    call set_table_rad_cov(  51, 140, 136, 133, 131, 232, 196, 180, 163, 176, 174 )
    call set_table_rad_cov(  61, 173, 172, 168, 169, 168, 167, 166, 165, 164, 170 )
    call set_table_rad_cov(  71, 162, 152, 146, 137, 131, 129, 122, 123, 124, 133 )
    call set_table_rad_cov(  81, 144, 144, 151, 145, 147, 142, 223, 201, 186, 175 )
    call set_table_rad_cov(  91, 169, 170, 171, 172, 166, 166, 166, 168, 165, 167 )
    call set_table_rad_cov( 101, 173, 176, 161, 157, 149, 143, 141, 134, 129, 128 )
    call set_table_rad_cov( 111, 121, 122, 136, 143, 162, 175, 165, 157, 500, 500 )

    call convert_unit_to_bohr

    Do it=1, ntyp
       inum = iatomn(it)
       rad_cov(it) = rad_cov_default(inum)
    End do

  contains

    subroutine convert_unit_to_bohr
      rad_cov_default = rad_cov_default / 1.0D2 / Bohr  
                                 ! Note : original data is in the unit of pm.
    end subroutine convert_unit_to_bohr

    subroutine set_table_rad_cov( istart, d1, d2, d3, d4, d5, d6, d7, d8, d9, d10 )
      integer, intent(in) :: istart
      integer, intent(in) :: d1, d2, d3, d4, d5, d6, d7, d8, d9, d10

      rad_cov_default( istart    ) = dble(d1)
      rad_cov_default( istart +1 ) = dble(d2)
      rad_cov_default( istart +2 ) = dble(d3)
      rad_cov_default( istart +3 ) = dble(d4)
      rad_cov_default( istart +4 ) = dble(d5)
      rad_cov_default( istart +5 ) = dble(d6)
      rad_cov_default( istart +6 ) = dble(d7)
      rad_cov_default( istart +7 ) = dble(d8)
      rad_cov_default( istart +8 ) = dble(d9)
      rad_cov_default( istart +9 ) = dble(d10)
    end subroutine set_table_rad_cov

  end subroutine m_CD_set_rad_cov_default

  subroutine m_CD_alloc_RhoMag_on_atom
    allocate( RhoMag_on_atom(natm,ndim_magmom) ); RhoMag_on_atom = 0.0d0
  end subroutine m_CD_alloc_RhoMag_on_atom

  subroutine m_CD_set_rad_cov_now
    integer :: ia, ja, it1, it2
    integer :: nx, ny, nz

    real(kind=DP) :: x1, y1, z1, dist
    real(kind=DP) :: c1, ctmp
    real(kind=DP), allocatable :: dist_min_among_atomtypes(:,:)

    allocate( dist_min_among_atomtypes(ntyp,ntyp) )
    dist_min_among_atomtypes = 10.0d0

    Do ia=1, natm-1
       it1 = ityp(ia)
       Do ja =ia+1, natm
          it2 = ityp(ja)
!
          Do nx=-1, 1
             Do ny=-1, 1
                Do nz=-1, 1
                   x1 = cps(ja,1) -cps(ia,1) +altv(1,1)*nx +altv(1,2)*ny +altv(1,3)*nz
                   y1 = cps(ja,2) -cps(ia,2) +altv(2,1)*nx +altv(2,2)*ny +altv(2,3)*nz
                   z1 = cps(ja,3) -cps(ia,3) +altv(3,1)*nx +altv(3,2)*ny +altv(3,3)*nz
!
                   dist = sqrt( x1**2 +y1**2 +z1**2 )
                   if ( dist < dist_min_among_atomtypes(it1,it2) ) then
                      dist_min_among_atomtypes(it1,it2) = dist
                   endif
                End do
             End do
          End do
       End do
    End Do

    Do it1=1, ntyp
       Do it2=1, ntyp
          c1 = rad_cov(it1) + rad_cov(it2)
          if ( dist_min_among_atomtypes(it1,it2) < c1 ) then
             ctmp = dist_min_among_atomtypes(it1,it2) /c1
             rad_cov(it1) = rad_cov(it1) *ctmp
             rad_cov(it2) = rad_cov(it2) *ctmp
          endif
       End do
    End Do

    if ( iprimagmom >= 3 ) then
       write(nfout,*) '! ------ info : Rad_cov ------ '
       write(nfout,*) '  atmo no.   rad_cov '
       Do ia=1, natm
          it1 = ityp(ia)
          write(nfout,'(I7,F15.8)')   ia, rad_cov(it1)
       End do
       write(nfout,*) '! ---------------------------- '
    endif

  end subroutine m_CD_set_rad_cov_now

  subroutine m_CD_calc_ChgMagMom_in_sphere
    integer :: i, ia, is, it, ist
    real(kind=DP) :: rad1, fac1r, fac1i, fac2
    real(kind=DP) :: VecG(3), normG, normG3, gr, d1

    real(kind=DP), allocatable :: zfcos(:), zfsin(:)
    real(kind=DP), allocatable :: RhoMag_on_atom_mpi(:,:)

    RhoMag_on_atom = 0.0d0

    allocate(zfcos(ista_kngp:iend_kngp)); zfcos = 0.d0
    allocate(zfsin(ista_kngp:iend_kngp)); zfsin = 0.d0

    Do ia=1, natm
       it = ityp(ia)
       rad1 = rad_cov(it)

       call calc_phase2( natm, pos, ia, kgp, ngabc, ista_kngp, iend_kngp, &
            &            zfcos, zfsin )

       if ( ista_kngp == 1 ) then
          ist = 2
       else
          ist = ista_kngp
       endif

       Do i=ist, iend_kngp

          VecG(1) = rltv(1,1)*ngabc(i,1) +rltv(1,2)*ngabc(i,2) +rltv(1,3)*ngabc(i,3)
          VecG(2) = rltv(2,1)*ngabc(i,1) +rltv(2,2)*ngabc(i,2) +rltv(2,3)*ngabc(i,3)
          VecG(3) = rltv(3,1)*ngabc(i,1) +rltv(3,2)*ngabc(i,2) +rltv(3,3)*ngabc(i,3)
          
          normG = sqrt( VecG(1)**2 +VecG(2)**2 +VecG(3)**2 )
          normG3 = normG**3

          fac1r = zfcos(i); fac1i = zfsin(i)
!
          gr = normG *rad1
          fac2 = -gr *cos(gr) + sin(gr)
          fac2 = fac2 *PAI4 /normG3
!
          Do is=1, ndim_magmom
             d1 = chgq_l(i,1,is)*fac1r -chgq_l(i,kimg,is)*fac1i
             RhoMag_on_atom(ia,is) = RhoMag_on_atom(ia,is) + d1 *fac2
          End do

       End do

       if ( mype == 0 ) then
          fac2 = PAI4 /3.0d0 *rad1**3
             
          Do is=1, ndim_magmom
             d1 = chgq_l(1,1,is)
             RhoMag_on_atom(ia,is) = RhoMag_on_atom(ia,is) + d1 *fac2
          End do
       endif
       
    End Do
!
    deallocate( zfcos, zfsin )

    if ( npes > 1 ) then
       allocate( RhoMag_on_atom_mpi(natm,ndim_magmom) ); RhoMag_on_atom_mpi = 0.0d0
       call mpi_allreduce( RhoMag_on_atom, RhoMag_on_atom_mpi, natm*ndim_magmom, &
            &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
       RhoMag_on_atom = RhoMag_on_atom_mpi
       deallocate( RhoMag_on_atom_mpi )
    endif
    
  end subroutine m_CD_calc_ChgMagMom_in_sphere

  subroutine m_CD_print_ChgMagmom_on_atom( nfout )
    integer, intent(in) :: nfout

    integer :: ia, it

    if ( iprimagmom < 2 ) return

    write(nfout,*) &
         & '! ------------ Local Magnetic Momemnt (soft+hard) at this scf step --- '
    write(nfout,*) &
         & '!   id   atom no.        tot            mx             my             mz'
    
    Do ia=1, natm
       it = ityp(ia)
       write(nfout,'(I7,F10.4,4F15.8)') ia, iatomn(it), &
            &                          RhoMag_on_atom(ia,1), &
            &                          RhoMag_on_atom(ia,2), &
            &                          RhoMag_on_atom(ia,3), &
            &                          RhoMag_on_atom(ia,4)
    End Do
    write(nfout,*) '! ---------------------------------------------'

  end subroutine m_CD_print_ChgMagmom_on_atom

! ------------------------------------------
  subroutine m_CD_estim_magmom_local( nfout )
    integer, intent(in) :: nfout

    integer :: ia, it, lmt1, lmt2, is
    real(kind=DP) :: sum, fac

!--
    Do ia=1, natm
       it = ityp(ia)

       Do is=2, ndim_magmom
          sum = 0.0d0
          Do lmt1=1, ilmt(it)
             Do lmt2=lmt1, ilmt(it)
                fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0
                sum = sum + fac *hsr( ia, lmt1, lmt2, is )*dl2p(lmt1,lmt2,1,it)
             End do
          End do
!
          magmom_local_now(ia,is-1) = sum
       End do
    End Do

  end subroutine m_CD_estim_magmom_local

  subroutine m_CD_print_magmom_local( nfout )
    integer, intent(in) :: nfout

    integer :: ia, it

    if ( iprimagmom < 3 ) return

    write(nfout,*) &
         & '! ------------ Local Magnetic Momemnt ( hard part ) at this scf step --- '
    write(nfout,*) '!   id   atom no.        mx             my             mz  '
    Do ia=1, natm
       it = ityp(ia)
       write(nfout,'(I7,F10.4,3F15.8)') ia, iatomn(it), &
            &                         magmom_local_now(ia,1), &
            &                         magmom_local_now(ia,2), &
            &                         magmom_local_now(ia,3)
    End Do
    write(nfout,*) '! ---------------------------------------------'

  end subroutine m_CD_print_magmom_local

end module m_CD_Mag_Moment

!=======================================================================
!
!  PROGRAM  PHASE/0 2014.01 (rev.375)
!
!  "First-principles Electronic Structure Calculation Program"
!
!  MAIN PROGRAM: CPMD
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!   Since 2002, this program set had been intensively developed as a part of the following 
!  national projects supported by the Ministry of Education, Culture, Sports, Science and 
!  Technology (MEXT) of Japan; "Frontier Simulation Software for Industrial Science 
!  (FSIS)" from 2002 to 2005, "Revolutionary Simulation Software (RSS21)" from 2006 to 
!  2008. "Research and Development of Innovative Simulation Software (RISS)" from 2008 
!  to 2013. These projects is lead by the Center for Research on Innovative Simulation 
!  Software (CISS), the Institute of Industrial Science (IIS), the University of Tokyo.
!   Since 2013, this program set has been further developed centering on PHASE System 
!  Consortium. 
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
program CPMD
! $Id: mdepmain.f90 334 2013-07-18 14:15:28Z yamasaki $
  implicit none
  logical  :: Forces_are_Converged, Ending_Time, MultiReplicaMode &
       &     ,AllForces_are_Converged

  call Initialization
  call InputData_Analysis
  MultiReplica: do
     call Preparation_ep
     call Initial_MD_Condition

     AtomicConfiguration: do
        call Forces
        if(Forces_are_Converged()) exit AtomicConfiguration
        call Move_Ions
        if(Ending_Time())          exit AtomicConfiguration
        call MDIterationNumber_Setting_ep
     enddo AtomicConfiguration

     call WriteDownData_onto_Files

     if(.not.MultiReplicaMode()) then
        exit MultiReplica
     else if( Ending_Time() .or. AllForces_are_Converged()) then
        exit MultiReplica
     end if

  end do MultiReplica

end program CPMD

!=======================================================================
!
!  PROGRAM  PHASE/0 2014.01 (rev.375)
!
!  "First-principles Electronic Structure Calculation Program"
!
!  SUBROUINE: dxml_fft, mulfac
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!   Since 2002, this program set had been intensively developed as a part of the following 
!  national projects supported by the Ministry of Education, Culture, Sports, Science and 
!  Technology (MEXT) of Japan; "Frontier Simulation Software for Industrial Science 
!  (FSIS)" from 2002 to 2005, "Revolutionary Simulation Software (RSS21)" from 2006 to 
!  2008. "Research and Development of Innovative Simulation Software (RISS)" from 2008 
!  to 2013. These projects is lead by the Center for Research on Innovative Simulation 
!  Software (CISS), the Institute of Industrial Science (IIS), the University of Tokyo.
!   Since 2013, this program set has been further developed centering on PHASE System 
!  Consortium. 
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
      subroutine dxml_fft(iop,id,nl,nm,nn,afft)
c $Id: dxmlfft.f 238 2012-11-12 04:11:13Z yamasaki $
      implicit real*8(a-h,o-z)
      include '/usr/include/DXMLDEF.FOR'
      real*8 afft(*)
      record /DXML_d_fft_structure_3D/ fft_struct_cd,fft_struct_wd
      record /DXML_z_fft_structure_3D/ fft_struct_cz,fft_struct_wz
      save fft_struct_cd,fft_struct_wd
      save fft_struct_cz,fft_struct_wz
      save nfft_cd,nfft_cz,nfft_wd,nfft_wz
      save nbox_cd,nbox_cz,nbox_wd,nbox_wz
c
c     IOP=1..DIRECT, IOP=2..INVERSE (REAL TRANSFORM)
c     IOP=1..INVERSE, IOP=2..DIRECT (COMPLEX TRANSFORM)
c
      entry cd_fft(iop,id,nm,afft)
        if(iop.eq.1) then
          call dfft_apply_3d('r','c','f',afft,afft,id,nm,
     $                        fft_struct_cd,1,1,1)
        else
          call dfft_apply_3d('c','r','b',afft,afft,id,nm,
     $                        fft_struct_cd,1,1,1)
c         scale=nfft_cd
c         call dscal(nbox_cd,scale,afft,1)
          call mulfac(afft,nbox_cd,nfft_cd)
        endif
      return
c
      entry cz_fft(iop,id,nm,afft)
        if(iop.eq.1) then
          call zfft_apply_3d('c','c','b',afft,afft,id,nm,
     $                        fft_struct_cz,1,1,1)
c         scale=nfft_cz
c         call dscal(nbox_cz,scale,afft,1)
          call mulfac(afft,nbox_cz,nfft_cz)
        else
          call zfft_apply_3d('c','c','f',afft,afft,id,nm,
     $                        fft_struct_cz,1,1,1)
        endif
      return
c
      entry wd_fft(iop,id,nm,afft)
        if(iop.eq.1) then
          call dfft_apply_3d('r','c','f',afft,afft,id,nm,
     $                        fft_struct_wd,1,1,1)
        else
          call dfft_apply_3d('c','r','b',afft,afft,id,nm,
     $                        fft_struct_wd,1,1,1)
c         scale=nfft_wd
c         call dscal(nbox_wd,scale,afft,1)
          call mulfac(afft,nbox_wd,nfft_wd)
        endif
      return
c
      entry wz_fft(iop,id,nm,afft)
        if(iop.eq.1) then
          call zfft_apply_3d('c','c','b',afft,afft,id,nm,
     $                        fft_struct_wz,1,1,1)
c         scale=nfft_wz
c         call dscal(nbox_wz,scale,afft,1)
          call mulfac(afft,nbox_wz,nfft_wz)
        else
          call zfft_apply_3d('c','c','f',afft,afft,id,nm,
     $                        fft_struct_wz,1,1,1)
        endif
      return
          
      entry cd_init(id,nl,nm,nn)
        call dfft_init_3d(nl,nm,nn,fft_struct_cd,.true.)
        nbox_cd=id*nm*nn
        nfft_cd=nl*nm*nn
        return
      entry cz_init(id,nl,nm,nn)
        call zfft_init_3d(nl,nm,nn,fft_struct_cz,.true.)
        nbox_cz=id*nm*nn*2
        nfft_cz=nl*nm*nn*2
        return
      entry wd_init(id,nl,nm,nn)
        call dfft_init_3d(nl,nm,nn,fft_struct_wd,.true.)
        nbox_wd=id*nm*nn
        nfft_wd=nl*nm*nn
        return
      entry wz_init(id,nl,nm,nn)
        call zfft_init_3d(nl,nm,nn,fft_struct_wz,.true.)
        nbox_wz=id*nm*nn*2
        nfft_wz=nl*nm*nn*2
        return
      end
      subroutine mulfac(afft,nbox,nfft)
      implicit real*8(a-h,o-z)
      dimension afft(nbox)
      scale=dble(nfft)
      do i=1,nbox
        afft(i)=afft(i)*scale
      enddo
      return
      end

!=======================================================================
!
!  PROGRAM  PHASE/0 2014.01 (rev.375)
!
!  "First-principles Electronic Structure Calculation Program"
!
!  MODULE: m_ES_IO
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!   The original version of this set of the computer programs "PHASE" was developed by 
!  the members of the Theory Group of Joint Research Center for Atom Technology 
!  (JRCAT), based in Tsukuba, in the period 1993-2001.  
!   Since 2002, this program set had been intensively developed as a part of the following 
!  national projects supported by the Ministry of Education, Culture, Sports, Science and 
!  Technology (MEXT) of Japan; "Frontier Simulation Software for Industrial Science 
!  (FSIS)" from 2002 to 2005, "Revolutionary Simulation Software (RSS21)" from 2006 to 
!  2008. "Research and Development of Innovative Simulation Software (RISS)" from 2008 
!  to 2013. These projects is lead by the Center for Research on Innovative Simulation 
!  Software (CISS), the Institute of Industrial Science (IIS), the University of Tokyo.
!   Since 2013, this program set has been further developed centering on PHASE System 
!  Consortium. 
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
module m_ES_IO
! $Id: m_ES_IO.F90 324 2013-06-24 11:32:23Z yamasaki $
  use m_Electronic_Structure, only : zaj_l,neordr,nrvf_ordr,eko_l,occup_l,efermi,efermi_spin,totch&
       &                            ,vnlph_l,vlhxc_l,eko_ek
  use m_Electronic_Structure, only : m_ES_WF_in_Rspace
  use m_PlaneWaveBasisSet,    only : kgp,kg1,ngabc,nbase,iba
  use m_Kpoints,              only : kv3, vkxyz, vkxyz_ek, kv3_ek, k_symmetry, qwgt
  use m_Timing,               only : tstatc0_begin, tstatc0_end
  use m_Control_Parameters,   only : nspin,kimg,neg,num_extra_bands,af,ipri, printable, neg_previous &
       &                           , wf_filetype, wf_title, eigmin_wf, eigmax_wf, ekmode, neg_is_enlarged &
       &                           , icond, fixed_charge_k_parallel, sw_ekzaj, numk_zajsaved, Nw_Psicoef
  use m_Const_parameters,     only : DP, SP, CMPLDP, BUCS, OFF, YES, EK, SCF, DENSITY_ONLY &
       &                           , CUBE, VTK, BINARY, GAMMA, GAMMA_base_symmetrization, ONE_BY_ONE &
       &                           , FIXED_CHARGE, FIXED_CHARGE_CONTINUATION, DELTA &
       &                           , EFERMI_VICINITY, ALL_VALUES, GRID, ON
  use m_Parallelization,      only : mpi_comm_group,mpi_k_world,is_kngp,ie_kngp,npes,mype,ierr,map_k &
       &                           , map_ek,ista_e,iend_e,istep_e,map_z, np_e &
       &                           , ista_k,iend_k,myrank_e,myrank_k,map_e,nrank_e &
       &                           , ista_kngp,iend_kngp, nrank_k  &
       &                           , ista_g1k,iend_g1k, np_g1k , myrank_g, nrank_g
  use m_IterationNumbers,     only : nk_in_the_process, nk_converged, nkgroup &
       &                           , first_kpoint_in_this_job, iteration_ionic, iteration_electronic
  use m_FFT,                  only : fft_box_size_WF,nfft
  use m_Crystal_Structure,    only : altv, sw_fix_total_spin
  use m_Ionic_System,         only : natm,natm2,iatomn,m_IS_pack_all_ions_in_uc
  use m_PseudoPotential,      only : ival
  use m_Crystal_Structure,    only : univol

! ===================================== added by K. Tagami ============= 11.0
  use m_Control_Parameters,    only : ndim_spinor, noncol, &
       &                              previous_nspin_collinear, &
       &                              previous_nband_collinear
! ====================================================================== 11.0
  use m_ErrorMessages,        only : EOF_REACHED

  implicit none
  include 'mpif.h'

  integer istatus(mpi_status_size)

  real(kind=SP), allocatable, dimension(:,:)  :: wf_l   ! work wave functions

!   3. m_ESIO_rd_EigenValues_etc    <-(Initial_Electronic_Structure)
!   4. m_ESIO_wd_EigenValues_etc    <-(WriteDownData_onto_Files)
!   x. m_ESIO_wd_EigenValues        <-(WriteDownData_onto_Files)
!   x. m_ESIO_wd_EigenValues_ek     <-(WriteDownData_onto_Files_ek)
!   x. m_ESIO_wd_vlhxc              <-(WriteDownData_onto_Files)
!  59. m_ESIO_rd_WFs                <-(Initial_Electronic_Structure)
!  60. m_ESIO_wd_WFs                <-(WriteDownData_onto_Files)
!  22. wd_vnlph_l_small_portion

contains
  subroutine m_ESIO_rd_EigenValues_etc(nfout,nfcntn_bin,F_CNTN_BIN_partitioned)
    integer, intent(in) :: nfout, nfcntn_bin
    logical, intent(in) :: F_CNTN_BIN_partitioned
    integer  :: ik, ie
    integer, allocatable, dimension(:,:) :: n1_wk, n2_wk  ! MPI
    real(DP),allocatable, dimension(:,:) :: e1_wk, e2_wk  ! MPI
!!$    read(nfcntn_bin) neordr,nrvf_ordr,eko_l,occup_l,efermi,totch

    if(F_CNTN_BIN_partitioned) then
       if(neg_previous /= neg) then
          write(nfout,'(" !! neg_previous /= neg <<m_ESIO_rd_EigenValues_etc>>")')
          write(nfout,'(" !! neg_prevous = ",i8)') neg_previous
          write(nfout,'(" !! neg         = ",i8)') neg
          write(nfout,'(" neg_previous sould be neg when F_CNTN_BIN_in_partitioned is true")')
          stop ' neg_previous sould be neg when F_CNTN_BIN_in_partitioned is true'
       end if
       allocate(n1_wk(neg,iend_k-ista_k+1), n2_wk(neg,iend_k-ista_k+1))
       allocate(e1_wk(np_e,iend_k-ista_k+1),e2_wk(np_e,iend_k-ista_k+1))
       n1_wk = 0; n2_wk = 0
       e1_wk = 0; e2_wk = 0
       ! -- neordr, nrvf_ordr --
       read(nfcntn_bin) n1_wk
       read(nfcntn_bin) n2_wk
       do ik = ista_k, iend_k
          neordr(1:neg,ik) = n1_wk(1:neg,ik-ista_k+1)
          nrvf_ordr(1:neg,ik) = n2_wk(1:neg,ik-ista_k+1)
       end do
       ! -- eko_l, occup_l --
       read(nfcntn_bin) e1_wk
       read(nfcntn_bin) e2_wk
       do ik = ista_k, iend_k
          do ie = ista_e, iend_e
             eko_l(map_z(ie),ik) = e1_wk(ie-ista_e+1,ik-ista_k+1)
             occup_l(map_z(ie),ik) = e2_wk(ie-ista_e+1,ik-ista_k+1)
          end do
       end do
       deallocate(e2_wk,e1_wk,n2_wk,n1_wk)
       ! -- nfermi, totch --
       read(nfcntn_bin) efermi, totch
    else
       allocate(n1_wk(neg_previous,kv3),n2_wk(neg_previous,kv3)) ! MPI
       allocate(e1_wk(neg_previous,kv3),e2_wk(neg_previous,kv3)) ! MPI
       n1_wk = 0; n2_wk = 0
       e1_wk = 0; e2_wk = 0

       ! -- neordr, nrvf_ordr --
       if(mype == 0) read(nfcntn_bin) n1_wk                ! MPI
       if(mype == 0) read(nfcntn_bin) n2_wk                ! MPI
       if(npes > 1) then
          call mpi_bcast(n1_wk,neg_previous*kv3,mpi_integer,0,mpi_comm_group,ierr) ! MPI
          call mpi_bcast(n2_wk,neg_previous*kv3,mpi_integer,0,mpi_comm_group,ierr) ! MPI
       endif
       do ik = ista_k, iend_k                              ! MPI
          neordr(1:neg_previous,ik) = n1_wk(1:neg_previous,ik)
          nrvf_ordr(1:neg_previous,ik) = n2_wk(1:neg_previous,ik)
          if(neg_previous < neg) then
             do ie = neg_previous+1, neg
                neordr(ie,ik) = ie
                nrvf_ordr(ie,ik) = ie
             end do
          end if
       end do                                              ! MPI

       ! -- eko_l, occup_l --
       if(mype == 0) read(nfcntn_bin) e1_wk                ! MPI
       if(mype == 0) read(nfcntn_bin) e2_wk                ! MPI
       if(npes > 1) then
          call mpi_bcast(e1_wk,neg_previous*kv3,mpi_double_precision,0,mpi_comm_group,ierr) ! MPI
          call mpi_bcast(e2_wk,neg_previous*kv3,mpi_double_precision,0,mpi_comm_group,ierr)! MPI
       end if
       do ik = ista_k, iend_k                              ! MPI
          do ie = 1, neg_previous                          ! MPI
             if(map_e(ie) == myrank_e) then                ! MPI
                eko_l(map_z(ie),ik) = e1_wk(ie,ik)         ! MPI
                occup_l(map_z(ie),ik) = e2_wk(ie,ik)       ! MPI
             end if
          end do                                           ! MPI
          if(neg_previous < neg) then
             do ie = neg_previous+1, neg
                if(map_e(ie) == myrank_e) then
                   eko_l(map_z(ie),ik) = 1.d+15
                   occup_l(map_z(ie),ik) = 0.d0
                end if
            end do           
          end if
       end do                                              ! MPI

       ! -- nfermi, totch --
       if(mype == 0) read(nfcntn_bin) efermi, totch        ! MPI
       if(npes > 1) then
          call mpi_bcast(efermi,1,mpi_double_precision,0,mpi_comm_group,ierr) ! MPI
          call mpi_bcast(totch,1, mpi_double_precision,0,mpi_comm_group,ierr) ! MPI
       end if

       deallocate(e2_wk,e1_wk,n2_wk,n1_wk)
    end if

    if(printable) write(nfout,'(" TOTCH (total charge) = ",f12.6 &
         & ," (= ",8d25.12,") at m_ESIO_rd_EigenValues_etc")') totch,totch

  end subroutine m_ESIO_rd_EigenValues_etc

  subroutine m_ESIO_wd_EigenValues_etc(nfcntn_bin,F_CNTN_BIN_partitioned,totch_flag)

    integer, intent(in) :: nfcntn_bin
    logical, intent(in) :: F_CNTN_BIN_partitioned
    integer, optional, intent(in) :: totch_flag

    integer  :: ik, ie
    integer, allocatable, dimension(:,:) :: n_wk, n2_mpi  ! MPI
    real(DP),allocatable, dimension(:,:) :: e_wk, e2_mpi  ! MPI
    integer  :: id_sname = -1
    call tstatc0_begin('m_ESIO_wd_EigenValues_etc ',id_sname)

!!$    write(nfcntn_bin) neordr,nrvf_ordr,eko_l,occup_l,efermi,totch

    if(F_CNTN_BIN_partitioned) then
       allocate(n_wk(neg,iend_k-ista_k+1))
       allocate(e_wk(np_e,iend_k-ista_k+1))
!!$       allocate(e_wk(neg,iend_k-ista_k+1)); allocate(e2_mpi(neg,iend_k-ista_k+1))
       n_wk = 0; e_wk = 0
       !  -- neordr --
       do ik = ista_k, iend_k
          n_wk(1:neg,ik-ista_k+1) = neordr(1:neg,ik)
       end do
       write(nfcntn_bin) n_wk

       !  -- nrvf_ordr --
       do ik = ista_k, iend_k
          n_wk(1:neg,ik-ista_k+1) = nrvf_ordr(1:neg,ik)
       end do
       write(nfcntn_bin) n_wk

       !  -- eko_l --
       e_wk = 0.d0
       do ik = ista_k, iend_k
          do ie = ista_e, iend_e
             e_wk(ie-ista_e+1,ik-ista_k+1) = eko_l(map_z(ie),ik)
!!$             e_wk(ie,ik-ista_k+1) = eko_l(map_z(ie),ik)
          end do
       end do
       write(nfcntn_bin) e_wk
!!$       if(npes >= 2) then
!!$          call mpi_allreduce(e_wk,e2_mpi,neg*(iend_k-ista_k+1),mpi_double_precision &
!!$               &               , mpi_sum, mpi_k_world)
!!$       else
!!$          e2_mpi = e_wk
!!$       end if
!!$       write(nfcntn_bin) e2_mpi

       !  -- occup_l --
       e_wk = 0.d0
       do ik = ista_k, iend_k
          do ie = ista_e, iend_e, istep_e
             e_wk(ie-ista_e+1,ik-ista_k+1) = occup_l(map_z(ie),ik)
!!$             e_wk(ie,ik-ista_k+1) = occup_l(map_z(ie),ik)
          end do
       end do
       write(nfcntn_bin) e_wk
!!$       if(npes >= 2) then
!!$          call mpi_allreduce(e_wk,e2_mpi,neg*(iend_k-ista_k+1),mpi_double_precision &
!!$               &               , mpi_sum, mpi_k_world)
!!$       else
!!$          e2_mpi = e_wk
!!$       end if
!!$       write(nfcntn_bin) e2_mpi
!!$       deallocate(e2_mpi, e_wk, n_wk)
       deallocate(e_wk, n_wk)

       if(totch_flag == OFF) then
          write(nfcntn_bin) efermi                     ! MPI
       else
          write(nfcntn_bin) efermi,totch               ! MPI
       end if
    else
       allocate(n_wk(neg,kv3)); allocate(n2_mpi(neg,kv3))! MPI
       allocate(e_wk(neg,kv3)); allocate(e2_mpi(neg,kv3))! MPI
       n_wk = 0; n2_mpi = 0
       e_wk = 0; e2_mpi = 0
       !  -- neordr --
       n_wk = 0                                          ! MPI
       do ik = 1, kv3                                     ! MPI
          if(map_k(ik) /= myrank_k) cycle                 ! MPI
          n_wk(1:neg,ik) = neordr(1:neg,ik)               ! MPI
       end do                                             ! MPI
       if(npes >= 2) then
          call mpi_allreduce(n_wk,n2_mpi,neg*kv3,mpi_integer,mpi_sum &
               &                      ,mpi_comm_group,ierr)  ! MPI
          n2_mpi = n2_mpi/nrank_e
       else
          n2_mpi = n_wk
       end if
       if(mype == 0) write(nfcntn_bin) n2_mpi             ! MPI ; writing (neordr)

       !  -- nrvf_ordr --
       n_wk = 0                                           ! MPI
       do ik = 1, kv3                                     ! MPI
          if(map_k(ik) /= myrank_k) cycle                 ! MPI
          n_wk(1:neg,ik) = nrvf_ordr(1:neg,ik)            ! MPI
       end do                                             ! MPI
       if(npes >= 2) then
          call mpi_allreduce(n_wk,n2_mpi,neg*kv3,mpi_integer,mpi_sum &
               &                      ,mpi_comm_group,ierr)  ! MPI
          n2_mpi = n2_mpi/nrank_e
       else
          n2_mpi = n_wk
       end if
       if(mype == 0) write(nfcntn_bin) n2_mpi             ! MPI ; writing (nrvf_ordr)

       !  -- eko_l --
       e_wk = 0.d0                                        ! MPI
       do ik = 1, kv3                                     ! MPI
          if(map_k(ik) /= myrank_k) cycle                 ! MPI
          do ie = 1, neg                                  ! MPI
             if(map_e(ie) /= myrank_e) cycle              ! MPI
             e_wk(ie,ik) = eko_l(map_z(ie),ik)            ! MPI
          end do
       end do
       if(npes >= 2) then
          call mpi_allreduce(e_wk,e2_mpi,neg*kv3,mpi_double_precision &
               &               ,mpi_sum,mpi_comm_group,ierr) ! MPI
       else
          e2_mpi = e_wk
       end if
       if(mype == 0) write(nfcntn_bin) e2_mpi             ! MPI ; writing (eko_l)

       !  -- occup_l --
       e_wk = 0.d0                                        ! MPI
       do ik = 1, kv3                                     ! MPI
          if(map_k(ik) /= myrank_k) cycle                 ! MPI
          do ie = 1, neg                                  ! MPI
             if(map_e(ie) /= myrank_e) cycle              ! MPI
             e_wk(ie,ik) = occup_l(map_z(ie),ik)          ! MPI
          end do                                            ! MPI
       end do                                               ! MPI
       if(npes >= 2) then
          call mpi_allreduce(e_wk,e2_mpi,neg*kv3,mpi_double_precision &
               &                  ,mpi_sum,mpi_comm_group,ierr) ! MPI
       else
          e2_mpi = e_wk
       end if
       if(mype == 0) write(nfcntn_bin) e2_mpi             ! MPI ; writing (occup_l)
       if(mype == 0) then
          if(totch_flag == OFF) then
             write(nfcntn_bin) efermi                     ! MPI
          else
             write(nfcntn_bin) efermi,totch               ! MPI
          end if
       end if
       deallocate(n_wk); deallocate(n2_mpi)              ! MPI
       deallocate(e_wk); deallocate(e2_mpi)              ! MPI
    end if
    call tstatc0_end(id_sname)
  end subroutine m_ESIO_wd_EigenValues_etc

  subroutine m_ESIO_wd_EigenValues(nf,iprieigen,nooccupation)

    integer, intent(in)              :: nf
    integer, intent(in)              :: iprieigen
    integer, intent(in)              :: nooccupation
    integer                          :: ie,  ipri0, kv3_i, ks
    integer                          :: hconst_min, lzero_max
    integer, parameter :: NCOLUMN = 6
    integer, parameter :: EIGEN_VALUES = 1, OCCUPATIONS = 2
    integer :: writemode
    real(kind=DP),allocatable, dimension(:,:) :: e_mpi, o_mpi
#ifdef __TIMER_SUB__
  call timer_sta(1378)
#endif
    allocate(e_mpi(neg,kv3)); e_mpi = 0.d0
    allocate(o_mpi(neg,kv3)); o_mpi = 0.d0

    call set_writemode(writemode)  ! ->(writemode) = ALL_VALUES or FERMI_VICINITY
    call get_ipri0(iprieigen,ipri0)

    if(ipri0 >= 2) then
       if(ipri0 >= 3 .and. nf == 6 .and. printable) call wd_neordr()

       call set_kv3_i_and_ks() ! -> kv3_i, ks
#ifndef _DEBUG_WRITE_
       if(writemode == EFERMI_VICINITY .and. kv3_i == kv3) &
            & call cal_vicinity_range(hconst_min,lzero_max) ! -> lzero_max, hconst_min
#endif
!     --- Energy eigen values ---
       call put_kpartArray_into(eko_l,e_mpi)
       if(printable) then
          if(ks == 0 .and. nf==6) call wd_efermi()
!!$          if(ks == 0) call wd_efermi()
          call wd_k_and_values(EIGEN_VALUES)
       end if
    end if
!     --- Occupations ---
    if(ipri0 >= 2 .and. nooccupation /= YES) then
       call put_kpartArray_into(occup_l,o_mpi)
       if(printable) call wd_k_and_values(OCCUPATIONS)
    end if
    deallocate(e_mpi)
    deallocate(o_mpi)
#ifdef __TIMER_SUB__
  call timer_end(1378)
#endif
  contains
    subroutine set_writemode(writemode)
      integer, intent(out) :: writemode
      writemode = ALL_VALUES
#ifndef _DEBUG_WRITE_
      if(nf==6) then
         if((icond == FIXED_CHARGE_CONTINUATION .or. icond == FIXED_CHARGE) .and. &
              & fixed_charge_k_parallel == ONE_BY_ONE) then
            writemode = ALL_VALUES
         else
            if(neg <= NCOLUMN) then
               writemode = ALL_VALUES
            else
               writemode = EFERMI_VICINITY
            end if
         end if
      end if
#endif
    end subroutine set_writemode

    subroutine set_kv3_i_and_ks()
!!$      if(iprieigen>=2 .and. printable) then
      if((icond == FIXED_CHARGE_CONTINUATION .or. icond == FIXED_CHARGE) .and. &
           & fixed_charge_k_parallel == ONE_BY_ONE) then
         kv3_i = kv3_ek - kv3*(nkgroup-1)
         if(kv3_i > kv3) kv3_i = kv3
         ks = max(1,first_kpoint_in_this_job) - 1 + kv3*(nkgroup-1)
      else
         kv3_i = kv3
         ks = 0
      end if

      if(iprieigen>=3 .and. printable) &
           & write(nf,'(" kv3_i, kv3, ks, nkgroup = ",4i8)') kv3_i, kv3, ks, nkgroup
!!$
!!$      call mpi_bcast(kv3_i,1,mpi_integer,0,mpi_comm_group,ierr)
!!$      call mpi_bcast(ks,1,mpi_integer,0,mpi_comm_group,ierr)
    end subroutine set_kv3_i_and_ks

    subroutine wd_k_and_values(mode)
      integer, intent(in) :: mode
      integer :: ik, nb
      integer :: ie_s, ie_e, nhw, neg_t
      real(kind=DP) :: hw, hc, hv
      
#ifndef _DEBUG_WRITE_
      if(writemode == EFERMI_VICINITY) then
         hw = (lzero_max-hconst_min)*0.5d0
         hv = (lzero_max+hconst_min)*0.5d0
         hc = NCOLUMN*0.5d0
         nhw = Int(hw/hc + 1.d0)
         ie_s = max(nint(hv-nhw*hc + DELTA),1)
         ie_e = min(ie_s + nhw*NCOLUMN - 1,neg)
      end if
#endif

      if(mode == EIGEN_VALUES) then
#ifndef _DEBUG_WRITE_
         if(writemode == EFERMI_VICINITY) then
            write(nf,'(" ======  Energy Eigen Values in the vicinity of the Fermi energy level (Range=" &
                 & ,i7," :",i7,") =====")') ie_s, ie_e
         else
#endif
            if(nf==6) write(nf,'(" ======  Energy Eigen Values ======")')
#ifndef _DEBUG_WRITE_
         end if
#endif
      else
#ifndef _DEBUG_WRITE_
         if(writemode == EFERMI_VICINITY) then
            write(nf,'(" ======  Occupations in the vicinity of the Fermi energy level (Range=" &
                 & ,i7," :",i7,") =====")') ie_s, ie_e
         else
#endif
            if(nf==6) write(nf,'(" ======  Occupations ======")')
#ifndef _DEBUG_WRITE_
         end if
#endif
      end if
#ifdef __TIMER_IODO__
  call timer_sta(1463)
#endif
      do ik = 1, kv3_i, ndim_spinor
#ifndef _DEBUG_WRITE_
!!$         if(mode == OCCUPATIONS) e_mpi(:,ik) = e_mpi(:,ik)/(qwgt(ik)*kv3)
!!$         if(mode == OCCUPATIONS) o_mpi(:,ik) = o_mpi(:,ik)/(qwgt(ik)*kv3)
         if(writemode==EFERMI_VICINITY .and. kv3==kv3_i) then
            call wd_k_and_efermi_vicinities(ik,ie_s,ie_e,mode)
         else
#endif
            if(nf /= 6 .and. mode == EIGEN_VALUES) write(nf,'(" ===== energy eigen values =====")')
            if(nf /= 6 .and. mode == OCCUPATIONS)  write(nf,'(" ===== occupations =====")')
            if ( noncol ) then
               call wd_k_points_noncl(ik)
            else
               call wd_k_points(ik)
            endif
            neg_t = neg
            if(neg_is_enlarged) neg_t = neg - num_extra_bands
            if(mode == EIGEN_VALUES) then
               write(nf,'(5f16.8)') (e_mpi(nb,ik),nb = 1, neg_t) ! =eko(neordr(nb,ik),ik)
            else if(mode == OCCUPATIONS) then
               write(nf,'(5f16.8)') (o_mpi(nb,ik)/(qwgt(ik)*kv3),nb = 1, neg_t) ! =occup(neordr(nb,ik),ik)
            end if
#ifndef _DEBUG_WRITE_
         end if
#endif
      end do
#ifdef __TIMER_IODO__
  call timer_end(1463)
#endif
    end subroutine wd_k_and_values

    subroutine put_kpartArray_into(a_l,a_all)
      real(kind=DP), intent(in), dimension(np_e,ista_k:iend_k) :: a_l
      real(kind=DP), intent(out), dimension(neg,kv3) :: a_all
      integer :: ik, ierr, ie
      integer :: ito

#ifdef __TIMER_IODO__
  call timer_sta(1461)
#endif
      a_all = 0.d0
      do ik = 1, kv3
         if(map_k(ik) /= myrank_k) cycle
         do ie = 1, neg
            if(map_e(ie) /= myrank_e) cycle
            ito = nrvf_ordr(ie,ik)
            a_all(ito,ik) = a_l(map_z(ie),ik)
         end do
      end do
#ifdef __TIMER_IODO__
  call timer_end(1461)
#endif
      if(npes >= 2) then
         call mpi_allreduce(MPI_IN_PLACE,a_all,neg*kv3,mpi_double_precision &
              &                      ,mpi_sum, mpi_comm_group,ierr)
      end if
     end subroutine put_kpartArray_into

    subroutine wd_neordr()
      integer :: ik
      write(nf,'(" kv3 = ",i8, " neg = ",i8)') kv3,neg
      do ik= 1,kv3
         write(nf,'(" map_k(",i3,") = ",i8)') ik,map_k(ik)
         if(map_k(ik) /= myrank_k) cycle
         write(nf,'(" neordr ik=",i8)') ik
         write(nf,'(10i8)') neordr(1:neg,ik)
      end do
    end subroutine wd_neordr

    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,mpi_comm_group,ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0

    subroutine wd_k_points(ik)
      integer, intent(in) :: ik
       if(nspin == 1) then
#ifdef _EIGENVALUES_IN_OLD_FORMAT_
          write(nf,'(i6,3f16.8)') ik+ks,(vkxyz(ik,1:3,BUCS))
#else
          write(nf,'(" ik = ",i4," (",3f10.6," )")') ik+ks,(vkxyz(ik,1:3,BUCS))
#endif
       else
#ifdef _EIGENVALUES_IN_OLD_FORMAT_
          if(mod(ik,2) == 1) then
             write(nf,'(i6,"    UP ",3f16.8)') ik+ks,(vkxyz(ik,1:3,BUCS))
          else
             write(nf,'(i6,"  DOWN ",3f16.8)') ik+ks,(vkxyz(ik,1:3,BUCS))
          end if
#else
          if(mod(ik,2) == 1) then
             write(nf,'(" ik = ",i4," (",3f10.6,")    UP ")') ik+ks,(vkxyz(ik,1:3,BUCS))
          else
             write(nf,'(" ik = ",i4," (",3f10.6,")  DOWN ")') ik+ks,(vkxyz(ik,1:3,BUCS))
          end if
#endif
       end if
     end subroutine wd_k_points

! ============================== added by K. Tagami ==================== 11.0
     subroutine wd_k_points_noncl(ik)
       integer, intent(in) :: ik
#ifdef _EIGENVALUES_IN_OLD_FORMAT_
       write(nf,'(i6,3f16.8)') ik+ks,(vkxyz(ik,1:3,BUCS))
#else
       write(nf,'(" ik = ",i4," (",3f10.6," )")') ik+ks,(vkxyz(ik,1:3,BUCS))
#endif
     end subroutine wd_k_points_noncl
! ====================================================================== 11.0

     subroutine cal_vicinity_range(hconst_min, lzero_max)
       integer, intent(out) :: hconst_min, lzero_max
       integer :: hconst,lzero
       integer :: ik, ie, nb
       integer :: ito

       e_mpi = 0.d0
       do ik = 1, kv3
          if(map_k(ik) /= myrank_k) cycle
          do ie = 1, neg
             if(map_e(ie) /= myrank_e) cycle
             ito = nrvf_ordr(ie,ik)
             e_mpi(ito,ik) = occup_l(map_z(ie),ik)
          end do
       end do
       if(npes >= 2) then
          call mpi_allreduce(MPI_IN_PLACE,e_mpi,neg*kv3,mpi_double_precision &
               &                  ,mpi_sum,mpi_comm_group,ierr) ! MPI
       end if
       hconst_min = neg
       lzero_max = 0
       do ik = 1, kv3, ndim_spinor
          hconst = neg
          lzero  = 1
          do nb = neg,1,-1
             if(e_mpi(nb,ik)<DELTA) lzero = nb
             if(e_mpi(nb,ik)>=qwgt(ik)*kv3-DELTA ) then
                hconst = nb
                exit
             end if
          end do
          if(hconst < hconst_min) hconst_min = hconst
          if(lzero_max < lzero)   lzero_max = lzero
       end do
       if(printable) write(nf,'(" hconst_min,lzero_max = ",2i8)') hconst_min,lzero_max
     end subroutine cal_vicinity_range

     subroutine wd_k_and_efermi_vicinities(ik,ie_s,ie_e,mode)
       integer, intent(in) :: ik, ie_s,ie_e,mode
       integer :: nb, nbloop, ie, ie1, ie2
       if(hconst_min >= 1) then
!!$          nb = lzero_max-hconst_min+1
          nb = ie_e - ie_s + 1
          nbloop = Int((nb-1)/NCOLUMN+1)
          do ie = 1, nbloop
!!$             ie1 = hconst_min+(ie-1)*NCOLUMN
!!$             ie2 = min(hconst_min+ie*NCOLUMN-1,neg)
             ie1 = max(ie_s+(ie-1)*NCOLUMN,1)
             ie2 = min(ie_s+ie*NCOLUMN-1,neg)
             if(ie == 1) then
                if(mode == EIGEN_VALUES) then
                   write(nf,'(" ik = ",i4,"  ",8f12.6)') ik, (e_mpi(nb,ik),nb=ie1,ie2)
                else if(mode == OCCUPATIONS) then
                   write(nf,'(" ik = ",i4,"  ",8f12.6)') ik, (o_mpi(nb,ik)/(qwgt(ik)*kv3),nb=ie1,ie2)
                end if
             else
                if(mode == EIGEN_VALUES) then
                   write(nf,'(12x,8f12.6)') (e_mpi(nb,ik),nb=ie1,ie2)
                else if(mode == OCCUPATIONS) then
                   write(nf,'(12x,8f12.6)') (o_mpi(nb,ik)/(qwgt(ik)*kv3),nb=ie1,ie2)
                end if
             end if
          end do
       end if
     end subroutine wd_k_and_efermi_vicinities

     subroutine wd_efermi()
       if(nf == 6) write(nf,'(" **** Eigen Values and Occupations ****")')
       write(nf,'(" ** iteration_ionic = ",i8, ", iteration_electronic = ",i8," **")') &
            & iteration_ionic, iteration_electronic
       write(nf,'(" EFermi = ",f16.8)') efermi
       if(sw_fix_total_spin == YES .and. nspin == 2) then
          write(nf,'(" Efermi_spin(1) = ",f16.8, ",  Efermi_spin(2) = ",f16.8)') &
               & efermi_spin(1), efermi_spin(2)
       end if
     end subroutine wd_efermi
  end subroutine m_ESIO_wd_EigenValues

  subroutine m_ESIO_wd_EigenValues_ek(nf,mode)
    integer, intent(in)              :: nf, mode

    real(kind=DP), parameter :: delta = 1.d-12
    real(kind=DP), allocatable, dimension(:) :: eko_t
    integer, allocatable, dimension(:)       :: neordr_t
    integer                     :: ik, ib,jb,ibo,jbo, neg_t

! =========================== added by K. Tagami ================ 11.0
    integer :: ikskip
! =============================================================== 11.0

    allocate(eko_t(neg))
    allocate(neordr_t(neg))
    eko_t = 0; neordr_t = 0

    if(mode == SCF .and. printable) write(nf,'(" ======  Energy Eigen Values ======")')
!!$    do ik = 1, kv3_ek
!!$    do ik = 1, nk_in_the_process

    if(printable) then
! ========================= modified by K. Tagami ============ 11.0
!       write(nf,'(" nk_converged = ",i8)') min(kv3_ek,nk_converged)
!       do ik = 1, kv3_ek
!          call wd_k_points
!       end do
       if ( noncol ) then
          write(nf,'(" nk_converged = ",i8)') min(kv3_ek,nk_converged) /ndim_spinor
          do ik = 1, kv3_ek, ndim_spinor
             call wd_k_points_noncl
          end do
       else
          write(nf,'(" nk_converged = ",i8)') min(kv3_ek,nk_converged)
          do ik = 1, kv3_ek
             call wd_k_points
          end do
       endif
! ============================================================= 11.0

       write(nf,'(" -----")')
    end if

! ====================== added by K. Tagami =================== 11.0
    if ( noncol ) then
       ikskip = ndim_spinor
    else
       ikskip = 1
    endif
! ============================================================ 11.0

! ============================ modified by K. Tagami ============ 11.0
!    do ik = 1, nk_converged
    do ik = 1, nk_converged, ikskip
! =============================================================== 11.0

!       if(sw_ekzaj == OFF .and. ik <= first_kpoint_in_this_job) cycle
       if(ik > kv3_ek) cycle
       if(mode == EK .and. printable) write(nf,'("=== energy_eigen_values ===")')
       eko_t = eko_ek(:,ik)
       if(nspin == 1 .or. (nspin == 2 .and. mod(ik,2) == 1)) &
            & neordr_t(1:neg) = (/(ib,ib=1,neg)/)
       do ib = 1, neg-1
          do jb = ib+1, neg
             ibo = neordr_t(ib)
             jbo = neordr_t(jb)
             if(eko_t(jbo)  < eko_t(ibo)-delta) then        ! MPI
                neordr_t(jb) = ibo
                neordr_t(ib) = jbo
             end if
          end do
       end do
       if(printable) then
! ================================ modified by K. Tagami ========== 11.0
!          call wd_k_points
          if ( noncol ) then
             call wd_k_points_noncl
          else
             call wd_k_points
          endif
! ================================================================= 11.0
          neg_t = neg

          if(neg_is_enlarged) neg_t = neg - num_extra_bands
          if(mode == SCF) then
             write(nf,'(5f16.8)') (eko_t(neordr_t(ib)),ib=1,neg_t)
          else
             write(nf,'(4f18.10)') (eko_t(neordr_t(ib)),ib=1,neg_t)
          end if
       end if
    end do
    deallocate(neordr_t)
    deallocate(eko_t)
  contains
    subroutine wd_k_points
      if(mode == SCF) then
         if(nspin == 1) then
            write(nf,'(i6,3f18.10)') ik,(vkxyz_ek(ik,1:3,BUCS))
         else
            if(mod(ik,2) == 1) then
               write(nf,'(i6,"    UP ",3f18.10)') ik,(vkxyz_ek(ik,1:3,BUCS))
            else
               write(nf,'(i6,"  DOWN ",3f18.10)') ik,(vkxyz_ek(ik,1:3,BUCS))
            end if
         end if
      else
         if(nspin == 1) then
            write(nf,'(" ik = ",i4," (",3f10.6," )")') ik,(vkxyz_ek(ik,1:3,BUCS))
         else
            if(mod(ik,2) == 1) then
               write(nf,'(" ik = ",i4," (",3f10.6,")    UP ")') ik,(vkxyz_ek(ik,1:3,BUCS))
            else
               write(nf,'(" ik = ",i4," (",3f10.6,")  DOWN ")') ik,(vkxyz_ek(ik,1:3,BUCS))
            end if
         end if
      end if
    end subroutine wd_k_points

! ============================== added by K. Tagami ==================== 11.0
    subroutine wd_k_points_noncl
      if (mode == SCF) then
         write(nf,'(i6,3f18.10)') ik,(vkxyz_ek(ik,1:3,BUCS))
      else
         write(nf,'(" ik = ",i4," (",3f10.6," )")') ik,(vkxyz_ek(ik,1:3,BUCS))
      endif
    end subroutine wd_k_points_noncl
! ====================================================================== 11.0

  end subroutine m_ESIO_wd_EigenValues_ek

! ======================================= modified by K. Tagami ========== 11.0
!  subroutine m_ESIO_wd_vlhxc(nfvlc)
!
  subroutine m_ESIO_wd_vlhxc( nfvlc, ismax )
    integer, intent(in)              :: ismax
! ======================================================================= 11.0

    integer, intent(in)              :: nfvlc
    integer                          :: is, ik, i
    real(DP),allocatable, dimension(:,:,:):: vlhxc_mpi,vlhxc_mpi2

    if(npes >= 2) then

! ========================== modiifed by K. Tagami ============= 11.0
!       allocate(vlhxc_mpi(kgp,kimg,nspin)); vlhxc_mpi = 0.d0  ! MPI
!       allocate(vlhxc_mpi2(kgp,kimg,nspin))

       allocate(vlhxc_mpi(kgp,kimg,ismax));
       allocate(vlhxc_mpi2(kgp,kimg,ismax))
! ============================================================= 11.0
       vlhxc_mpi = 0.0d0;       vlhxc_mpi2 = 0.0d0

! ========================== modiifed by K. Tagami ============= 11.0
!       do is = 1, nspin
       do is = 1, ismax
! ============================================================== 11.0
          do ik = 1, kimg
             do i = ista_kngp, iend_kngp
                vlhxc_mpi(i,ik,is) = vlhxc_l(i,ik,is)
             end do
          end do
       end do

! ========================== modiifed by K. Tagami ====================== 11.0
!       call mpi_allreduce(vlhxc_mpi,vlhxc_mpi2,kgp*kimg*nspin &
!            &     , mpi_double_precision, mpi_sum, mpi_comm_group,ierr)
       call mpi_allreduce( vlhxc_mpi, vlhxc_mpi2, kgp*kimg*ismax, &
            &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
! ====================================================================== 11.0

       if (mype == 0) write(nfvlc) vlhxc_mpi2

       deallocate(vlhxc_mpi); deallocate(vlhxc_mpi2)
    else
       write(nfvlc) vlhxc_l
    end if
  end subroutine m_ESIO_wd_vlhxc

  subroutine m_ESIO_rd_WFs(nfout,nfzaj, F_ZAJ_partitioned)
    integer, intent(in) :: nfout, nfzaj
    logical, intent(in) :: F_ZAJ_partitioned
    integer    :: ik,ib,ri, i
    integer    :: id_sname = -1
    integer    :: ierror
    call tstatc0_begin('m_ESIO_rd_WFs ',id_sname)

    allocate(wf_l(kg1,kimg)); wf_l = 0.d0
    rewind nfzaj
    if(ipri >= 1) write(nfout,*) ' !D Reading zaj'
    if(F_ZAJ_partitioned) then
       do ik = ista_k, iend_k, af+1        ! MPI
          do ib = ista_e, iend_e, istep_e  ! MPI
             if(ib > neg_previous) cycle
             read(nfzaj) wf_l
             if(kimg == 1) then
                do i = 1, kg1
                   zaj_l(i,map_z(ib),ik,1) = wf_l(i,1)
                end do
             else if(kimg==2) then
                do i = 1, kg1
                   zaj_l(i,map_z(ib),ik,1) = wf_l(i,1)
                   zaj_l(i,map_z(ib),ik,2) = wf_l(i,2)
                end do
             end if
          end do
       end do
    else
       do ik = 1, kv3, af+1
          do ib = 1, neg_previous

             if(mype == 0) read(nfzaj, end = 9999, err = 9999) wf_l  ! MPI
             if(mype == 0 .and. map_ek(ib,ik) /= 0) then ! MPI
                call mpi_send(wf_l,kg1*kimg,mpi_real,map_ek(ib,ik),1,mpi_comm_group,ierr) ! MPI
             else if(map_ek(ib,ik) == mype .and. map_ek(ib,ik) /= 0) then                  ! MPI
                call mpi_recv(wf_l,kg1*kimg,mpi_real,0,1,mpi_comm_group,istatus,ierr)     ! MPI
             end if
             if(map_ek(ib,ik) == mype) then              ! MPI
                do ri = 1, kimg
                   zaj_l(1:kg1,map_z(ib),ik,ri) = wf_l(1:kg1,ri)  ! MPI
                end do
             end if
          end do
       end do
    end if
    deallocate(wf_l)

    call tstatc0_end(id_sname)                      
    return
9999 continue
    ierror = EOF_REACHED
    call phase_error_wo_filename(ierror, nfout, nfzaj, __LINE__, __FILE__)
  end subroutine m_ESIO_rd_WFs

! ==================================== added by K. Tagami =============== 11.0
  subroutine m_ESIO_rd_WFs_import_frm_collin(nfout,nfzaj, F_ZAJ_partitioned)
    integer, intent(in) :: nfout, nfzaj
    logical, intent(in) :: F_ZAJ_partitioned

    integer  neg_to_be_read

    integer    :: id_sname = -1
    call tstatc0_begin('m_ESIO_rd_WFs_import_frm_collin ',id_sname)

    allocate(wf_l(kg1,kimg))
    wf_l = 0
    rewind nfzaj
    if(ipri >= 1) write(nfout,*) ' !D Reading zaj'

    if(F_ZAJ_partitioned) then
       write(*,*) &
            & 'Not supported : importing collinear Wfns  when F_ZAJ_partitioned = true'

    else
       neg_to_be_read = neg / 2

       write(nfout,*) '******************************** '
       write(nfout,*) '!! Collinear wavefunctions are used. '
       write(nfout,*) '!! neg_to_be_read is assumed to be ', neg_to_be_read
       write(nfout,*) '******************************** '

       if ( previous_nspin_collinear == 1 ) then
          call case_previous_nspin_eq_1
       else if ( previous_nspin_collinear == 2 ) then
          call case_previous_nspin_eq_2
       endif

    end if

    deallocate(wf_l)
    call tstatc0_end(id_sname)

  contains

    subroutine case_previous_nspin_eq_2
      integer :: ik, ib, ri, i
      integer :: ib_0, is

      do ik = 1, kv3, ndim_spinor
         Do is=1, ndim_spinor
            do ib_0 = 1, previous_nband_collinear
               ib = ( ib_0 -1 )*ndim_spinor + is
               if(mype == 0) read(nfzaj) wf_l              ! MPI

               if(mype == 0 .and. map_ek(ib,ik) /= 0) then ! MPI
                  call mpi_send( wf_l, kg1*kimg, mpi_real, map_ek(ib,ik), 1, &
                       &         mpi_comm_group, ierr ) ! MPI
               else if(map_ek(ib,ik) == mype .and. map_ek(ib,ik) /= 0 ) then     ! MPI
                  call mpi_recv( wf_l, kg1*kimg, mpi_real, 0, 1, &
                       &         mpi_comm_group, istatus, ierr )     ! MPI
               end if

               if ( ib_0 > neg_to_be_read ) cycle

               if(map_ek(ib,ik) == mype) then              ! MPI
                  do ri = 1, kimg
                     zaj_l(1:kg1,map_z(ib),ik+is-1,ri) = wf_l(1:kg1,ri)  ! MPI
                  end do
               end if

            end do
         End Do
      end do
    end subroutine case_previous_nspin_eq_2

    subroutine case_previous_nspin_eq_1
      integer :: ik, ib, ri, i
      integer :: ib_0, is

      do ik = 1, kv3, ndim_spinor
         do ib_0 = 1, previous_nband_collinear
            if(mype == 0) read(nfzaj) wf_l              ! MPI

            Do is=1, ndim_spinor
               ib = ( ib_0 -1 )*ndim_spinor + is
               if(mype == 0 .and. map_ek(ib,ik) /= 0) then ! MPI
                  call mpi_send( wf_l, kg1*kimg, mpi_real, map_ek(ib,ik), 1, &
                       &         mpi_comm_group, ierr ) ! MPI
               else if(map_ek(ib,ik) == mype .and. map_ek(ib,ik) /= 0 ) then     ! MPI
                  call mpi_recv( wf_l, kg1*kimg, mpi_real, 0, 1, &
                       &         mpi_comm_group, istatus, ierr )     ! MPI
               end if

               if ( ib_0 > neg_to_be_read ) cycle

               if(map_ek(ib,ik) == mype) then              ! MPI
                  do ri = 1, kimg
                     zaj_l(1:kg1,map_z(ib),ik+is-1,ri) = wf_l(1:kg1,ri)  ! MPI
                  end do
               end if

            end do
         End Do
      end do
    end subroutine case_previous_nspin_eq_1

  end subroutine m_ESIO_rd_WFs_import_frm_collin
!===================================================================== 11.0

  subroutine m_ESIO_wd_WFs(nfout,nfzaj,F_ZAJ_partitioned)
    integer, intent(in) :: nfout,nfzaj
    logical, intent(in) :: F_ZAJ_partitioned
    integer :: ik,ib,ri
    integer :: id_sname = -1
    call tstatc0_begin('m_ESIO_wd_WFs ',id_sname)

    allocate(wf_l(kg1,kimg));    wf_l = 0
    call mpi_barrier(mpi_comm_group,ierr)
    !!$ print *, ' !D Writing zaj '
    if(ipri >= 1) write(nfout,*) ' !D Writing zaj '
    rewind nfzaj
    if(F_ZAJ_partitioned) then
       do ik = ista_k, iend_k, af+1        ! MPI
          do ib = ista_e, iend_e, istep_e  ! MPI
             do ri = 1, kimg
                wf_l(1:kg1,ri) = zaj_l(1:kg1,map_z(ib),ik,ri)
             end do
             write(nfzaj) wf_l
          end do
       end do
    else
       do ik = 1, kv3, af+1
          do ib = 1, neg
             if(map_ek(ib,ik) == mype) then                          ! MPI
                do ri = 1, kimg
                   wf_l(1:kg1,ri) = zaj_l(1:kg1,map_z(ib),ik,ri)
                end do
                if(map_ek(ib,ik) /= 0) &                             ! MPI
                     &   call mpi_send(wf_l,kg1*kimg,mpi_real,0,1,mpi_comm_group,ierr) ! MPI
             else if(mype == 0 .and. map_ek(ib,ik) /= 0) then
                call mpi_recv(wf_l,kg1*kimg,mpi_real,map_ek(ib,ik),1,mpi_comm_group,istatus,ierr)!MPI
             end if
             if(mype == 0) write(nfzaj)  wf_l                        ! MPI
          end do
       end do
    end if
    deallocate(wf_l)
    call tstatc0_end(id_sname)
  end subroutine m_ESIO_wd_WFs

  subroutine m_ESIO_wd_WFs_standardout(nfout,ipriwf)
    integer, intent(in) :: nfout,ipriwf
    integer :: ik,ib,ri, i, ic, ipriwf0, icycle, icolumn, max_elements, istart, iend
    integer :: id_sname = -1
    real(kind=DP) :: phase2r, phase2i, phaser,phasei
    complex(kind=CMPLDP) :: exp2theta, exptheta
    call tstatc0_begin('m_ESIO_wd_WFs_stndout ',id_sname)
    
    ipriwf0 = ipriwf
    if(npes > 1) call mpi_bcast(ipriwf0,1,mpi_integer,0,mpi_comm_group,ierr)

    if(ipriwf0 >= 2) then
       icolumn = 10
       allocate(wf_l(kg1,kimg+3)); wf_l = 0.d0
       call mpi_barrier(mpi_comm_group,ierr)
       if(mype == 0)  write(nfout,*) ' !wf Writing zaj '

       do ik = 1, kv3, af+1
          max_elements = iba(ik)
          if(mype == 0) write(nfout,'(" !wf   ik = ",i5)') ik
          do ib = 1, neg
             if(mype == 0) write(nfout,'(" !wf   ib = ",i5)') ib
             if(map_ek(ib,ik) == mype) then                          ! MPI
                do ri = 1, kimg
                   wf_l(1:kg1,ri) = zaj_l(1:kg1,map_z(ib),ik,ri)
                end do
                if(map_ek(ib,ik) /= 0) &                             ! MPI
                     &   call mpi_send(wf_l,kg1*kimg,mpi_real,0,1,mpi_comm_group,ierr) ! MPI
             else if(mype == 0 .and. map_ek(ib,ik) /= 0) then
                call mpi_recv(wf_l,kg1*kimg,mpi_real,map_ek(ib,ik),1,mpi_comm_group,istatus,ierr)!MPI
             end if
             if(mype == 0) then
                if(kimg == 2) then
                   do i = 1, iba(ik)
                      wf_l(i,3) = wf_l(i,1)**2 + wf_l(i,2)**2
                   end do
                   if(k_symmetry(ik) == GAMMA .or. k_symmetry(ik) == GAMMA_base_symmetrization) then
                      phase2r = (wf_l(1,1)**2 - wf_l(1,2)**2)/wf_l(1,3)
                      phase2i = -2.d0*wf_l(1,1)*wf_l(1,2)/wf_l(1,3)
                      exp2theta = cmplx(phase2r, phase2i)
                      exptheta = sqrt(exp2theta)
                      phaser = real(exptheta)
                      phasei = imag(exptheta)
                      write(nfout,'(" !wf exp2theta = ",2d20.8)') exp2theta
                      write(nfout,'(" !wf           = ",2d20.8)') phase2r, phase2i
                      write(nfout,'(" !wf |exp2theta|**2 = ",d20.8)') dsqrt(phase2r**2 + phase2i**2)
                      write(nfout,'(" !wf exptheta  = ",2d20.8)') exptheta
                      write(nfout,'(" !wf |exptheta| = ",d20.8)') abs(exptheta)
                      do i = 1, iba(ik)
!!$                      wf_l(i,4) = real(exptheta*cmplx(wf_l(i,1),wf_l(i,2)))
!!$                      wf_l(i,5) = imag(exptheta*cmplx(wf_l(i,1),wf_l(i,2)))
                         wf_l(i,4) = phaser*wf_l(i,1) - phasei*wf_l(i,2)
                         wf_l(i,5) = phaser*wf_l(i,2) + phasei*wf_l(i,1)
                      end do
                   end if
                else
                   do i = 1, iba(ik)
                      wf_l(i,2) = wf_l(i,1)**2
                   end do
                   exp2theta = 1.d0
                   exptheta = 1.d0
                end if
                icycle = ceiling(dble(min(max_elements,iba(ik)))/icolumn)
                istart = 1
                do ic = 1, icycle
                   iend = min(istart+icolumn-1,max_elements,iba(ik))
                   write(nfout,'(" !wf (nx)    ",10i10)') (ngabc(nbase(i,ik),1),i=istart,iend)
                   write(nfout,'(" !wf (ny)    ",10i10)') (ngabc(nbase(i,ik),2),i=istart,iend)
                   write(nfout,'(" !wf (nz)    ",10i10)') (ngabc(nbase(i,ik),3),i=istart,iend)
                   write(nfout,'(" !wf (zaj-r) ",10d10.2)') (wf_l(i,1),i=istart,iend)
                   if(kimg == 2) write(nfout,'(" !wf (zaj-i) ",10d10.2)') (wf_l(i,2),i=istart,iend)
                   write(nfout,'(" !wf abs     ",10d10.2)') (wf_l(i,kimg+1),i=istart,iend)
                   if(kimg == 2) then
                      if(k_symmetry(ik) == GAMMA .or. k_symmetry(ik) == GAMMA_base_symmetrization) then
                         write(nfout,'(" !wf (zaj-r)d",10d10.2)') (wf_l(i,4),i=istart,iend)
                         write(nfout,'(" !wf (zaj-i)d",10d10.2)') (wf_l(i,5),i=istart,iend)
                      end if
                   end if
                   istart = iend+1
                end do
             end if
          end do
       end do
       deallocate(wf_l)
    end if
    call tstatc0_end(id_sname)
  end subroutine m_ESIO_wd_WFs_standardout

  subroutine m_ESIO_rd_WFs_and_EVs_ek(nfout,nf)
    integer, intent(in) :: nfout,nf
    integer  :: ik, ie, iks, ri, ikg, ikt, ike, ike2
    integer, allocatable, dimension(:,:) :: n_mpi, n2_mpi  ! MPI
    real(DP),allocatable, dimension(:,:) :: e_mpi, e2_mpi  ! MPI
!!$    read(nf) neordr,nrvf_ordr,eko_l,occup_l,efermi,totch

    allocate(n_mpi(neg,nspin)); allocate(n2_mpi(neg,nspin)) ! MPI
    allocate(e_mpi(neg,nspin)); allocate(e2_mpi(neg,nspin)) ! MPI
    allocate(wf_l(kg1,kimg))

    n_mpi =0; n2_mpi = 0
    e_mpi =0; e2_mpi = 0; wf_l = 0
    if(ipri >= 1) write(nfout,*) ' !D Reading zaj'

    rewind nf

    eko_ek = 0.d0
!!$    do ik = 1, nk_in_the_process-kv3, kv3
    do ik = 1, nk_in_the_process - nspin, nspin
       if(ipri >= 1) write(nfout,*) ' !D     skipping ik = ', ik
!!$       do iks = 1, kv3, af+1
       do iks = 1, nspin, af+1
          do ie = 1, neg
             if(mype == 0) read(nf) wf_l
          end do
       end do
       if(mype == 0) read(nf) n_mpi
       if(mype == 0) read(nf) n2_mpi
       if(mype == 0) read(nf) e_mpi

       if(mype == 0) then
!!$          do iks = 1, kv3
          do iks = 1, nspin
             do ie = 1, neg
                eko_ek(ie,ik+iks-1) = e_mpi(n_mpi(ie,iks),iks)
             end do
          end do
          if(ipri >= 3) then
!!$             do iks=1,kv3
             do iks=1,nspin
                write(nfout,'(" ik = ",i5)') ik+iks-1
                write(nfout,'(8f8.4)') (e_mpi(n_mpi(ie,iks),iks),ie=1,neg)
             end do
          end if
       end if
    end do
       
    if(nk_in_the_process > kv3_ek) goto 1001

!!$    do ik = 1, kv3, af+1
    KPOINT_LOOP: do ikg = 1, nrank_k
       do ikt = 1, nspin, af+1
          ik = (ikg-1)*nspin+ikt
          if(nk_in_the_process -1 + ik > kv3_ek) exit KPOINT_LOOP
          if(nk_in_the_process -1 + ik > numk_zajsaved) exit KPOINT_LOOP
          if(ipri>=1) write(nfout,*) ' !D     reading  ik = ', ik+first_kpoint_in_this_job-1

          do ie = 1, neg
             if(ipri>=2) write(nfout,*) ' !D     ie = ', ie
             if(mype == 0) read(nf,err=2,end=2) wf_l     ! MPI
             if(mype == 0 .and. map_ek(ie,ik) /= 0) then ! MPI
                call mpi_send(wf_l,kg1*kimg,mpi_real,map_ek(ie,ik),1,mpi_comm_group,ierr) ! MPI
             else if(map_ek(ie,ik) == mype .and. map_ek(ie,ik) /= 0) then                  ! MPI
                call mpi_recv(wf_l,kg1*kimg,mpi_real,0,1,mpi_comm_group,istatus,ierr)     ! MPI
             end if
             if(map_ek(ie,ik) == mype) then              ! MPI
                do ri = 1, kimg
                   zaj_l(1:kg1,map_z(ie),ik,ri) = wf_l(1:kg1,ri)  ! MPI
                end do
             end if
          end do
       end do

       if(mype == 0) read(nf) n_mpi                ! MPI
       if(mype == 0) read(nf) n2_mpi               ! MPI
       call mpi_bcast(n_mpi,neg*nspin,mpi_integer,0,mpi_comm_group,ierr) ! MPI
       call mpi_bcast(n2_mpi,neg*nspin,mpi_integer,0,mpi_comm_group,ierr)! MPI

       do ikt = 1, nspin                             ! MPI
          ik = (ikg-1)*nspin + ikt
          if(map_k(ik) == myrank_k) then
             neordr(1:neg,ik) = n_mpi(1:neg,ikt)     ! MPI
             nrvf_ordr(1:neg,ik) = n2_mpi(1:neg,ikt) ! MPI
          end if
       end do                                        ! MPI

       if(mype == 0) read(nf) e_mpi                ! MPI
       call mpi_bcast(e_mpi,neg*nspin,mpi_double_precision,0,mpi_comm_group,ierr) ! MPI

       do ikt = 1, nspin                                   ! MPI
          ik = (ikg-1)*nspin + ikt
          do ie = 1, neg                                   ! MPI
             if(map_ek(ie,ik) == mype) then                ! MPI
                eko_l(map_z(ie),ik) = e_mpi(ie,ikt)        ! MPI
             end if                                        ! MPI
          end do                                           ! MPI
          do ie = 1, neg
             eko_ek(ie,nk_in_the_process+ik-1) = e_mpi(n_mpi(ie,ikt),ikt)
          end do
       end do                                              ! MPI
       goto 3
2      continue
       stop ' eof from nf <<m_ESIO_rd_WFs_and_EVs_ek>>'
3      continue
    end do KPOINT_LOOP

    if(ipri>=2) write(nfout,*) ' !D     ikg  = ', ikg
!!$    if(ikg <= 1) stop ' ikg <= 1 <<m_ESIO_rd_WFs_and_EVs_ek>>'
    if(ikg < nrank_k .and. ikg > 1 ) then
       do ike = ikg, nrank_k
          if(ipri>=2) write(nfout,*) ' !D     ike  = ', ike
          if(ipri>=2) write(nfout,*) ' !D     zaj_l'
          do ikt = 1, nspin, af+1
             ik   = (ikg-2)*nspin+ikt
             ike2 = (ike-1)*nspin+ikt
             if(ipri>=2) write(nfout,*) ' !D     ik, ike2 = ',ik,ike2
             do ie = 1, neg
                if(map_ek(ie,ik) == mype) then
                   do ri = 1, kimg
                      wf_l(1:kg1,ri) = zaj_l(1:kg1,map_z(ie),ik,ri)
                   end do
                end if

                if(map_ek(ie,ik) == mype) then
                   call mpi_send(wf_l,kg1*kimg,mpi_real,map_ek(ie,ike2),1,mpi_comm_group,ierr)
                else if(map_ek(ie,ike2) == mype) then
                   call mpi_recv(wf_l,kg1*kimg,mpi_real,map_ek(ie,ik),1,mpi_comm_group,istatus,ierr)
                end if
                if(map_ek(ie,ike2) == mype) then
                   do ri = 1, kimg
                      zaj_l(1:kg1,map_z(ie),ike2,ri) = wf_l(1:kg1,ri)
                   end do
                end if
             end do
          end do

          ! ---> neordr, nrvf_ordr
          do ikt = 1, nspin
             ik = (ikg-2)*nspin+ikt
             if(map_k(ik) == myrank_k) then
                n_mpi(1:neg,ikt) = neordr(1:neg,ik)
                n2_mpi(1:neg,ikt) = nrvf_ordr(1:neg,ik)
             end if
          end do
          call mpi_bcast(n_mpi,neg*nspin,mpi_integer,map_k(ik),mpi_comm_group,ierr)
          call mpi_bcast(n2_mpi,neg*nspin,mpi_integer,map_k(ik),mpi_comm_group,ierr)

          if(ipri>=2) write(nfout,*) ' !D     neordr and nrvf_ordr'
          do ikt = 1, nspin
             ike2 = (ike-1)*nspin+ikt
             if(map_k(ike2) == myrank_k) then
                neordr(1:neg,ike2) = n_mpi(1:neg,ikt)     ! MPI
                nrvf_ordr(1:neg,ike2) = n2_mpi(1:neg,ikt) ! MPI
             end if
          end do

          ! ---> eko_l
          if(ipri>=2) write(nfout,*) ' !D     eko_l'
          e_mpi = 0.d0
          do ikt = 1, nspin
             ik = (ikg-2)*nspin+ikt
             if(ipri>=2) write(nfout,'(" !D eko_l ik = ",i6)') ik
             do ie = 1, neg
                if(map_ek(ie,ik) == mype) then
                   e_mpi(ie,ikt) = eko_l(map_z(ie),ik)
                end if
             end do
          end do
          if(npes >= 2) then
             call mpi_allreduce(e_mpi,e2_mpi,neg*nspin,mpi_double_precision &
                  & ,mpi_sum,mpi_comm_group,ierr)
          else
             e2_mpi  = e_mpi
          end if

          if(ipri>=2) then
             write(nfout,'(" <<m_ESIO_rd_WFs_and_EVs_ek>>")')
             do ikt = 1, nspin
                ik = (ikg-2)*nspin+ikt
                write(nfout,'(" ik = ",i5)') ik
                write(nfout,'(10f8.4)') (e2_mpi(ie,ikt),ie=1,neg)
             end do
          end if

          do ikt = 1, nspin
             ike2 = (ike-1)*nspin+ikt
             if(ipri>=2) write(nfout,'(" !D eko_l ike2 = ",i6)') ike2
             do ie = 1, neg
                if(map_ek(ie,ike2) == mype) then
                   eko_l(map_z(ie),ike2) = e2_mpi(ie,ikt)
                end if
             end do
          end do

       end do
    end if

1001 continue

    if(npes >= 2) &
         & call mpi_bcast(eko_ek,neg*kv3_ek,mpi_double_precision,0,mpi_comm_group,ierr)

    if(nk_in_the_process > kv3_ek) goto 1002
    call m_ESIO_wd_EigenValues(nfout,2,nooccupation=YES)

1002 continue

!!$    ik = nk_in_the_process
!!$    do iks = 1, kv3
!!$          do ie = 1, neg
!!$             eko_ek(ie,ik+iks-1) = e_mpi(n_mpi(ie,iks),iks)
!!$          end do
!!$       end do
!!$    end if
!!$
    if(ipri >= 1) then
       write(nfout,'(" <<m_ESIO_rd_WFs_and_EVs_ek>>")')
       do iks = 1, kv3_ek
          if(iks > numk_zajsaved) cycle
          write(nfout,'(" ik = ",i5)') iks
          write(nfout,'(10f8.4)') (eko_ek(ie,iks),ie=1,neg)
       end do
    end if


    rewind nf

    do ik = 1, nk_in_the_process-nspin, nspin
       do iks = 1, nspin, af+1
          do ie = 1, neg
             if(mype == 0) read(nf) wf_l                 ! MPI
          end do
       end do
       if(mype == 0) read(nf) n_mpi                   ! MPI
       if(mype == 0) read(nf) n2_mpi                  ! MPI
       if(mype == 0) read(nf) e_mpi                   ! MPI
    end do

    deallocate(wf_l)                                    ! MPI
    deallocate(n_mpi); deallocate(n2_mpi)               ! MPI
    deallocate(e_mpi); deallocate(e2_mpi)               ! MPI

!!$    write(nfout,'(" ---<< m_ESIO_rd_WFs_and_EVs_ek>>---")')
  end subroutine m_ESIO_rd_WFs_and_EVs_ek

  subroutine m_ESIO_rd_EVs_ek(nfout,nf)
    integer, intent(in) :: nfout,nf
    integer  :: ik, ie, iks
    integer, allocatable, dimension(:,:) :: n_mpi, n2_mpi  ! MPI
    real(DP),allocatable, dimension(:,:) :: e_mpi, e2_mpi  ! MPI

    allocate(n_mpi(neg,nspin)); allocate(n2_mpi(neg,nspin)) ! MPI
    allocate(e_mpi(neg,nspin)); allocate(e2_mpi(neg,nspin)) ! MPI
    allocate(wf_l(kg1,kimg))
    n_mpi =0; n2_mpi = 0
    e_mpi =0; e2_mpi = 0; wf_l = 0

    if(ipri >= 1) write(nfout,*) ' !D Reading zaj <<m_ESIO_rd_EVs_ek>>'

    rewind nf

    eko_ek = 0.d0
!!$    do ik = 1, nk_in_the_process-kv3, kv3
    do ik = 1, nk_in_the_process - nspin, nspin
       if(ipri >= 1) write(nfout,*) ' !D     skipping ik = ', ik
!!$       do iks = 1, kv3, af+1
       do iks = 1, nspin, af+1
          do ie = 1, neg
             if(mype == 0) read(nf) wf_l
          end do
       end do
       if(mype == 0) read(nf) n_mpi
       if(mype == 0) read(nf) n2_mpi
       if(mype == 0) read(nf) e_mpi

       if(mype == 0) then
          do iks = 1, nspin
             do ie = 1, neg
                eko_ek(ie,ik+iks-1) = e_mpi(n_mpi(ie,iks),iks)
             end do
          end do
          if(ipri >= 3) then
             do iks=1,nspin
                write(nfout,'(" ik = ",i5)') ik+iks-1
                write(nfout,'(8f8.4)') (e_mpi(n_mpi(ie,iks),iks),ie=1,neg)
             end do
          end if
       end if
    end do
       
    write(nfout,'(" ---<< m_ESIO_rd_EVs_ek>>---")')
  end subroutine m_ESIO_rd_EVs_ek

  subroutine m_ESIO_wd_Psicoef(ipri,nfout,nf)
    integer, intent(in) :: ipri,nfout, nf

    integer, parameter :: Ncol = 5
    integer :: ik, ie, ri,  nel, ig, ib,ib1,ib2,ibt,ibsize
    integer, allocatable, dimension(:) :: n_mpi
    real(DP),allocatable, dimension(:) :: e_mpi
    real(DP),allocatable, dimension(:,:,:) :: wf

    integer :: id_sname = -1
    call tstatc0_begin('m_ESIO_wd_Psicoef ',id_sname)

    allocate(e_mpi(neg)); e_mpi = 0.d0
    allocate(n_mpi(neg)); n_mpi = 0

    if(mype == 0) write(nf,'(" !!COEFFICIENTS of WAVE functions")')

    KPOINT: do ik = 1, kv3, af+1
       nel = min(Nw_Psicoef,iba(ik))
       allocate(wf_l(nel,kimg)); wf_l = 0.d0
       call wd_k_points()
       e_mpi = 0.d0
       n_mpi = 0
       if(map_k(ik) == myrank_k) then
          if(ipri>=1) then
             write(nfout,'(" ik = ", i4, " neordr ")') ik
             write(nfout,'(8i8)') (neordr(ie,ik),ie=1,neg)
          end if
          do ie = 1, neg
!!$             if(map_ek(ie,ik) == mype) n_mpi(ie) = neordr(ie,ik)
             n_mpi(ie) = neordr(ie,ik)
             if(map_e(ie) /= myrank_e) cycle
             e_mpi(ie) = eko_l(map_z(ie),ik)
          end do
       end if
       if(npes>=2) call mpi_allreduce(MPI_IN_PLACE,e_mpi,neg,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
       if(nrank_k>=2) then
          if(map_ek(1,ik) == mype .and. map_ek(1,ik) /= 0) then
             call mpi_send(n_mpi,neg,mpi_integer,0,1,mpi_comm_group,ierr)
          else if(mype == 0 .and. map_ek(1,ik) /= 0) then
             call mpi_recv(n_mpi,neg,mpi_integer,map_ek(1,ik),1,mpi_comm_group,istatus,ierr)
          end if
!!$          call mpi_allreduce(MPI_IN_PLACE,n_mpi,neg,mpi_integer,mpi_sum,mpi_comm_group,ierr)
       end if
       do ie = 1, neg, Ncol
          ib1 = ie; ib2 = min(ie+Ncol-1,neg)
          ibsize = ib2-ib1+1
          if(mype == 0) then
             allocate(wf(nel,kimg,ibsize)); wf=0.d0
          end if
          do ib = ib1, ib2
!!$             ibt = n_mpi(ib)
             ibt = ib
             if(map_ek(ibt,ik) == mype) then                          ! MPI
                do ri = 1, kimg
                   wf_l(1:nel,ri) = zaj_l(1:nel,map_z(ibt),ik,ri)
                end do
                if(map_ek(ibt,ik) /= 0) &                             ! MPI
                     &   call mpi_send(wf_l,nel*kimg,mpi_real,0,1,mpi_comm_group,ierr) ! MPI
             else if(mype == 0 .and. map_ek(ibt,ik) /= 0) then
                call mpi_recv(wf_l,nel*kimg,mpi_real,map_ek(ibt,ik),1,mpi_comm_group,istatus,ierr)!MPI
             end if
             if(mype == 0) wf(:,:,ib-ib1+1) = wf_l(:,:)
          end do
          call wd_eko(ib1,ib2)
!!$          if(ik <= 2) then
             do ig = 1, nel
                call wd_coef(ibsize,ig)
             end do
!!$          end if
          if(mype == 0) deallocate(wf)
       end do
       deallocate(wf_l)
    end do KPOINT

    call tstatc0_end(id_sname)
  contains
    subroutine wd_coef(ibsize,ig)
      integer, intent(in) :: ibsize,ig
      integer :: ib
!!$      character(3) :: nan
      if(mype == 0) then
         if(kimg==2) then
            write(nf,'(i4," ( ",3i4," )", 5(" (",2f11.5," )"))') &
                 & ig, ngabc(nbase(ig,ik),1:3),(wf(ig,1,ib),wf(ig,2,ib),ib=1,ibsize)
!!$                 & ig, ngabc(nbase(ig,ik),1:3),(wf(ig,1,ie),wf(ig,2,ie),ie=1,3)
         else
!!$            nan="---"
            write(nf,'(i4," ( ",3i4," )", 5(" (",f11.5,4x,"---",4x," )"))') &
                 & ig, ngabc(nbase(ig,ik),1:3),(wf(ig,1,ib),ib=1,ibsize)
!!$            write(nf,'(i4," ( ",3i4," )", 5f11.5)') &
!!$                 & ig, ngabc(nbase(ig,ik),1:3),(wf(ig,1,ie),ie=1,ibsize)
         end if
      end if
    end subroutine wd_coef

    subroutine wd_eko(ib1,ib2)
      integer, intent(in) :: ib1,ib2
      integer :: ie
      if(mype == 0) then
         write(nf,'(a12,5x,a5,5(i7,2x,f10.5,7x))') "ig", "\ e: ", (ie,e_mpi(n_mpi(ie)),ie=ib1,ib2)
      end if
    end subroutine wd_eko

    subroutine wd_k_points()
      if(mype == 0) then
         if(nspin == 1) then
            write(nf,'(" ik = ",i6,"    ( ",3f14.6," )")') ik,(vkxyz(ik,1:3,BUCS))
         else
            if(mod(ik,2) == 1) then
               write(nf,'(" ik = ",i6,"    UP ","    ( ",3f14.6," )")') ik,(vkxyz(ik,1:3,BUCS))
            else
               write(nf,'(" ik = ",i6,"  DOWN ","    ( ",3f14.6," )")') ik,(vkxyz(ik,1:3,BUCS))
            end if
         end if
      end if
    end subroutine wd_k_points
  end subroutine m_ESIO_wd_Psicoef

  subroutine m_ESIO_wd_WFs_and_EVs_ek(nfout,nf)
    integer, intent(in) :: nfout, nf
    integer  :: ik, ie, ri, ikg, ikt
    integer, allocatable, dimension(:,:) :: n_mpi
    real(DP),allocatable, dimension(:,:) :: e_mpi
    integer :: id_sname = -1
    call tstatc0_begin('m_ESIO_wd_WFs_and_EVs_ek ',id_sname)

    allocate(wf_l(kg1,kimg));    wf_l = 0
    call mpi_barrier(mpi_comm_group,ierr)
    if(ipri>=2) write(nfout,'(" !D Writing WaveFunctions ")')

    allocate(n_mpi(neg,nspin)); n_mpi = 0
    allocate(e_mpi(neg,nspin)); e_mpi = 0.d0

    KPOINT: do ikg = 1, nrank_k
       ! ---> zaj_l
       if((ikg-1)*nspin + 1 > kv3) then
          if(ipri >= 1) write(nfout,'(" !D ik > kv3")')
          exit KPOINT
       end if

       do ikt = 1, nspin, af+1
          ik = (ikg-1)*nspin + ikt
          if(ipri>=1) write(nfout,'(" !D Writing WaveFunctions ik = ",i5)') ik
          do ie = 1, neg
             if(map_ek(ie,ik) == mype) then                          ! MPI
                do ri = 1, kimg
                   wf_l(1:kg1,ri) = zaj_l(1:kg1,map_z(ie),ik,ri)
                end do
                if(map_ek(ie,ik) /= 0) &                             ! MPI
                     &   call mpi_send(wf_l,kg1*kimg,mpi_real,0,1,mpi_comm_group,ierr) ! MPI
             else if(mype == 0 .and. map_ek(ie,ik) /= 0) then
                call mpi_recv(wf_l,kg1*kimg,mpi_real,map_ek(ie,ik),1,mpi_comm_group,istatus,ierr)!MPI
             end if
             if(mype == 0) write(nf)  wf_l                        ! MPI
          end do
       end do

       ! --->  neordr
       n_mpi = 0                                          ! MPI
       do ikt = 1, nspin                                  ! MPI
          ik = (ikg-1)*nspin + ikt
          if(map_k(ik) /= myrank_k) cycle                 ! MPI
          n_mpi(1:neg,ikt) = neordr(1:neg,ik)             ! MPI
       end do                                             ! MPI
       if(npes >= 2) then
          call mpi_allreduce(MPI_IN_PLACE,n_mpi,neg*nspin,mpi_integer,mpi_sum &
               &                      ,mpi_comm_group,ierr)  ! MPI
          n_mpi = n_mpi/nrank_e
       end if
       if(ipri>=2) write(nfout,'(" !D Writing neordr ik = ",i5)') ik
       if(mype == 0) write(nf) n_mpi             ! MPI ; writing (neordr)

       ! --->  nrvf_ordr
       n_mpi = 0                                          ! MPI
       do ikt = 1, nspin                                  ! MPI
          ik = (ikg-1)*nspin + ikt
          if(map_k(ik) /= myrank_k) cycle                 ! MPI
          n_mpi(1:neg,ikt) = nrvf_ordr(1:neg,ik)          ! MPI
       end do                                             ! MPI
       if(npes >= 2) then
          call mpi_allreduce(MPI_IN_PLACE,n_mpi,neg*nspin,mpi_integer,mpi_sum &
               &                      ,mpi_comm_group,ierr)  ! MPI
          n_mpi = n_mpi/nrank_e
       end if
       if(ipri>=2) write(nfout,'(" !D Writing nrvf_ordr ik = ",i5)') ik
       if(mype == 0) write(nf) n_mpi             ! MPI ; writing (nrvf_ordr)

       e_mpi = 0.d0                                       ! MPI
       do ikt = 1, nspin                                  ! MPI
          ik = (ikg-1)*nspin + ikt
          if(map_k(ik) /= myrank_k) cycle                 ! MPI
          do ie = 1, neg                                  ! MPI
             if(map_e(ie) /= myrank_e) cycle              ! MPI
             e_mpi(ie,ikt) = eko_l(map_z(ie),ik)           ! MPI
          end do
       end do
       if(npes >= 2) then
          call mpi_allreduce(MPI_IN_PLACE,e_mpi,neg*nspin,mpi_double_precision &
               &               ,mpi_sum,mpi_comm_group,ierr) ! MPI
       end if
       if(ipri>=2) write(nfout,'(" !D Writing eko_l ik = ",i5)') ik
       if(mype == 0) write(nf) e_mpi             ! MPI ; writing (eko_l)
    end do KPOINT

!!$    do ik = 1, kv3, af+1
!!$       do ie = 1, neg
!!$          if(map_ek(ie,ik) == mype) then                          ! MPI
!!$             do ri = 1, kimg
!!$                wf_l(1:kg1,ri) = zaj_l(1:kg1,map_z(ie),ik,ri)
!!$             end do
!!$             if(map_ek(ie,ik) /= 0) &                             ! MPI
!!$            &   call mpi_send(wf_l,kg1*kimg,mpi_real,0,1,mpi_comm_group,ierr) ! MPI
!!$          else if(mype == 0 .and. map_ek(ie,ik) /= 0) then
!!$             call mpi_recv(wf_l,kg1*kimg,mpi_real,map_ek(ie,ik),1,mpi_comm_group,istatus,ierr)!MPI
!!$          end if
!!$          if(mype == 0) write(nf)  wf_l                        ! MPI
!!$       end do
!!$    end do
!!$    deallocate(wf_l)
!!$
!!$    allocate(n_mpi(neg,kv3)); allocate(n2_mpi(neg,kv3))! MPI
!!$    allocate(e_mpi(neg,kv3)); allocate(e2_mpi(neg,kv3))! MPI
!!$
!!$    n_mpi = 0                                          ! MPI
!!$    do ik = 1, kv3                                     ! MPI
!!$       if(map_k(ik) /= myrank_k) cycle                 ! MPI
!!$       n_mpi(1:neg,ik) = neordr(1:neg,ik)              ! MPI
!!$    end do                                             ! MPI
!!$    if(npes >= 2) then
!!$       call mpi_allreduce(n_mpi,n2_mpi,neg*kv3,mpi_integer,mpi_sum &
!!$            &                      ,mpi_comm_group,ierr)  ! MPI
!!$       n2_mpi = n2_mpi/nrank_e
!!$    else
!!$       n2_mpi = n_mpi
!!$    end if
!!$    if(mype == 0) write(nf) n2_mpi             ! MPI ; writing (neordr)
!!$
!!$    n_mpi = 0                                          ! MPI
!!$    do ik = 1, kv3                                     ! MPI
!!$       if(map_k(ik) /= myrank_k) cycle                 ! MPI
!!$       n_mpi(1:neg,ik) = nrvf_ordr(1:neg,ik)           ! MPI
!!$    end do                                             ! MPI
!!$    if(npes >= 2) then
!!$       call mpi_allreduce(n_mpi,n2_mpi,neg*kv3,mpi_integer,mpi_sum &
!!$            &                      ,mpi_comm_group,ierr)  ! MPI
!!$       n2_mpi = n2_mpi/nrank_e
!!$    else
!!$       n2_mpi = n_mpi
!!$    end if
!!$    if(mype == 0) write(nf) n2_mpi             ! MPI ; writing (nrvf_ordr)
!!$
!!$    e_mpi = 0.d0                                       ! MPI
!!$    do ik = 1, kv3                                     ! MPI
!!$       if(map_k(ik) /= myrank_k) cycle                 ! MPI
!!$       do ie = 1, neg                                  ! MPI
!!$          if(map_e(ie) /= myrank_e) cycle              ! MPI
!!$          e_mpi(ie,ik) = eko_l(map_z(ie),ik)           ! MPI
!!$       end do
!!$    end do
!!$    if(npes >= 2) then
!!$       call mpi_allreduce(e_mpi,e2_mpi,neg*kv3,mpi_double_precision &
!!$            &               ,mpi_sum,mpi_comm_group,ierr) ! MPI
!!$    else
!!$       e2_mpi = e_mpi
!!$    end if
!!$    if(mype == 0) write(nf) e2_mpi             ! MPI ; writing (eko_l)

!!$    e_mpi = 0.d0                                       ! MPI
!!$    do ik = 1, kv3                                     ! MPI
!!$       if(map_k(ik) /= myrank_k) cycle                 ! MPI
!!$       do ie = 1, neg                                  ! MPI
!!$          if(map_e(ie) /= myrank_e) cycle              ! MPI
!!$          e_mpi(ie,ik) = occup_l(map_z(ie),ik)         ! MPI
!!$       end do                                          ! MPI
!!$    end do                                             ! MPI
!!$    if(npes >= 2) then
!!$       call mpi_allreduce(e_mpi,e2_mpi,neg*kv3,mpi_double_precision &
!!$            &                  ,mpi_sum,mpi_comm_group,ierr) ! MPI
!!$    else
!!$       e2_mpi = e_mpi
!!$    end if
!!$    if(mype == 0) write(nf) e2_mpi             ! MPI ; writing (occup_l)

    deallocate(wf_l)
    deallocate(n_mpi)
    deallocate(e_mpi)

    call tstatc0_end(id_sname)

  end subroutine m_ESIO_wd_WFs_and_EVs_ek

  subroutine m_ESIO_wd_WFn(nfout,nfwfk,ik,ib)
    integer, intent(in) :: nfout,nfwfk
    integer, intent(in) :: ik,ib
    integer :: jb,ri
    real(kind=DP), allocatable :: bfft(:)
    real(kind=DP) :: eig
    integer :: id_sname = -1
    call tstatc0_begin('m_ESIO_wd_WFn ',id_sname)

    allocate(bfft(nfft));    bfft = 0
    call mpi_barrier(mpi_comm_group,ierr)
    if(ipri >= 1) write(nfout,*) ' !D Writing Wavefunctions '
    rewind nfwfk
    jb = neordr(ib,ik)
    if(map_ek(jb,ik) == mype) then                          ! MPI
       call m_ES_WF_in_Rspace(ik,jb,bfft)
       eig = eko_l(map_z(jb),ik)
       if(map_ek(jb,ik) /= 0) then                             ! MPI
          call mpi_send(bfft,nfft,mpi_double_precision,0,1,mpi_comm_group,ierr) ! MPI
          call mpi_send(eig,1,mpi_double_precision,0,1,mpi_comm_group,ierr) ! MPI
       end if
    else if(mype == 0 .and. map_ek(jb,ik) /= 0) then
       call mpi_recv(bfft,nfft,mpi_double_precision,map_ek(jb,ik),1,mpi_comm_group,istatus,ierr)!MPI
       call mpi_recv(eig,1,mpi_double_precision,map_ek(jb,ik),1,mpi_comm_group,istatus,ierr)!MPI
    end if
    if(mype == 0) then                     ! MPI
       call wd_wf(nfout,nfwfk,ik,ib,eig)
    end if
    deallocate(bfft)
    call tstatc0_end(id_sname)
  contains
    subroutine wd_wf(nfout,nfwfk,ik,ib,eig)
      integer, intent(in) :: nfout,nfwfk,ik,ib
      real(kind=DP), intent(in) :: eig
      integer :: i,j,k, id, nl, nm, nn, nlhf,inew,jnew,knew,ip,mm
      real(kind=DP),allocatable,dimension(:,:,:,:) :: wkwf
      real(kind=DP) ::      x,y,z
      integer, parameter :: UP = 1 , DOWN = 2
      integer ::            up_down
      real(kind=DP),allocatable,dimension(:,:) :: cps_full
      integer, allocatable,dimension(:) :: ityp_full
      integer :: m, nk
      real(kind=DP) :: norm
      real(kind=DP) :: normr,normi
      integer :: n1,n2,n3
      real(kind=DP) :: dn1,dn2,dn3
      integer :: icomp

      id = fft_box_size_WF(1,0)
      mm = fft_box_size_WF(2,0)
      nl = fft_box_size_WF(1,1)
      nm = fft_box_size_WF(2,1)
      nn = fft_box_size_WF(3,1)

      if(kimg == 1) then
         nlhf = id/2
      else
         nlhf = id
      end if

      if(wf_filetype == DENSITY_ONLY &
      & .or. wf_filetype == VTK &
      & .or. wf_filetype == BINARY) then
         allocate(wkwf(nl,nm,nn,2)); wkwf = 0.d0
      else if(wf_filetype == CUBE) then
         allocate(wkwf(nn,nm,nl,2)); wkwf = 0.d0
      end if

      if(nspin==2) then
         if(mod(ik/nspin,2) == 1) then
            up_down = UP
         else
            up_down = DOWN
         end if
      end if
      nk = (ik-1)/nspin+1

      if(ipri >= 2) write(nfout,9001) nl*nm*nn, nl, nm, nn
9001  format(' Wavefunction ',i8,'(',3i5,')')

      if(ipri >= 2) write(nfout,*) ' !D FFT cube mapping start'
      do i = 1, nm
         do j = 1, nn
            do k = 1, nl
               if(kimg == 1 .and. k > nlhf) then
                  knew = id - k
                  jnew = nn+2 - j
                  inew = nm+2 - i
                  if(jnew > nn) then
                     jnew = jnew - nn
                  end if
                  if(inew > nm) then
                     inew = inew - nm
                  end if
               else
                  knew = k; jnew = j; inew = i
               end if
               ip = nlhf*mm*(jnew-1) + nlhf*(inew-1) + knew
               if(wf_filetype == DENSITY_ONLY &
               & .or. wf_filetype == VTK &
               & .or. wf_filetype == BINARY) then
                  wkwf(k,i,j,1) = bfft(ip*2-1)
                  wkwf(k,i,j,2) = bfft(ip*2)
               else if(wf_filetype == CUBE) then
                  wkwf(j,i,k,1) = bfft(ip*2-1)
                  wkwf(j,i,k,2) = bfft(ip*2)
               end if
            end do
         end do
      end do
! Normalization
      normr = 0.d0
      normi = 0.d0
      do i = 1, nm
         do j = 1, nn
            do k = 1, nl
               if(wf_filetype == DENSITY_ONLY &
               & .or. wf_filetype == VTK &
               & .or. wf_filetype == BINARY) then
                  normr = normr + wkwf(k,i,j,1)*wkwf(k,i,j,1)
                  normi = normi + wkwf(k,i,j,2)*wkwf(k,i,j,2)
               else if(wf_filetype == CUBE) then
                  normr = normr + wkwf(j,i,k,1)*wkwf(j,i,k,1)
                  normi = normi + wkwf(j,i,k,2)*wkwf(j,i,k,2)
               end if
            end do
         end do
      end do
      norm = normr + normi
      write(nfout,*) 'Real and imaginary parts of wf = ',normr/norm,normi/norm
      if(wf_filetype == VTK .or. wf_filetype == BINARY) then
         if(normr>normi) then
            norm = normr
            icomp = 1
            write(nfout,*) 'Real part of wf will be outputed.'
         else
            norm = normi
            icomp = 2
            write(nfout,*) 'Imaginary part of wf will be outputed.'
         end if
      end if
      norm = univol*norm/dble(nm*nn*nl)
      norm = 1.d0/dsqrt(norm)
      do i = 1, nm
         do j = 1, nn
            do k = 1, nl
               if(wf_filetype == DENSITY_ONLY &
               & .or. wf_filetype == VTK &
               & .or. wf_filetype == BINARY) then
                  wkwf(k,i,j,1) = norm*wkwf(k,i,j,1)
                  wkwf(k,i,j,2) = norm*wkwf(k,i,j,2)
               else if(wf_filetype == CUBE) then
                  wkwf(j,i,k,1) = norm*wkwf(j,i,k,1)
                  wkwf(j,i,k,2) = norm*wkwf(j,i,k,2)
               end if
            end do
         end do
      end do

      if(wf_filetype == DENSITY_ONLY) then
         write(nfwfk,9001) nl*nm*nn, nl, nm, nn
         write(nfwfk,'(6e13.5)') wkwf
      else if(wf_filetype == BINARY) then
         write(nfwfk) nl*nm*nn, nl, nm, nn
         write(nfwfk) altv, nspin, up_down, nk, ib, eig
         write(nfwfk) wkwf(:,:,:,icomp)
      else if(wf_filetype == VTK) then
         write(nfwfk,'("# vtk DataFile Version 2.0")')
         if(nspin == 2) then
            if(up_down == 1) then
               write(nfwfk,'(" SCF Wavefunction UP : k=",i7," n=",i7," eig=",f20.5)') nk,ib,eig
            else
               write(nfwfk,'(" SCF Wavefunction DOWN : k=",i7," n=",i7," eig=",f20.5)') nk,ib,eig
            end if
         else
            write(nfwfk,'(" SCF Wavefunction : k=",i7," n=",i7," eig=",f20.5)') nk, ib, eig
         end if
         write(nfwfk,'("ASCII")')
         write(nfwfk,'("DATASET STRUCTURED_GRID")')
         write(nfwfk,'("DIMENSIONS",3(1x,i5))') nl+1,nm+1,nn+1
         write(nfwfk,'("POINTS",1x,i10,1x,"float")') (nl+1)*(nm+1)*(nn+1)
         do n1=0,nl
            do n2=0,nm
               do n3=0,nn
                  dn1 = n1/dble(nl)
                  dn2 = n2/dble(nm)
                  dn3 = n3/dble(nn)
                  x = altv(1,1)*dn1 + altv(1,2)*dn2 + altv(1,3)*dn3
                  y = altv(2,1)*dn1 + altv(2,2)*dn2 + altv(2,3)*dn3
                  z = altv(3,1)*dn1 + altv(3,2)*dn2 + altv(3,3)*dn3
                  write(nfwfk,'(3(1x,e13.5))') x,y,z
               end do
            end do
         end do
         write(nfwfk,'("")')
         write(nfwfk,'("POINT_DATA",1x,i10)') (nl+1)*(nm+1)*(nn+1)
         write(nfwfk,'("SCALARS scalars float")')
         write(nfwfk,'("LOOKUP_TABLE default")')
         do n1=0,nl
            i=n1+1
             if(n1==nl) i=1
            do n2=0,nm
               j=n2+1
               if(n2==nm) j=1
               do n3=0,nn
                  k=n3+1
                  if(n3==nn) k=1
                  write(nfwfk,'(e13.5)') wkwf(i,j,k,icomp)
               end do
            end do
         end do
      else if(wf_filetype == CUBE) then
         if(len_trim(wf_title) >= 1) then
            write(nfwfk,*) trim(wf_title)
         else
            write(nfwfk,'(" Calculated by phase")')
         end if
         if(nspin == 2) then
            if(up_down == 1) then
               write(nfwfk,'(" SCF Wavefunction UP : k=",i7," n=",i7," eig=",f20.5)') nk,ib,eig
            else
               write(nfwfk,'(" SCF Wavefunction DOWN : k=",i7," n=",i7," eig=",f20.5)') nk,ib,eig
            end if
         else
            write(nfwfk,'(" SCF Wavefunction : k=",i7," n=",i7," eig=",f20.5)') nk, ib, eig
         end if
         x = 0.d0; y = 0.d0; z = 0.d0
         write(nfwfk,'(i6,3f10.4)') -natm2, x,y,z
         do i = 1, 3
            write(nfwfk,'(i6,3f10.6)') fft_box_size_WF(i,1), altv(1:3,i)/dble(fft_box_size_WF(i,1))
         end do

         allocate(cps_full(natm2,3))
         allocate(ityp_full(natm2))
         cps_full = 0; ityp_full = 0
         call m_IS_pack_all_ions_in_uc(ityp_full,cps_full)
         do i = 1, natm2
            m = ityp_full(i)
            write(nfwfk,'(f8.4,4f10.6)') iatomn(m), ival(m), cps_full(i,1:3)
         end do
         deallocate(ityp_full,cps_full)

         write(nfwfk,'(10i5)') 2,1,2
         write(nfwfk,'(6e13.5)') wkwf(:,:,:,1)
         write(nfwfk,'(6e13.5)') wkwf(:,:,:,2)
  
      end if
      if(allocated(wkwf)) deallocate(wkwf)
    end subroutine wd_wf
  end subroutine m_ESIO_wd_WFn

  logical function m_ESIO_check_energy(ik,ib)
    integer, intent(in) :: ik,ib
    integer :: jb
    real(kind=DP) :: eig
    jb = neordr(ib,ik)
    if(map_ek(jb,ik) == mype) then
       eig = eko_l(map_z(jb),ik)
       if(eig >= eigmin_wf .and. eig <= eigmax_wf) then
          m_ESIO_check_energy = .true.
       else
          m_ESIO_check_energy = .false.
       end if
    end if
    call mpi_bcast(m_ESIO_check_energy,1,mpi_logical,map_ek(jb,ik),mpi_comm_group,ierr) ! MPI
  end function m_ESIO_check_energy

  subroutine m_ESIO_wd_efermi(nfout,nfefermi)
    integer, intent(in) :: nfout, nfefermi
#ifdef __TIMER_SUB__
  call timer_sta(1377)
#endif

    if(mype == 0) then
#ifdef __TIMER_IODO__
  call timer_sta(1460)
#endif
       write(nfefermi,'(f16.8," : Efermi")') efermi
       if(sw_fix_total_spin == YES .and. nspin == 2) then
          write(nfefermi,'(2f16.8," : Ffermi_spin(1), Efermi_spin(2)")') &
               & efermi_spin(1),efermi_spin(2)
       end if
#ifdef __TIMER_IODO__
  call timer_end(1460)
#endif
    end if
#ifdef __TIMER_SUB__
  call timer_end(1377)
#endif
  end subroutine m_ESIO_wd_efermi

  subroutine m_ESIO_rd_Efermi(nfout,nfefermi)
    integer, intent(in) :: nfout, nfefermi
#ifdef __TIMER_SUB__
  call timer_sta(1376)
#endif
    if(mype == 0) then
#ifdef __TIMER_IODO__
  call timer_sta(1458)
#endif
       read(nfefermi,*,err=1001,end=1001) efermi
       write(nfout,'(" ! efermi = ",f16.8," : this is read from nfefermi")') efermi
       if(sw_fix_total_spin == YES .and. nspin == 2) then
          read(nfefermi,*,err=1002,end=1002) efermi_spin(1),efermi_spin(2)
          write(nfout,'(" ! efermi_spin = ",2f16.8," : these are read from nfefermi")') efermi_spin(1:2)
       end if
#ifdef __TIMER_IODO__
  call timer_end(1458)
#endif
       goto 1010
1001   continue
       efermi = 0.d0
1002   continue
       if(sw_fix_total_spin == YES .and. nspin == 2) then
          efermi_spin(1) = 0.d0; efermi_spin(2) = 0.d0
       end if
1010   continue
    end if
    if(npes > 1) then
#ifdef __TIMER_IOCOMM__
  call timer_barrier(mpi_comm_group)
  call timer_sta(1459)
#endif
       call mpi_bcast(efermi,1,mpi_double_precision,0,mpi_comm_group,ierr)
       if(sw_fix_total_spin == YES .and. nspin == 2) then
          call mpi_bcast(efermi_spin,2,mpi_double_precision,0,mpi_comm_group,ierr)
       end if
#ifdef __TIMER_IOCOMM__
  call timer_end(1459)
#endif
    end if
#ifdef __TIMER_SUB__
  call timer_end(1376)
#endif
  end subroutine m_ESIO_rd_Efermi


end module m_ES_IO

!=======================================================================
!
!  PROGRAM  PHASE/0 2014.01 (rev.375)
!
!  "First-principles Electronic Structure Calculation Program"
!
!  SUBROUINE: ChargeDensity_Construction, FermiEnergyLevel, 
!             CD_Softpart_plus_Hardpart
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!  
!
!=======================================================================
!
!   The original version of this set of the computer programs "PHASE" was developed by 
!  the members of the Theory Group of Joint Research Center for Atom Technology 
!  (JRCAT), based in Tsukuba, in the period 1993-2001.  
!   Since 2002, this program set had been intensively developed as a part of the following 
!  national projects supported by the Ministry of Education, Culture, Sports, Science and 
!  Technology (MEXT) of Japan; "Frontier Simulation Software for Industrial Science 
!  (FSIS)" from 2002 to 2005, "Revolutionary Simulation Software (RSS21)" from 2006 to 
!  2008. "Research and Development of Innovative Simulation Software (RISS)" from 2008 
!  to 2013. These projects is lead by the Center for Research on Innovative Simulation 
!  Software (CISS), the Institute of Industrial Science (IIS), the University of Tokyo.
!   Since 2013, this program set has been further developed centering on PHASE System 
!  Consortium. 
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
subroutine ChargeDensity_Construction(ic)
! $Id: ChargeDensity_Construction.F90 238 2012-11-12 04:11:13Z yamasaki $
  use m_Total_Energy,         only : m_TE_total_energy, ehartr
  use m_Charge_Density,       only : m_CD_convergence_check &
       &                           , m_CD_softpart, m_CD_hardpart &
       &                           , chgq_l &
       &                           , m_CD_hardpart_hsr
  use m_ES_occup,             only : m_ESoc_fermi_parabolic, m_ESoc_fermi_tetrahedron &
       &                           , m_ESoc_fermi_ColdSmearing, m_ESoc_check_num_bands &
       &                           , m_ESoc_occup_fix
  use m_ES_IO,                only : m_ESIO_wd_EigenValues
  use m_Kpoints,              only : kv3
  use m_Files,                only : nfout
  use m_Crystal_Structure,    only : sw_bandgap_constraint, imag
  use m_Control_Parameters,   only : iprieigenvalue, projector_type, num_projectors &
       &                           , sw_hubbard, alpha_hubbard, icond, ekmode &
#ifdef ENABLE_ESM_PACK
       &                           , m_CtrlP_way_of_smearing,sw_esm, kimg, nspin
#else
       &                           , m_CtrlP_way_of_smearing
#endif
  use m_Const_Parameters,     only : PARABOLIC, MP, TETRAHEDRON, COLD, YES, OFF, ON &
       &                           , SPHERICAL_HARMONICS, ATOMIC_ORBITAL &
       &                           , INITIAL,CONTINUATION,FIXED_CHARGE,FIXED_CHARGE_CONTINUATION,CMPLDP
  !!$use m_Orbital_Population,   only : m_OP_mix_om

! ============================= added by K. Tagami =================== 5.0
  use m_Control_Parameters,  only : sw_eval_energy_before_charge, &
       &                            sw_update_charge_total
! ==================================================================== 5.0

  use m_Parallelization,      only : ista_kngp,iend_kngp,mpi_comm_group,mype

! =========================================== added by K. Tagami ========== 11.0
  use m_Control_Parameters,      only : noncol
  use m_Charge_Density,        only : m_CD_hardpart_hsr_noncl, &
       &                              m_CD_softpart_noncl, &
       &                              m_CD_hardpart_noncl
  use m_Total_Energy,          only : m_TE_total_energy_noncl
! ========================================================================= 11.0


  use m_PlaneWaveBasisSet,       only : kgp,ngabc,igfp_l
  use m_Electronic_Structure,    only : vlhxc_l 
  use m_FFT,                     only : fft_box_size_CD

  implicit none
  include 'mpif.h'

  integer, intent(in) :: ic
  logical             :: display_on, enough_bands
  complex(kind=CMPLDP),allocatable,dimension(:) :: vhar
  complex(kind=CMPLDP),allocatable, dimension(:,:) :: chgc
  integer :: ig,is,nfftcd,ierr
#ifdef __TIMER_SUB__
  call timer_sta(701)
#endif

  if(ic == 0) display_on = .true.
  if(ic /= 0) display_on = .false.


  enough_bands = m_ESoc_check_num_bands()
  if(enough_bands) then
     call FermiEnergyLevel()            ! -(contained here)
  else
     if(iprieigenvalue >= 1) write(nfout,'(" the number of bands is not enough")')
     stop ' the number of bands is not enough'
  end if

! =================== added by K. Tagami ============ 5.0
  if ( sw_eval_energy_before_charge == ON ) then
! ================================= modified by K.Tagami ====== 11.0
!     call m_TE_total_energy(nfout,display_on,kv3)
!
     if ( noncol ) then
        call m_TE_total_energy_noncl(nfout,display_on,kv3)
     else
        call m_TE_total_energy(nfout,display_on,kv3)
     endif
! ============================================================= 11.0
  endif
! =================================================== 5.0

! ======================== modified by K. Tagami ======= 5.0
!  if(icond == INITIAL .or. icond == CONTINUATION) then
!     call CD_Softpart_plus_Hardpart()   ! -(contained here)
!     if(ic == 0) call m_CD_conversion_check(nfout)
!  else if ((icond==FIXED_CHARGE.or.icond==FIXED_CHARGE_CONTINUATION).and.ekmode==OFF) then
!     call m_CD_hardpart_hsr(nfout,kv3)  ! fsr_l, fsi_l -> hsr
!  end if
  if ( sw_update_charge_total == ON ) then
     if ( icond == INITIAL .or. icond == CONTINUATION ) then
! ======================== modifided by K. Tagami ========================= 11.0
!       call CD_Softpart_plus_Hardpart()   ! -(contained here)
!
        if ( noncol ) then
           call CD_Softpart_plus_Hardpart_noncl()   ! -(contained here)
        else
           call CD_Softpart_plus_Hardpart()   ! -(contained here)
        endif
! ========================================================================= 11.0

        if ( ic == 0 ) call m_CD_convergence_check(nfout)
     else if ( ( icond==FIXED_CHARGE.or.icond==FIXED_CHARGE_CONTINUATION ) &
          &         .and. ekmode==OFF ) then
! ======================== modifided by K. Tagami ========================= 11.0
!!     call m_CD_hardpart_hsr(nfout,kv3)             ! fsr_l, fsi_l -> hsr
        if ( noncol ) then
           call m_CD_hardpart_hsr_noncl(nfout,kv3)
        else
           call m_CD_hardpart_hsr(nfout,kv3)             ! fsr_l, fsi_l -> hsr
        endif
! ========================================================================== 11.0
     end if
     call Renewal_of_OccMat( .false., OFF )            ! evaluated with new om, hsr
  endif
! ========================================================= 5.0


#ifdef ENABLE_ESM_PACK
     if(sw_esm==ON)then
         nfftcd = fft_box_size_CD(1,0)*fft_box_size_CD(2,0)*fft_box_size_CD(3,0)
         allocate(vhar(nfftcd));vhar=(0.d0,0.d0)
         allocate(chgc(iend_kngp-ista_kngp+1,nspin));chgc=(0.d0,0.d0)
         if(kimg==1)then
            do ig=ista_kngp,iend_kngp
               chgc(ig-ista_kngp+1,1:nspin) = dcmplx(chgq_l(ig,1,1:nspin),0.d0)
            enddo
         else
            do ig=ista_kngp,iend_kngp
               chgc(ig-ista_kngp+1,1:nspin) = dcmplx(chgq_l(ig,1,1:nspin),chgq_l(ig,2,1:nspin))
            enddo
         endif
         call esm_hartree(chgc,ehartr,vhar)
         ehartr  = 0.5d0*ehartr  !Ry -> Ha
         deallocate(chgc)
         deallocate(vhar)
     endif
#endif

! ===================== modified by K. Tagami ============ 5.0
!!!  call m_TE_total_energy(nfout,display_on,kv3)

  if ( sw_eval_energy_before_charge == OFF ) then
! ================================== modified by K. Tagami ================ 11.0
!     call m_TE_total_energy(nfout,display_on,kv3)
     if ( noncol ) then
        call m_TE_total_energy_noncl(nfout,display_on,kv3)
     else
        call m_TE_total_energy(nfout,display_on,kv3)
     endif
! ========================================================================== 11.0
  endif
! ======================================================== 5.0

  if(ic == 0) call m_ESIO_wd_EigenValues(nfout,iprieigenvalue,nooccupation=YES)


#ifdef __TIMER_SUB__
  call timer_end(701)
#endif
contains
  subroutine FermiEnergyLevel()
    integer :: way_of_smearing
#ifdef __TIMER_SUB__
  call timer_sta(702)
#endif
    way_of_smearing = m_CtrlP_way_of_smearing()
    if(way_of_smearing == PARABOLIC) then
       call m_ESoc_fermi_parabolic(nfout)
!!$  else if(way_of_smearing == MP) then
!!$     call fermi_mesfessel_paxton(nfout)
    else if(way_of_smearing == TETRAHEDRON) then
        call m_ESoc_fermi_tetrahedron(nfout)
    else if(way_of_smearing == COLD) then
        call m_ESoc_fermi_ColdSmearing(nfout)
    end if
    if(sw_bandgap_constraint == ON) then
       call m_ESoc_occup_fix(nfout)
    end if
#ifdef __TIMER_SUB__
  call timer_end(702)
#endif
  end subroutine FermiEnergyLevel

  subroutine CD_Softpart_plus_Hardpart
! $Id: ChargeDensity_Construction.F90 238 2012-11-12 04:11:13Z yamasaki $
!fj#ifdef __TIMER_SUB__
!fj  call timer_sta(716)
!fj#endif
    call m_CD_softpart(nfout,kv3)
    call m_CD_hardpart(nfout,kv3)
!fj#ifdef __TIMER_SUB__
!fj  call timer_end(716)
!fj#endif
  end subroutine CD_Softpart_plus_Hardpart

! ============================ added by K. Tagami ============== 11.0
  subroutine CD_Softpart_plus_Hardpart_noncl
    call m_CD_softpart_noncl(nfout,kv3)
    call m_CD_hardpart_noncl(nfout,kv3)
  end subroutine CD_Softpart_plus_Hardpart_noncl
! ============================================================= 11.0

end subroutine ChargeDensity_Construction

!=======================================================================
!
!  PROGRAM  PHASE/0 2014.01 (rev.375)
!
!  "First-principles Electronic Structure Calculation Program"
!
!  SUBROUINE: Preparation_ep
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!   Since 2002, this program set had been intensively developed as a part of the following 
!  national projects supported by the Ministry of Education, Culture, Sports, Science and 
!  Technology (MEXT) of Japan; "Frontier Simulation Software for Industrial Science 
!  (FSIS)" from 2002 to 2005, "Revolutionary Simulation Software (RSS21)" from 2006 to 
!  2008. "Research and Development of Innovative Simulation Software (RISS)" from 2008 
!  to 2013. These projects is lead by the Center for Research on Innovative Simulation 
!  Software (CISS), the Institute of Industrial Science (IIS), the University of Tokyo.
!   Since 2013, this program set has been further developed centering on PHASE System 
!  Consortium. 
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
subroutine Preparation_ep
! $Id: Preparation_ep.f90 334 2013-07-18 14:15:28Z yamasaki $
  use m_Control_Parameters,only: m_CtrlP_set_wct_start
  use m_Files,             only: nfout
  use m_Crystal_Structure, only: nbztyp_spg, m_CS_alloc_op_tau &
       &                       , m_CS_gnrt_symmetry_operations
  use m_Ionic_System,      only: m_IS_alloc_napt &
       &                       , m_IS_symm_check_of_pos
  use m_Force,             only: m_Force_alloc

  implicit none

  call m_CtrlP_set_wct_start                   !  (ckcput)
!!$  if(nbztyp_spg >= GENERAL) call m_Files_open_
!!$  call m_CS_gnrt_symmetry_operations(.true.,nfout,nfspg)
  call m_CS_gnrt_symmetry_operations(.true.,nfout)
!!$  if(.not.paramset) then
     call m_CS_alloc_op_tau(nfout)
!!$     call m_CS_gnrt_symmetry_operations(.false.,nfout,nfspg)
     call m_CS_gnrt_symmetry_operations(.false.,nfout)
     call m_IS_alloc_napt()
     call m_IS_symm_check_of_pos()
!!$  end if
  call m_Force_alloc()
end subroutine Preparation_ep

      SUBROUTINE DSTEIN( N, D, E, M, W, IBLOCK, ISPLIT, Z, LDZ, WORK,
     $                   IWORK, IFAIL, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      INTEGER            INFO, LDZ, M, N
*     ..
*     .. Array Arguments ..
      INTEGER            IBLOCK( * ), IFAIL( * ), ISPLIT( * ),
     $                   IWORK( * )
      DOUBLE PRECISION   D( * ), E( * ), W( * ), WORK( * ), Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
*  DSTEIN computes the eigenvectors of a real symmetric tridiagonal
*  matrix T corresponding to specified eigenvalues, using inverse
*  iteration.
*
*  The maximum number of iterations allowed for each eigenvector is
*  specified by an internal parameter MAXITS (currently set to 5).
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The order of the matrix.  N >= 0.
*
*  D       (input) DOUBLE PRECISION array, dimension (N)
*          The n diagonal elements of the tridiagonal matrix T.
*
*  E       (input) DOUBLE PRECISION array, dimension (N)
*          The (n-1) subdiagonal elements of the tridiagonal matrix
*          T, in elements 1 to N-1.  E(N) need not be set.
*
*  M       (input) INTEGER
*          The number of eigenvectors to be found.  0 <= M <= N.
*
*  W       (input) DOUBLE PRECISION array, dimension (N)
*          The first M elements of W contain the eigenvalues for
*          which eigenvectors are to be computed.  The eigenvalues
*          should be grouped by split-off block and ordered from
*          smallest to largest within the block.  ( The output array
*          W from DSTEBZ with ORDER = 'B' is expected here. )
*
*  IBLOCK  (input) INTEGER array, dimension (N)
*          The submatrix indices associated with the corresponding
*          eigenvalues in W; IBLOCK(i)=1 if eigenvalue W(i) belongs to
*          the first submatrix from the top, =2 if W(i) belongs to
*          the second submatrix, etc.  ( The output array IBLOCK
*          from DSTEBZ is expected here. )
*
*  ISPLIT  (input) INTEGER array, dimension (N)
*          The splitting points, at which T breaks up into submatrices.
*          The first submatrix consists of rows/columns 1 to
*          ISPLIT( 1 ), the second of rows/columns ISPLIT( 1 )+1
*          through ISPLIT( 2 ), etc.
*          ( The output array ISPLIT from DSTEBZ is expected here. )
*
*  Z       (output) DOUBLE PRECISION array, dimension (LDZ, M)
*          The computed eigenvectors.  The eigenvector associated
*          with the eigenvalue W(i) is stored in the i-th column of
*          Z.  Any vector which fails to converge is set to its current
*          iterate after MAXITS iterations.
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z.  LDZ >= max(1,N).
*
*  WORK    (workspace) DOUBLE PRECISION array, dimension (5*N)
*
*  IWORK   (workspace) INTEGER array, dimension (N)
*
*  IFAIL   (output) INTEGER array, dimension (M)
*          On normal exit, all elements of IFAIL are zero.
*          If one or more eigenvectors fail to converge after
*          MAXITS iterations, then their indices are stored in
*          array IFAIL.
*
*  INFO    (output) INTEGER
*          = 0: successful exit.
*          < 0: if INFO = -i, the i-th argument had an illegal value
*          > 0: if INFO = i, then i eigenvectors failed to converge
*               in MAXITS iterations.  Their indices are stored in
*               array IFAIL.
*
*  Internal Parameters
*  ===================
*
*  MAXITS  INTEGER, default = 5
*          The maximum number of iterations performed.
*
*  EXTRA   INTEGER, default = 2
*          The number of iterations performed after norm growth
*          criterion is satisfied, should be at least 1.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE, TEN, ODM3, ODM1
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0, TEN = 1.0D+1,
     $                   ODM3 = 1.0D-3, ODM1 = 1.0D-1 )
      INTEGER            MAXITS, EXTRA
      PARAMETER          ( MAXITS = 5, EXTRA = 2 )
*     ..
*     .. Local Scalars ..
      INTEGER            B1, BLKSIZ, BN, GPIND, I, IINFO, INDRV1,
     $                   INDRV2, INDRV3, INDRV4, INDRV5, ITS, J, J1,
     $                   JBLK, JMAX, NBLK, NRMCHK
      DOUBLE PRECISION   DTPCRT, EPS, EPS1, NRM, ONENRM, ORTOL, PERTOL,
     $                   SCL, SEP, TOL, XJ, XJM, ZTR
*     ..
*     .. Local Arrays ..
      INTEGER            ISEED( 4 )
*     ..
*     .. External Functions ..
      INTEGER            IDAMAX
      DOUBLE PRECISION   DASUM, DDOT, DLAMCH, DNRM2
      EXTERNAL           IDAMAX, DASUM, DDOT, DLAMCH, DNRM2
*     ..
*     .. External Subroutines ..
      EXTERNAL           DAXPY, DCOPY, DLAGTF, DLAGTS, DLARNV, DSCAL,
     $                   XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      DO 10 I = 1, M
         IFAIL( I ) = 0
   10 CONTINUE
*
      IF( N.LT.0 ) THEN
         INFO = -1
      ELSE IF( M.LT.0 .OR. M.GT.N ) THEN
         INFO = -4
      ELSE IF( LDZ.LT.MAX( 1, N ) ) THEN
         INFO = -9
      ELSE
         DO 20 J = 2, M
            IF( IBLOCK( J ).LT.IBLOCK( J-1 ) ) THEN
               INFO = -6
               GO TO 30
            END IF
            IF( IBLOCK( J ).EQ.IBLOCK( J-1 ) .AND. W( J ).LT.W( J-1 ) )
     $           THEN
               INFO = -5
               GO TO 30
            END IF
   20    CONTINUE
   30    CONTINUE
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DSTEIN', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 .OR. M.EQ.0 ) THEN
         RETURN
      ELSE IF( N.EQ.1 ) THEN
         Z( 1, 1 ) = ONE
         RETURN
      END IF
*
*     Get machine constants.
*
      EPS = DLAMCH( 'Precision' )
*
*     Initialize seed for random number generator DLARNV.
*
      DO 40 I = 1, 4
         ISEED( I ) = 1
   40 CONTINUE
*
*     Initialize pointers.
*
      INDRV1 = 0
      INDRV2 = INDRV1 + N
      INDRV3 = INDRV2 + N
      INDRV4 = INDRV3 + N
      INDRV5 = INDRV4 + N
*
*     Compute eigenvectors of matrix blocks.
*
      J1 = 1
      DO 160 NBLK = 1, IBLOCK( M )
*
*        Find starting and ending indices of block nblk.
*
         IF( NBLK.EQ.1 ) THEN
            B1 = 1
         ELSE
            B1 = ISPLIT( NBLK-1 ) + 1
         END IF
         BN = ISPLIT( NBLK )
         BLKSIZ = BN - B1 + 1
         IF( BLKSIZ.EQ.1 )
     $      GO TO 60
         GPIND = B1
*
*        Compute reorthogonalization criterion and stopping criterion.
*
         ONENRM = ABS( D( B1 ) ) + ABS( E( B1 ) )
         ONENRM = MAX( ONENRM, ABS( D( BN ) )+ABS( E( BN-1 ) ) )
         DO 50 I = B1 + 1, BN - 1
            ONENRM = MAX( ONENRM, ABS( D( I ) )+ABS( E( I-1 ) )+
     $               ABS( E( I ) ) )
   50    CONTINUE
         ORTOL = ODM3*ONENRM
*
         DTPCRT = SQRT( ODM1 / BLKSIZ )
*
*        Loop through eigenvalues of block nblk.
*
   60    CONTINUE
         JBLK = 0
         DO 150 J = J1, M
            IF( IBLOCK( J ).NE.NBLK ) THEN
               J1 = J
               GO TO 160
            END IF
            JBLK = JBLK + 1
            XJ = W( J )
*
*           Skip all the work if the block size is one.
*
            IF( BLKSIZ.EQ.1 ) THEN
               WORK( INDRV1+1 ) = ONE
               GO TO 120
            END IF
*
*           If eigenvalues j and j-1 are too close, add a relatively
*           small perturbation.
*
            IF( JBLK.GT.1 ) THEN
               EPS1 = ABS( EPS*XJ )
               PERTOL = TEN*EPS1
               SEP = XJ - XJM
               IF( SEP.LT.PERTOL )
     $            XJ = XJM + PERTOL
            END IF
*
            ITS = 0
            NRMCHK = 0
*
*           Get random starting vector.
*
            CALL DLARNV( 2, ISEED, BLKSIZ, WORK( INDRV1+1 ) )
*
*           Copy the matrix T so it won't be destroyed in factorization.
*
            CALL DCOPY( BLKSIZ, D( B1 ), 1, WORK( INDRV4+1 ), 1 )
            CALL DCOPY( BLKSIZ-1, E( B1 ), 1, WORK( INDRV2+2 ), 1 )
            CALL DCOPY( BLKSIZ-1, E( B1 ), 1, WORK( INDRV3+1 ), 1 )
*
*           Compute LU factors with partial pivoting  ( PT = LU )
*
            TOL = ZERO
            CALL DLAGTF( BLKSIZ, WORK( INDRV4+1 ), XJ, WORK( INDRV2+2 ),
     $                   WORK( INDRV3+1 ), TOL, WORK( INDRV5+1 ), IWORK,
     $                   IINFO )
*
*           Update iteration count.
*
   70       CONTINUE
            ITS = ITS + 1
            IF( ITS.GT.MAXITS )
     $         GO TO 100
*
*           Normalize and scale the righthand side vector Pb.
*
            SCL = BLKSIZ*ONENRM*MAX( EPS,
     $            ABS( WORK( INDRV4+BLKSIZ ) ) ) /
     $            DASUM( BLKSIZ, WORK( INDRV1+1 ), 1 )
            CALL DSCAL( BLKSIZ, SCL, WORK( INDRV1+1 ), 1 )
*
*           Solve the system LU = Pb.
*
            CALL DLAGTS( -1, BLKSIZ, WORK( INDRV4+1 ), WORK( INDRV2+2 ),
     $                   WORK( INDRV3+1 ), WORK( INDRV5+1 ), IWORK,
     $                   WORK( INDRV1+1 ), TOL, IINFO )
*
*           Reorthogonalize by modified Gram-Schmidt if eigenvalues are
*           close enough.
*
            IF( JBLK.EQ.1 )
     $         GO TO 90
            IF( ABS( XJ-XJM ).GT.ORTOL )
     $         GPIND = J
            IF( GPIND.NE.J ) THEN
               DO 80 I = GPIND, J - 1
                  ZTR = -DDOT( BLKSIZ, WORK( INDRV1+1 ), 1, Z( B1, I ),
     $                  1 )
                  CALL DAXPY( BLKSIZ, ZTR, Z( B1, I ), 1,
     $                        WORK( INDRV1+1 ), 1 )
   80          CONTINUE
            END IF
*
*           Check the infinity norm of the iterate.
*
   90       CONTINUE
            JMAX = IDAMAX( BLKSIZ, WORK( INDRV1+1 ), 1 )
            NRM = ABS( WORK( INDRV1+JMAX ) )
*
*           Continue for additional iterations after norm reaches
*           stopping criterion.
*
            IF( NRM.LT.DTPCRT )
     $         GO TO 70
            NRMCHK = NRMCHK + 1
            IF( NRMCHK.LT.EXTRA+1 )
     $         GO TO 70
*
            GO TO 110
*
*           If stopping criterion was not satisfied, update info and
*           store eigenvector number in array ifail.
*
  100       CONTINUE
            INFO = INFO + 1
            IFAIL( INFO ) = J
*
*           Accept iterate as jth eigenvector.
*
  110       CONTINUE
            SCL = ONE / DNRM2( BLKSIZ, WORK( INDRV1+1 ), 1 )
            JMAX = IDAMAX( BLKSIZ, WORK( INDRV1+1 ), 1 )
            IF( WORK( INDRV1+JMAX ).LT.ZERO )
     $         SCL = -SCL
            CALL DSCAL( BLKSIZ, SCL, WORK( INDRV1+1 ), 1 )
  120       CONTINUE
            DO 130 I = 1, N
               Z( I, J ) = ZERO
  130       CONTINUE
            DO 140 I = 1, BLKSIZ
               Z( B1+I-1, J ) = WORK( INDRV1+I )
  140       CONTINUE
*
*           Save the shift to check eigenvalue spacing at next
*           iteration.
*
            XJM = XJ
*
  150    CONTINUE
  160 CONTINUE
*
      RETURN
*
*     End of DSTEIN
*
      END

!=======================================================================
!
!  PROGRAM  PHASE/0 2014.01 (rev.375)
!
!  "First-principles Electronic Structure Calculation Program"
!
!  AUTHOR(S): J. Koga
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!   The original version of this set of the computer programs "PHASE" was developed by 
!  the members of the Theory Group of Joint Research Center for Atom Technology 
!  (JRCAT), based in Tsukuba, in the period 1993-2001.  
!   Since 2002, this program set had been intensively developed as a part of the following 
!  national projects supported by the Ministry of Education, Culture, Sports, Science and 
!  Technology (MEXT) of Japan; "Frontier Simulation Software for Industrial Science 
!  (FSIS)" from 2002 to 2005, "Revolutionary Simulation Software (RSS21)" from 2006 to 
!  2008. "Research and Development of Innovative Simulation Software (RISS)" from 2008 
!  to 2013. These projects is lead by the Center for Research on Innovative Simulation 
!  Software (CISS), the Institute of Industrial Science (IIS), the University of Tokyo.
!   Since 2013, this program set has been further developed centering on PHASE System 
!  Consortium. 
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
#ifdef ENABLE_ESM_PACK
subroutine Preparation_for_ESM()
    use m_Const_Parameters, only : ON,BARE,PE1,PE2,DP
    use m_Control_Parameters, only : gmaxp,kimg,nspin,sw_esm,esm_z1,esm_izwall &
  &                                , esm_iexpot,esm_z_wall,esm_bar_height,esm_bar_width, esm_e_field &
  &                                , esm_fix_ef,esm_add_elec,esm_gps,esm_gpe,ipriesm,nspin,esm_bc,esm_w &
  &                                , esm_izwall, esm_z_wall, esm_bar_height, esm_bar_width
    use m_Ionic_System, only : natm,natm2,ityp,iatomn,ntyp,ival,cps
    use m_FFT, only : fft_box_size_CD
    use m_Crystal_Structure, only : altv
    use m_Parallelization, only : npes,mype, ista_kngp, iend_kngp, mpi_comm_group
    use m_PlaneWaveBasisSet, only : ngabc,igfp_l

    implicit none
    include 'mpif.h'
    character(len=3) :: esm_bc_c
    real(kind=DP), allocatable,dimension(:) :: ival_at
    real(kind=DP), allocatable, dimension(:,:) :: cps_tmp
    integer, allocatable, dimension(:,:) :: ngabc_esm
    integer, allocatable, dimension(:) :: igfp_l_esm
    integer :: i,j,ierr

    if(sw_esm/=ON) return
    if(esm_bc==BARE)then 
       esm_bc_c = 'bc1'
    else if (esm_bc == PE1) then
       esm_bc_c = 'bc2'
    else if (esm_bc == PE2) then
       esm_bc_c = 'bc3'
    endif
    allocate(ival_at(natm));ival_at=0.d0
    do i=1,natm
       ival_at(i) = ival(ityp(i))
    enddo
    allocate(ngabc_esm(3,1:iend_kngp-ista_kngp+1));ngabc_esm=0
    do i=1,3
       do j=ista_kngp,iend_kngp
          ngabc_esm(i,j-ista_kngp+1) = ngabc(j,i)
       enddo
    enddo
    allocate(cps_tmp(3,natm))
    do i=1,3
       do j=1,natm
          cps_tmp(i,j) = cps(j,i)
       enddo
    enddo
    allocate(igfp_l_esm(1:iend_kngp-ista_kngp+1));igfp_l_esm=0
    do i=ista_kngp,iend_kngp
       igfp_l_esm(i-ista_kngp+1) = igfp_l(i)
    enddo
    call Esm_interface_map_parameters(natm,ival_at,cps_tmp,1.0d0,altv, &
    & fft_box_size_CD(1,0),fft_box_size_CD(2,0),fft_box_size_CD(3,0),  &
    & esm_bc_c,.false.,iend_kngp-ista_kngp+1,nspin,ngabc_esm,          &
    & igfp_l_esm,igfp_l_esm,esm_w,2.0d0*esm_e_field, esm_izwall,       &
    & esm_z_wall, esm_bar_height,esm_bar_width)
    call Esm_interface_set_communicator(mpi_comm_group)
    deallocate(igfp_l_esm)
    deallocate(ival_at)
    deallocate(ngabc_esm)
    deallocate(cps_tmp)
end subroutine Preparation_for_ESM
#endif

!=======================================================================
!
!  PROGRAM  PHASE/0 2014.01 (rev.375)
!
!  "First-principles Electronic Structure Calculation Program"
!
!  PROGRAM: vdW
!
!  AUTHOR(S): Y. Ono
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!   The original version of this set of the computer programs "PHASE" was developed by 
!  the members of the Theory Group of Joint Research Center for Atom Technology 
!  (JRCAT), based in Tsukuba, in the period 1993-2001.  
!   Since 2002, this program set had been intensively developed as a part of the following 
!  national projects supported by the Ministry of Education, Culture, Sports, Science and 
!  Technology (MEXT) of Japan; "Frontier Simulation Software for Industrial Science 
!  (FSIS)" from 2002 to 2005, "Revolutionary Simulation Software (RSS21)" from 2006 to 
!  2008. "Research and Development of Innovative Simulation Software (RISS)" from 2008 
!  to 2013. These projects is lead by the Center for Research on Innovative Simulation 
!  Software (CISS), the Institute of Industrial Science (IIS), the University of Tokyo.
!   Since 2013, this program set has been further developed centering on PHASE System 
!  Consortium. 
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!

!********************************** Note ******************************************
! This program calculates non-local exchange-correlation energy (Ecnl).
! This Algorism follows Dion's 1-shot method.
!            (Reference; M.Dion et al. PRL 92 (2004) 246401.)
! E_total = E_total(GGAx) + EcLDA + Ecnl
!
! Periodic systems are assumed.
! Only orthogonal corrdinates are applicable.
! Atomic unit (Hartree) is used.
!
!
!
! +++++++++++ Algorithm ++++++++++
! Ecnl  ---> gauleg
!            Coef
!            piDphi  ---> gauleg
!            cLDA
!
!
!
! ++++++++ Input & Output ++++++++
! Input file
!   nfchr.cube             : Electron density distribution given by
!                             GGA(exchange only) calculation
!   nfefn.data             : Total energy given by GGA(exchange only) calculation
!
! Output
!   E_total(vdW-DF)
!     = E_total(GGAx) + EcLDA + Ecnl
!
!         E_total(GGAx)    : Total energy given by GGA(exchange only) calculation
!         Ecnl             : Non-local Correlation energy
!         EcLDA            : LDA Correlation energy
!
!
!
! ++++++ Internal parameters +++++
! Each internal parameter is set to restrict the error less than 10meV.
!
! na(=nb) ( 30    )        : For Gauss-Legendre integration
! a2(=b2) ( 60    )        : Upper limit of the integral of a, b
! etai    ( 1.3   )        : Radius of analytical integrating sphere (a.u.)
! eta1    ( 8     )        : Radius of numerical integrating sphere  (a.u.)
! eta2    ( 40    )        : Cutoff of asymptotic function      (unit cell)
!
! Calculation scale is Order(da * db * eta1**3).
!
!
!
! ++++ Calculation procedure +++++
! 1. Call gauleg to get parameters for Gauss-Legendre integral.
!
! 2. 7 points formula is used for differentiation of total density.
!
! 3. Call Coef and obtain the coefficients of the asymptotic function.
!
! 4. Calculate the local correlation energy using LDA.
!
! 5. Output total correlation energy.
!     --- Ec = Ecnl + EcLDA
!
!
!
!                                              Written by Youky Ono in 2010/June
!**********************************************************************************
 

 
      Program vdW
      Implicit None
#ifdef _MPI_
      include 'mpif.h'
#endif
      Integer, Parameter :: DP = kind(1.d0)

 
!++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
!...Translated by Crescent Bay Software VAST      7.1S0 15:22:42   2/ 4/2010  
      doubleprecision ni1u,nk1u,di1u,dk1u,gamm1u,phi1u,ni2u,nk2u,q0i1u,q0k1u
      Integer  nx,ny,nz,nspin,ispin
      Real(8) a1,a2
      Integer  ci,cj,ck,ca,cb,na,nb
      Parameter (na=30,a1=0,a2=60)

      Real(8) ddel,dphiD,del,phiD,tmp,phix,phiy
      Integer ndel,cdel,nphiD,cphiD
      Parameter (ndel=200,nphiD=1000)
      Real(8) phidD(0:ndel,-1:nphiD+1)

! Gauss-Legendre integration
      Real(8) xi(na),wi(na)
 
      Integer  cir,cix,ciy,ciz&
&             ,cjr,cjx,cjy,cjz&
&             ,ckr,ckx,cky,ckz&
&             ,cr ,cx ,cy ,cz,lcx,hcx,lcy,hcy,lcz,hcz
      Real(8)  di,dj,dk,dx,dy,dz,dv,n,ni,nj,nk
      Integer  i,j,k,zxp,zxm,zyp,zym,zzp,zzm

      Real(8)  eta,etai,eta1,eta2,maxq0,minq0
      Parameter (eta=0.0000000001,etai=1.3,eta1=8,eta2=20)
 
! Unit cell information from 'TAPP'
      Real(8) ax,aa,bb,detr
      Dimension aa(3,3),bb(3,3)
 
      Real(8), Allocatable  ::  C6(:,:,:)
 
      character*4   ::  acube,bcube
      integer       ::  ncube,ix,iy,iz
      real(8) n1,n2,n3,dcube(3,3)
      real(kind=8),allocatable :: atom(:,:)


      Real(8) rs,x,nnx,nny,nnz,nn2,nn2i,nn2k,r,zo
      Real(8) nxp,nxm,nyp,nym,nzp,nzm,rxb,rxa,ryb,rya,rzb,rza
      Real(8) zx(-3:3),zy(-3:3),zz(-3:3),rn(3,-3:3)
      Real(8),  Allocatable  ::  rho(:,:,:),Eii(:,:,:) &
&        ,dxrho(:,:,:),dyrho(:,:,:),dzrho(:,:,:) &
&        ,darho(:,:,:),dbrho(:,:,:),dcrho(:,:,:)
 
      Real(8) rhomin
      Parameter (rhomin=0.0001)
 
      Real(8)  kF,exc0,exLDA,excLDA,pi,Zab,wp,wq,q,m,h,e,GxcLDA
      Real(8)  gamma,a,b,C,d,q0,q0i,q0k
      Real(8)  v1,v2,v3,v4
      Parameter (pi=3.1415926535897932)
      Parameter (e=1,m=1)
      Parameter (Zab=-0.8491)
 
      Real(8) T,W,phi,psi,Ecnl,Ecik,Ecik1,Ecik2,Ecii,EcLDA,ExGGA
      doubleprecision h1
 
! Estimate running time
      Real(8) time
      Integer hh,mm,ss
 
! Time estimation
      Real(8) estime,escpu,eseta1,esnxyz,esna,adj
      Parameter (adj=1,escpu=0.000261)
#ifdef _MPI_
      Integer :: mype,npes,ierr
#endif
!++++++++++++++++++++++++ end VARIABLES ++++++++++++++++++++++++



!---------------------- Calculation Start ----------------------
      Call CPU_TIME(time)
#ifdef _MPI_
  call initialize_mpi(npes,mype)
#endif

  open(6,file='nfefn.data')
  read(6,*) acube
  read(6,*) n1,n2,n3
  ExGGA = n3
  close(6)

  nspin=1
  open(5,file='nfchr.cube')
  read(5,*) acube
  read(5,*) bcube

  read(5,*) ncube,n1,n2,n3
  read(5,*) nx,aa(1,1),aa(1,2),aa(1,3)
  read(5,*) ny,aa(2,1),aa(2,2),aa(2,3)
  read(5,*) nz,aa(3,1),aa(3,2),aa(3,3)
  allocate(atom(ncube,5))

  read(5,*) ((atom(i,j),j=1,5),i=1,ncube)
  allocate(rho(nx,ny,nz))
     read(5,*) (((rho(i,j,k),k=1,nz),j=1,ny),i=1,nx)
  close(5)

  ax = 1


      Allocate(dxrho(nx,ny,nz))
      Allocate(dyrho(nx,ny,nz))
      Allocate(dzrho(nx,ny,nz))
      Allocate(darho(nx,ny,nz))
      Allocate(dbrho(nx,ny,nz))
      Allocate(dcrho(nx,ny,nz))
      Allocate(Eii(nx,ny,nz))
      Allocate(C6(-(nx-1):nx-1,-(ny-1):ny-1,-(nz-1):nz-1))


        
      nb = na
      dx = ax*((aa(1,1)**2+aa(1,2)**2+aa(1,3)**2)**0.5)
      dy = ax*((aa(2,1)**2+aa(2,2)**2+aa(2,3)**2)**0.5)
      dz = ax*((aa(3,1)**2+aa(3,2)**2+aa(3,3)**2)**0.5)
      dv = aa(1,1)*(aa(2,2)*aa(3,3)-aa(2,3)*aa(3,2)) &
&        + aa(1,2)*(aa(2,3)*aa(3,1)-aa(2,1)*aa(3,3)) &
&        + aa(1,3)*(aa(2,1)*aa(3,2)-aa(2,2)*aa(3,1))

 
 
      Do cjx = 1,nx
      Do cjy = 1,ny
      Do cjz = 1,nz
 
         Do j = -3,3
            zx(j) = MOD(2*nx+(cjx+j)-1,nx)+1
            zy(j) = MOD(2*ny+(cjy+j)-1,ny)+1
            zz(j) = MOD(2*nz+(cjz+j)-1,nz)+1
 
            rn(1,j) = rho(zx(j),cjy,cjz)
            rn(2,j) = rho(cjx,zy(j),cjz)
            rn(3,j) = rho(cjx,cjy,zz(j))
         End Do
 
         darho(cjx,cjy,cjz) = &
&           (rn(1,3)-9*rn(1,2)+45*rn(1,1)-45*rn(1,-1)+9*rn(1,-2)-rn(1,-3))/(60)
         dbrho(cjx,cjy,cjz) = &
&           (rn(2,3)-9*rn(2,2)+45*rn(2,1)-45*rn(2,-1)+9*rn(2,-2)-rn(2,-3))/(60)
         dcrho(cjx,cjy,cjz) = &
&           (rn(3,3)-9*rn(3,2)+45*rn(3,1)-45*rn(3,-1)+9*rn(3,-2)-rn(3,-3))/(60)
      End Do
      End Do
      End Do

      detr = (aa(1,1)*aa(2,2)*aa(3,3)+aa(1,2)*aa(2,3)*aa(3,1)+aa(1,3)*aa(2,1)*aa(3,2)) &
&          - (aa(1,1)*aa(2,3)*aa(3,2)+aa(1,2)*aa(2,1)*aa(3,3)+aa(1,3)*aa(2,2)*aa(3,1))

      bb(1,1) =  (aa(2,2)*aa(3,3)-aa(2,3)*aa(3,2))/detr
      bb(2,1) = -(aa(2,1)*aa(3,3)-aa(2,3)*aa(3,1))/detr
      bb(3,1) =  (aa(2,1)*aa(3,2)-aa(2,2)*aa(3,1))/detr
      bb(1,2) = -(aa(1,2)*aa(3,3)-aa(1,3)*aa(3,2))/detr
      bb(2,2) =  (aa(1,1)*aa(3,3)-aa(1,3)*aa(3,1))/detr
      bb(3,2) = -(aa(1,1)*aa(3,2)-aa(1,2)*aa(3,1))/detr
      bb(1,3) =  (aa(1,2)*aa(2,3)-aa(1,3)*aa(2,2))/detr
      bb(2,3) = -(aa(1,1)*aa(2,3)-aa(1,3)*aa(2,1))/detr
      bb(3,3) =  (aa(1,1)*aa(2,2)-aa(1,2)*aa(2,1))/detr

      Do cjx = 1,nx
      Do cjy = 1,ny
      Do cjz = 1,nz

        dxrho(cjx,cjy,cjz) = &
&       (bb(1,1)*darho(cjx,cjy,cjz) + bb(1,2)*dbrho(cjx,cjy,cjz) + bb(1,3)*dcrho(cjx,cjy,cjz))
        dyrho(cjx,cjy,cjz) = &
&       (bb(2,1)*darho(cjx,cjy,cjz) + bb(2,2)*dbrho(cjx,cjy,cjz) + bb(2,3)*dcrho(cjx,cjy,cjz))
        dzrho(cjx,cjy,cjz) = &
&       (bb(3,1)*darho(cjx,cjy,cjz) + bb(3,2)*dbrho(cjx,cjy,cjz) + bb(3,3)*dcrho(cjx,cjy,cjz))

      End Do
      End Do
      End Do

 

!############## Call gauleg for Gauss-Legendre integral ##########
      Call gauleg(a1,a2,na,xi,wi)
!#################################################################
 
      maxq0 = 0
      minq0 = 100
      Do cir = 1,nx*ny*nz 
         cix = 1 + (cir - 1 - mod(cir - 1 + ny*nz,ny*nz))/(ny*nz) 
         ciy = 1 + (cir - ny*nz*(cix - 1) - 1 - mod(cir - 1 + nz,nz))/nz 
         ciz = cir - nz*(ny*(cix - 1) - 1 + ciy) 

         n = rho(cix,ciy,ciz)
         If (n .ge. rhomin) then

         nnx = dxrho(cix,ciy,ciz) 
         nny = dyrho(cix,ciy,ciz) 
         nnz = dzrho(cix,ciy,ciz) 
         nn2 = nnx**2 + nny**2 + nnz**2 
!         write(14,*) nn2**0.5
         rs = (3/((4*pi)*n))**0.3333333333333333 
         x = rs/11.4 
         gxclda = 0.5*((1 + x**3)*log(1 + 1/x) - x**2 + x/2)
         exclda = (-0.458/rs) - 0.0666*gxclda 
         kf = (((3*pi)*pi)*n)**0.3333333333333333 
         exlda = (-3*e)*kf/(4*pi) 
         exc0 = exclda - exlda*zab*nn2/(((18)*2)*kf*kf*n*n) 
         q0 = exc0*kf/exlda 

         If(q0.GE.maxq0) Then
            maxq0 = q0
         Endif
         If(q0.LE.minq0) Then
            minq0 = q0
         Endif
!         write(11,*) q0,n,nn2
!         write(11,*) gxclda,exclda,kf
!         write(11,*) exlda,exc0

         Endif

      End do
!      write(*,*) maxq0,minq0
!      maxq0 = 10

! phi(del,phiD)
      ddel = 1/Real(ndel)
      gamma=(4*pi)/9
      dphiD = (maxq0*eta1-minq0*etai)/(Real(nphiD))
!      write(11,*) dphiD,nphiD
   do cdel = 0,ndel
   do cphiD   = -1,nphiD+1
      del = Real(cdel)*ddel
      phiD = minq0*etai + Real(cphiD)*dphiD
!      write(11,*) minq0,etai,cphiD,dphiD,phiD
      di = phiD*(1+del)
      dk = phiD*(1-del)

      tmp = 0
   do ca = 1, na 
       a = xi(ca) 
   do cb = 1, na
       b = xi(cb) 

      h = 1 - exp((-gamma*(a/di)**2)) 
      v1 = (a**2)/(2*h) 
 
      h = 1 - exp((-gamma*(b/di)**2)) 
      v2 = (b**2)/(2*h) 
 
      h = 1 - exp((-gamma*(a/dk)**2)) 
      v3 = (a**2)/(2*h) 
 
      h = 1 - exp((-gamma*(b/dk)**2)) 
      v4 = (b**2)/(2*h) 
 
      w = 2*((3-(a*a))*b*(cos(b))*(sin(a)) + &
&         (3-(b*b))*a*(cos(a))*(sin(b)) +    &
&         ((a*a)+(b*b)-3)*(sin(a))*(sin(b))  &
&         -3*a*b*(cos(a))*(cos(b)))/(a*b)**3 

      t = 0.5*(1/(v1 + v2) + 1/(v3 + v4))*(1/((v1 + &
&         v3)*(v2 + v4)) + 1/((v1 + v4)*(v2 + v3))) 

      tmp = tmp + wi(ca)*wi(cb)*(a*b)**2*w*t 

   end do
   end do
      tmp = tmp * (2*m*(e**4)/(pi**2))

   phidD(cdel,cphiD) = tmp
!   write(11,*) del,phiD,tmp !4*pi*(D**2)*tmp

   end do
!   write(11,*) ' '
   end do
      tmp = 0
 
 
      Ecik1=0
#ifndef _MPI_
!$OMP PARALLEL DO &
!$OMP& DEFAULT(SHARED) &
!$OMP& PRIVATE(cix, ciy, ciz, ni, nnx, nny, nnz, nn2i, lcx, hcx, lcy &
!$OMP&   , hcy, lcz, hcz, ckr, r, cx, cy, cz, nk, nn2k, di, dk, n, nn2, rs, x,  &
!$OMP&   gxclda, exclda, kf, exlda, exc0, q0, d, gamma, phi, a, h1, v1, b, h,   &
!$OMP&   v2, v3, v4, w, t, cb, ni1u, nk1u, di1u, dk1u, gamm1u, phi1u,i,j,k,     &
!$OMP&   del,cdel,phiD,cphiD,phix,phiy)                                         &
!$OMP&    REDUCTION(+:ecik1) 
#endif
      do cir = 1,nx*ny*nz 
#ifdef _MPI_
         if(mod(cir,npes)/=mype) cycle
#endif
         cix = 1 + (cir - 1 - mod(cir - 1 + ny*nz,ny*nz))/(ny*nz) 
         ciy = 1 + (cir - ny*nz*(cix - 1) - 1 - mod(cir - 1 + nz,nz))/nz 
         ciz = cir - nz*(ny*(cix - 1) - 1 + ciy) 
 
         ni1u = rho(cix,ciy,ciz) 
         if (ni1u .ge. rhomin) then 
            nnx = dxrho(cix,ciy,ciz) 
            nny = dyrho(cix,ciy,ciz) 
            nnz = dzrho(cix,ciy,ciz) 
            nn2i = nnx**2 + nny**2 + nnz**2 
 
            lcx = cix - 4*(aint((eta1/dx))) 
            hcx = cix + 4*(aint((eta1/dx))) 
            lcy = ciy - 4*(aint((eta1/dy))) 
            hcy = ciy + 4*(aint((eta1/dy))) 
            lcz = ciz - 4*(aint((eta1/dz))) 
            hcz = ciz + 4*(aint((eta1/dz))) 
 
            do ckx = 1, hcx - lcx + 1 
               do cky = 1, hcy - lcy + 1 
                  do ckz = 1, hcz - lcz + 1 

!                     r = (((cix + 1 - ckx - lcx)*dx)**2 + ((ciy + 1 - cky - lcy&
!     &                  )*dy)**2 + ((ciz + 1 - ckz - lcz)*dz)**2)**0.5 

               i = cix+1-ckx-lcx
               j = ciy+1-cky-lcy
               k = ciz+1-ckz-lcz
               r = ((i*aa(1,1)+j*aa(2,1)+k*aa(3,1))**2 &
&                 + (i*aa(1,2)+j*aa(2,2)+k*aa(3,2))**2 &
&                 + (i*aa(1,3)+j*aa(2,3)+k*aa(3,3))**2)**0.5

               if (r.le.eta1 .and. r.gt.etai) then
!               if (cir.eq.43.and.k.eq.0) then
!                  write(*,*) i*aa(1,1)+j*aa(2,1),i*aa(1,2)+j*aa(2,2),r
!               end if
                        cx = mod(20*nx + lcx + ckx - 2,nx) + 1 
                        cy = mod(20*ny + lcy + cky - 2,ny) + 1 
                        cz = mod(20*nz + lcz + ckz - 2,nz) + 1 
                        nk1u = rho(cx,cy,cz) 
                        if (nk1u .ge. rhomin) then 
                           nnx = dxrho(cx,cy,cz) 
                           nny = dyrho(cx,cy,cz) 
                           nnz = dzrho(cx,cy,cz) 
                           nn2k = nnx**2 + nny**2 + nnz**2 
 
                           di1u = 0 
                           dk1u = 0 
                           n = ni1u + 0.D0 
                           nn2 = nn2i + 0.D0 
                           rs = (3/((4*pi)*n))**0.3333333333333333 
                           x = rs/11.4 
                           gxclda = 0.5*((1 + x**3)*log(1 + 1/x) - x**2 + x/2&
     &                         - (0)) 
                           exclda = (-0.458/rs) - 0.0666*gxclda 
                           kf = (((3*pi)*pi)*n)**0.3333333333333333 
                           exlda = (-3*e)*kf/(4*pi) 
                           exc0 = exclda - exlda*zab*nn2/(((18)*2)*kf*kf*n*n) 
                           q0 = exc0*kf/exlda 
                           d = r*q0 
                           di1u = di1u + d 
                           dk1u = dk1u + 0.D0 
                           n = 0.D0 + nk1u 
                           nn2 = 0.D0 + nn2k 
                           rs = (3/((4*pi)*n))**0.3333333333333333 
                           x = rs/11.4 
                           gxclda = 0.5*((1 + x**3)*log(1 + 1/x) - x**2 + x/2&
     &                         - (0)) 
                           exclda = (-0.458/rs) - 0.0666*gxclda 
                           kf = (((3*pi)*pi)*n)**0.3333333333333333 
                           exlda = (-3*e)*kf/(4*pi) 
                           exc0 = exclda - exlda*zab*nn2/(((18)*2)*kf*kf*n*n) 
                           q0 = exc0*kf/exlda 
                           d = r*q0 
                           di1u = di1u + 0.D0 
                           dk1u = dk1u + d 
 
                           di1u = di1u + eta 
                           dk1u = dk1u + eta 
 
! Dispersion law of wq.
                           gamm1u = (4*pi)/9 
 
                           del = ABS((di1u-dk1u)/(di1u+dk1u))
                           cdel = AINT(del/ddel)
!                        write(11,*) del,ddel,cdel
                           phiD = (di1u+dk1u)/2
                           cphiD = AINT(REAL(nphiD)*(phiD-minq0*etai)/(maxq0*eta1-minq0*etai))

!                           write(11,*) cphiD,phiD,di1u/r,dk1u/r
!                         write(11,*) phidD(cdel,cphiD)

                           phix = del/ddel - REAL(cdel)
                           phiy = REAL(nphiD)*(phiD-minq0*etai)/(maxq0*eta1-minq0*etai) - REAL(cphiD)

                           phi1u =  (1-phix)*(1-phiy) * phidD(cdel  ,cphiD  ) &
&                                  +   phix *(1-phiy) * phidD(cdel+1,cphiD  ) &
&                                  +(1-phix)*   phiy  * phidD(cdel  ,cphiD+1) &
&                                  +   phix *   phiy  * phidD(cdel+1,cphiD+1)

                           ecik1 = ecik1 + dv**2*0.5*ni1u*phi1u*nk1u 
                           
                        endif 
 
                     endif 
                  end do 
               end do 
            end do 
         endif 
      end do 
#ifdef _MPI_ 
      if(npes>1)then
         call mpi_allreduce(MPI_IN_PLACE,ecik1,1,mpi_double_precision,mpi_sum,mpi_comm_world,ierr)
      endif
#endif
! Ecik1 is the non-local correlation energy E_c^nl summated for i not= k.
 
!      write(*,*) 'test'
 
!########  Call Coef and obtain the coefficients of the ##########
!########  asymptotic function.                         ##########
   Call Coef(nx,ny,nz,aa,eta1,eta2,C6)
!#################################################################
 
 
 
   Ecik2 = 0
#ifndef _MPI_
!$OMP PARALLEL DO PRIVATE(ni, nk, q0i, q0k, psi, c, cjx, cjy, cjz, n, rs, x, &
!$OMP&   gxclda, exclda, kf, exlda, nnx, nny, nnz, nn2, exc0, q0, ni2u, nk2u, &
!$OMP&   q0i1u, q0k1u, cix, ciy, ciz, ckx, cky, ckz) REDUCTION(+:ecik2) 
#endif
      do cir = 1, nx*ny*nz
#ifdef _MPI_
         if(mod(cir,npes)/=mype) cycle
#endif
         cix = 1 + (cir - 1 - mod(cir - 1 + ny*nz,ny*nz))/(ny*nz) 
         ciy = 1 + (cir - ny*nz*(cix - 1) - 1 - mod(cir - 1 + nz,nz))/nz 
         ciz = cir - nz*(ny*(cix - 1) - 1 + ciy) 

!      do cix = 1, nx 
!         do ciy = 1, ny 
!            do ciz = 1, nz 

               ni2u = rho(cix,ciy,ciz) 
               if (ni2u .ge. rhomin) then 
 
      do ckr = 1, nx*ny*nz
         ckx = 1 + (ckr - 1 - mod(ckr - 1 + ny*nz,ny*nz))/(ny*nz)
         cky = 1 + (ckr - ny*nz*(ckx - 1) - 1 - mod(ckr - 1 + nz,nz))/nz
         ckz = ckr - nz*(ny*(ckx - 1) - 1 + cky)

!                  do ckx = 1, nx 
!                     do cky = 1, ny 
!                        do ckz = 1, nz 

                           nk2u = rho(ckx,cky,ckz) 
                           if (nk2u .ge. rhomin) then 
 
                              q0i1u = 0 
                              q0k1u = 0 
                              do j = 1, 2 
                                 cjx = cix*mod(j,2) + ckx*mod(j - 1,2) 
                                 cjy = ciy*mod(j,2) + cky*mod(j - 1,2) 
                                 cjz = ciz*mod(j,2) + ckz*mod(j - 1,2) 
                                 n = ni2u*(mod(j,2)) + nk2u*(mod(j - 1,2)) 
 
                                 rs = (3/((4*pi)*n))**0.3333333333333333 
                                 x = rs/11.4 
                                 gxclda = 0.5*((1 + x**3)*log(1 + 1/x) - x**2&
     &                               + x/2 - 0) 
                                 exclda = (-0.458/rs) - 0.0666*gxclda 
 
                                 kf = (3*pi*pi*n)**0.3333333333333333 
                                 exlda = (-3)*e*kf/(4*pi) 
                                 nnx = dxrho(cjx,cjy,cjz) 
                                 nny = dyrho(cjx,cjy,cjz) 
                                 nnz = dzrho(cjx,cjy,cjz) 
                                 nn2 = nnx**2 + nny**2 + nnz**2 
 
! Eq.(12) of Dion PRL92,246401
                                 exc0 = exclda - exlda*zab*nn2/(36*kf*kf*n*n) 
 
! Eq.(11) of Dion PRL92,246401
                                 q0 = exc0*kf/exlda 
                                 q0i1u = q0i1u + q0*(mod(j,2)) 
                                 q0k1u = q0k1u + q0*(mod(j - 1,2)) 
                              end do 
 
                              psi = ((q0i1u*q0k1u)**2*(q0i1u**2 + q0k1u**2))**(&
     &                           -1) 
                              c = 12*m*e**4*((4*pi)/9)**3 
!                              write(11,*) q0 
                              ecik2 = ecik2 - dv**2*c*ni2u*psi*nk2u&
     &                                 *0.5*c6(cix-ckx,ciy-cky,ciz-ckz)

!                              write(*,*) dv**2*c*ni2u*psi*nk2u,&
!     &                                 c6(cix-ckx,ciy-cky,ciz-ckz),cix-ckx,ciy-cky,ciz-ckz

                           endif 
!                        end do 
!                     end do 
                  end do 

               endif 
!            end do 
!         end do 
      end do 
#ifdef _MPI_
      if(npes>1)then
         call mpi_allreduce(MPI_IN_PLACE,ecik2,1,mpi_double_precision,mpi_sum,mpi_comm_world,ierr)
      endif
#endif
 
   Ecik = Ecik1 + Ecik2
 

 
!######  Call piDphi and obtain the matrix elements of Eii #######
   Call piDphi(nx,ny,nz,rho,dxrho,dyrho,dzrho,dv,etai,na,xi,wi,Eii)
!#################################################################
 
 
 
   Ecii=0
#ifndef _MPI_
!$OMP PARALLEL DO PRIVATE(n, rs, x, gxclda, exclda, kf, exlda, nnx, nny, nnz, &
!$OMP&   nn2, exc0, q0, cjx) REDUCTION(+:ecii) 
#endif
      do cjy = 1, ny 
         do cjz = 1, nz 
            do cjx = 1, nx 
#ifdef _MPI_
               if(mod(cjy*cjz*cjx,npes)/=mype) cycle
#endif
               n = rho(cjx,cjy,cjz) 
               if (n .ge. rhomin) then 
 
                  rs = (3/(4*pi*n))**0.3333333333333333 
                  x = rs/11.4 
                  gxclda = 0.5*((1 + x**3)*log(1 + 1/x) - x**2 + x/2 - 1/3) 
                  exclda = (-0.458/rs) - 0.0666*gxclda 
 
                  kf = (3*pi*pi*n)**0.3333333333333333 
                  exlda = (-3)*e*kf/(4*pi) 
                  nn2 = dxrho(cjx,cjy,cjz)**2 + dyrho(cjx,cjy,cjz)**2 + dzrho(&
     &               cjx,cjy,cjz)**2 
 
! Eq.(12) of Dion PRL92,246401
                  exc0 = exclda - exlda*zab*nn2/(9*2*2*kf*kf*n*n) 
 
                  ecii = ecii + dv*0.5*n**2*eii(cjx,cjy,cjz)/(exc0*kf/exlda)**3 
 
               endif 
            end do 
         end do 
      end do 
 
#ifdef _MPI_
      if(npes>1) call mpi_allreduce(MPI_IN_PLACE,ecii,1,mpi_double_precision,mpi_sum,mpi_comm_world,ierr)
#endif
! Ecii is the non-local correlation energy E_c^nl summated for i = k.
!   write(*,*) '#',Ecii
 
   Ecnl = Ecik + Ecii
 
!   write(*,*) Ecik1,Ecik2
!   write(*,*) Ecik,Ecii,Ecnl
 
 
 
!####  Call cLDA and obtain the local correlation energy EcLDA ###
   Call cLDA(nx,ny,nz,rho,rhomin,dv,EcLDA)
!#################################################################
#ifdef _MPI_ 
   if (mype==0) then
#endif
   Write(*,*)  ' '
   Write(*,11) ExGGA
   Write(*,*)  ' '
   Write(*,12) EcLDA
   Write(*,13) Ecnl
   Write(*,14) EcLDA + Ecnl
   Write(*,*)  ' '
   Write(*,15) EcLDA + Ecnl + ExGGA
   Write(*,*)  ' '
 11    Format('E_total(GGA exchange)      = ',F19.13)

 12    Format('Ec(LDA)                    = ',F19.13)
 13    Format('Ec(nl)                     = ',F19.13)
 14    Format('Ec (= Ec(LDA) + Ec(nl) )   = ',F19.13)

 15    Format('E_total(vdW-DF)            = ',F19.13)

   Write(*,*)  '                  Given in Hartree atomic units'
   Write(*,*)  ' '
 
      Call CPU_TIME(time)
      ss=time
      hh=time/3600
      ss=Mod(ss,3600)
      mm=ss/60
      ss=Mod(ss,60)
      time=time-3600*hh-60*mm-ss
      Write(*,16) hh,mm,ss+time
 16    Format('# Calculation time ',I5,':',I2,':',F7.4)
#ifdef _MPI_
   endif
   call mpi_finalize(ierr)
#endif
 
! End of Dion_main
      End Program vdW

 
 
!** SUBROUTINE CPU_TIME ************************
      Subroutine CPU_TIME(time)
      Real(8) time
      Integer count,count_rate,hh,mm,ss
 
      Call System_clock(count,count_rate)
      If(count_rate.Eq.0) Then
         time=Real(count)/count_rate
      Else
         time=-1
      End If
 
      End Subroutine CPU_TIME
!** End SUBROUTINE CPU_TIME ********************




!** SUBROUTINE gauleg **************************
      Subroutine gauleg(x1,x2,n,xi,wi)
      Implicit none


!++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
      Integer  m,j,i,n
      Real(8)  x1,x2,z1,z,xm,xl,pp,p3,p2,p1,pi,eta
      Parameter (pi=3.1415926535897932 , eta=0.0000000001)

      Real(8)  ::  xi(n),wi(n)
!++++++++++++++++++++++++ end VARIABLES ++++++++++++++++++++++++



!---------------------- Calculation Start ----------------------
      m=(n+1)/2
      xm=0.5*(x2+x1)
      xl=0.5*(x2-x1)

      Do i=1,m
         z=COS(pi*(i-0.25)/(n+0.5))

         Do While (ABS(z-z1).GT.eta)
            p1=1.0
            p2=0.0

            Do j=1,n
               p3=p2
               P2=p1
               p1=((2.0*j-1.0)*z*p2-(j-1.0)*p3)/j
            End Do

            pp=n*(z*p1-p2)/(z*z-1.0)
            z1=z
            z=z1-p1/pp
            
         End Do

         xi(i) = xm-xl*z
         xi(n+1-i) = xm+xl*z
         wi(i) = 2.0*xl/((1.0-z*z)*pp*pp)
         wi(n+1-i) = wi(i)

      End Do
      End Subroutine gauleg
!** End SUBROUTINE gauleg **********************




!** SUBROUTINE Coef ****************************
      Subroutine Coef(nx,ny,nz,aa,eta1,eta2,C6)
      Implicit None

!************************ Note *********************************
! This Algorism calculates the coefficient of the asymptotic 
! function phi.
!
! Input
!   nx,ny,nz,ax,ay,az,eta1,eta2 : Information of the unit cell
!
! Output
!   C6                          : Coefficient of the asymptotic
! function of the core function phi.
!
!
!                            Written by Youky Ono in 2009/Sep.
!***************************************************************



!++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
      Integer  nx,ny,nz,nspin
      Real(8) f1,f2,f3,rxyz

      Integer  cir,cix,ciy,ciz&
&             ,ckr,ckx,cky,ckz
      Real(8)  di,dj,dk,dx,dy,dz,dv,aa(3,3)
      Integer  i,j,k,tx,ty,tz

      Real(8)  eta1,eta2

      Real(8) :: C6(-(nx-1):nx-1,-(ny-1):ny-1,-(nz-1):nz-1)
!++++++++++++++++++++++++ end VARIABLES ++++++++++++++++++++++++



!---------------------- Calculation Start ----------------------
! As Main program !
      Do cix = -(nx-1),nx-1
      Do ciy = -(ny-1),ny-1
      Do ciz = -(nz-1),nz-1
         C6(cix,ciy,ciz) = 0
      End Do
      End Do
      End Do

      Do ckx = -(nx-1),nx-1
      Do cky = -(ny-1),ny-1
      Do ckz = -(nz-1),nz-1
         Do tx=-1*eta2,eta2
         Do ty=-1*eta2,eta2
         Do tz=-1*eta2,eta2

            f1 = (REAL(ckx)/REAL(nx))+tx
            f2 = (REAL(cky)/REAL(ny))+ty
            f3 = (REAL(ckz)/REAL(nz))+tz

            rxyz = &
&             ((nx*f1*aa(1,1)+ny*f2*aa(2,1)+nz*f3*aa(3,1))**2 &
&             +(nx*f1*aa(1,2)+ny*f2*aa(2,2)+nz*f3*aa(3,2))**2 &
&             +(nx*f1*aa(1,3)+ny*f2*aa(2,3)+nz*f3*aa(3,3))**2)**0.5

         If(rxyz.GT.eta1) Then
            C6(ckx,cky,ckz) = C6(ckx,cky,ckz) + (rxyz**(-6))
         End If

         End Do
         End Do
         End Do
      End Do
      End Do
      End Do


    End Subroutine Coef
!** End SUBROUTINE Coef ************************



!** SUBROUTINE piDphi **************************
      Subroutine piDphi(nx,ny,nz,rho,dxrho,dyrho,dzrho,dv,etai,na,xi,wi,Eii)
      implicit none

!************************ Note *********************************
! This Algorism follows Dion's 1-shot method.
!
! This program is a subroutine.
! This program calculates the matrix elements of Eii(cjx,cjy,cjz).
!
! Input
!   rho(nrxyz,nsipn) : Total density
!
! Output
!   Eii(cjx,cjy,cjz) : Result of the numerical integral. 
!                      The integrand is 4*pi*(D**2)*phi.
!
!
!                            Written by Youky Ono in 2009/June.
!***************************************************************



!++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
      integer  nx,ny,nz,nspin
      real(8) da,db,a1,a2
      integer  ci,cj,ck,ca,cb,na

! Gauss-Legendre integration
      Real(8) xi(na),wi(na)

      integer cD,nD
      parameter (nD=75)
      real(8) maxD,minD,dD,LD,PLD,LDxi(nD),LDwi(nD)
      parameter (minD=0)

      integer  cjx,cjy,cjz
      real(8)  di,dj,dk,eta,etai,dx,dy,dz,dv,n,ni,nj,nk
      integer  i,j,k,zxp,zxm,zyp,zym,zzp,zzm
      parameter (eta=0.00000001)

! Unit cell information from 'TAPP'
      real(8) tappax,tappaa
      dimension tappaa(3,3)

      real(8) rs,x,nnx,nny,nnz,nn2,r
      real(8) nxp,nxm,nyp,nym,nzp,nzm
      real(8) zx(-3:3),zy(-3:3),zz(-3:3),rn(3,-3:3)
      real(8)  ::  rho(nx,ny,nz),Eii(nx,ny,nz) &
&        ,dxrho(nx,ny,nz),dyrho(nx,ny,nz),dzrho(nx,ny,nz) 

      real(8)  kF,exc0,exLDA,excLDA,q0,pi,Zab,wp,wq,q,m,h,e,GxcLDA
      real(8)  gamma,a,b,d,px
      real(8)  v1,v2,v3,v4
      parameter (pi=3.1415926535897932)
      parameter (e=1,m=1)
      parameter (Zab=-0.8491)

      real(8) T,W,phi,pphi

! Estimate running time
      real(8) time
      integer hh,mm,ss


!++++++++++++++++++++++++ end VARIABLES ++++++++++++++++++++++++



!---------------------- Calculation Start ----------------------
!      dv = dx*dy*dz
      gamma = 4*pi/9


!      Do cjx = 1,nx
!      Do cjy = 1,ny
!      Do cjz = 1,nz

!         Do j = -3,3
!            zx(j) = MOD(2*nx+(cjx+j)-1,nx)+1
!            zy(j) = MOD(2*ny+(cjy+j)-1,ny)+1
!            zz(j) = MOD(2*nz+(cjz+j)-1,nz)+1

!            rn(1,j) = rho(zx(j),cjy,cjz)
!            rn(2,j) = rho(cjx,zy(j),cjz)
!            rn(3,j) = rho(cjx,cjy,zz(j))
!         End Do

!         dxrho(cjx,cjy,cjz) = &
!&           (rn(1,3)-9*rn(1,2)+45*rn(1,1)-45*rn(1,-1)+9*rn(1,-2)-rn(1,-3))/(60*dx)
!         dyrho(cjx,cjy,cjz) = &
!&           (rn(2,3)-9*rn(2,2)+45*rn(2,1)-45*rn(2,-1)+9*rn(2,-2)-rn(2,-3))/(60*dy)
!         dzrho(cjx,cjy,cjz) = &
!&           (rn(3,3)-9*rn(3,2)+45*rn(3,1)-45*rn(3,-1)+9*rn(3,-2)-rn(3,-3))/(60*dz)

!      End Do
!      End Do
!      End Do


   do cjx=1,nx
   do cjy=1,ny
   do cjz=1,nz      

      Eii(cjx,cjy,cjz)=0
      n = rho(cjx,cjy,cjz)

      rs = (3/(4*pi*n))**0.3333333333333333
      x = rs/11.4
      GxcLDA = 0.5*((1+x**3)*LOG(1+1/x)-x**2+x/2-1/3)
      excLDA = -0.458/rs-0.0666*GxcLDA

      kF = (3*pi*pi*n)**0.3333333333333333
      exLDA = -3*e*kF/(4*pi)
      nnx = dxrho(cjx,cjy,cjz) 
      nny = dyrho(cjx,cjy,cjz) 
      nnz = dzrho(cjx,cjy,cjz) 
      nn2 = (nnx**2)+(nny**2)+(nnz**2)

! Eq.(12) of Dion PRL92,246401
      exc0 = excLDA - exLDA*Zab*nn2/(9*2*2*kF*kF*n*n)

! Eq.(11) of Dion PRL92,246401
      q0 = exc0*kF/exLDA

!      nD=NINT(q0*etai/dD)
      maxD=q0*etai



!############## Call gauleg for Gauss-Legendre integral ##########
      Call gauleg(minD,maxD,nD,LDxi,LDwi)
!#################################################################


      
      Do cD=1,nD
         LD = LDxi(cD)

      phi = 0
      Do ca=1,na
      Do cb=1,ca

         a = xi(ca)
         b = xi(cb)

         h = 1-EXP(-gamma*((a/LD)**2))
         v1 = (a**2)/(2*h)

         h = 1-EXP(-gamma*((b/LD)**2))
         v2 = (b**2)/(2*h)

         h = 1-EXP(-gamma*((a/LD)**2))
         v3 = (a**2)/(2*h)

         h = 1-EXP(-gamma*((b/LD)**2))
         v4 = (b**2)/(2*h)

         W = 2*((3-a*a)*b*COS(b)*SIN(a) + (3-b*b)*a*COS(a)*SIN(b) &
&            + (a*a+b*b-3)*SIN(a)*SIN(b) &
&            -3*a*b*COS(a)*COS(b))/((a*b)**3)

! ((a*b)**2)*T
         T = ((a*b)**2) &
&            * 0.5*(1/(v1+v2) + 1/(v3+v4) ) &
&            * (1/((v1+v3)*(v2+v4)) + 1/((v1+v4)*(v2+v3)))

         phi = phi + wi(ca)*wi(cb)*W*T

      End Do
      End Do

      phi = phi * 2

      Do ca=1,na
         cb=ca
         a = xi(ca)
         b = xi(cb)

         h = 1-EXP(-gamma*((a/LD)**2))
         v1 = (a**2)/(2*h)

         h = 1-EXP(-gamma*((b/LD)**2))
         v2 = (b**2)/(2*h)

         h = 1-EXP(-gamma*((a/LD)**2))
         v3 = (a**2)/(2*h)

         h = 1-EXP(-gamma*((b/LD)**2))
         v4 = (b**2)/(2*h)

         W = 2*((3-a*a)*b*COS(b)*SIN(a) + (3-b*b)*a*COS(a)*SIN(b) &
&            + (a*a+b*b-3)*SIN(a)*SIN(b) &
&            -3*a*b*COS(a)*COS(b))/((a*b)**3)

! ((a*b)**2)*T
         T = ((a*b)**2) &
&            * 0.5*(1/(v1+v2) + 1/(v3+v4) ) &
&            * (1/((v1+v3)*(v2+v4)) + 1/((v1+v4)*(v2+v3)))

         phi = phi - wi(ca)*wi(cb)*W*T

      End Do
      

      phi = phi * 2*m*(e**4)/(pi**2)

      Eii(cjx,cjy,cjz) = Eii(cjx,cjy,cjz) &
&                        + LDwi(cD)*4*pi*(LD**2)*phi

      End Do

   end do
   end do
   end do

      end Subroutine piDphi
!** End SUBROUTINE piphi ***********************




!** SUBROUTINE cLDA ****************************
      Subroutine cLDA(nx,ny,nz,rho,rhomin,dv,EcLDA)
      implicit none

!************************ Note *********************************
! This Algorism follows Dion's 1-shot method.
!
! This program is a subroutine.
! This program calculates the correlation energy from LDA.
! The formula is given at Eq.(58) (p.93) of 'Theory of the 
!   Inhomogeneous Electron Gas' Lundqvist, March.
! 
!
! Input
!   rho(nrxyz,nsipn) : Total density
!
! Output
!   EcLDA : Corrilation energy from LDA.
!
!
!                            Written by Youky Ono in 2009/Jul.
!***************************************************************



!++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
      integer  nx,ny,nz,nspin
      integer  ci,cj,ck,cjx,cjy,cjz
      real(8)  dx,dy,dz,dv,eta
      integer  i,j,k
      parameter (eta=0.00000001)

      real(8) rs,x,aB,ec,EcLDA,n,A,C,rhomin
      parameter (A=21,C=0.045)
      real(8)  ::  rho(nx,ny,nz)
      parameter (aB=1) ! aB=1[a.u.]

      real(8)  pi,e,m
      parameter (pi=3.1415926535897932)
      parameter (e=1,m=1) ! Hatree atomic unit

!++++++++++++++++++++++++ end VARIABLES ++++++++++++++++++++++++



!---------------------- Calculation Start ----------------------
!      dv = dx*dy*dz

      EcLDA=0
   do cjx=1,nx
   do cjy=1,ny
   do cjz=1,nz      
      n = rho(cjx,cjy,cjz)

   if(n.GE.rhomin) then

      rs = ((3/(4*pi*n))**0.3333333333333333)/aB
      x = rs/11.4
      ec = -0.0666*0.5*((1+x**3)*LOG(1+1/x)-x**2+x/2-1/3)

      EcLDA = EcLDA + dv*n*ec

   end if
   end do
   end do
   end do


      end Subroutine cLDA
!** End SUBROUTINE cLDA **********************

#ifdef _MPI_
    SUBROUTINE initialize_mpi(npes,mype)
       implicit none
       integer,intent(out) :: npes
       integer,intent(out) :: mype
       include 'mpif.h'
       integer :: ierr
       call mpi_init(ierr)
       call mpi_comm_size(mpi_comm_world,npes,ierr)
       call mpi_comm_rank(mpi_comm_world,mype,ierr)
       if(ierr/=0) then
          write(6,'(a,i5)') 'failed initialization of MPI; error code : ',ierr
          stop
       endif
    end SUBROUTINE initialize_mpi
#endif

#!/bin/sh

NP=2
NK=2
NE=1
dvol=1
nvol=11
inivol=20

rm -f energy.data
rm -f log
echo -n 'start time:'>>log ; date >> log
for v in `seq 1 $nvol`; do
  vol=$( echo \($v-1\)*$dvol+$inivol | bc -l )
  a=$( echo e\(l\($vol\)/3\) | bc -l )
  mkdir -p vol$vol/
  echo -n $vol >> energy.data ; tail -1 vol$vol/nfefn.data >> energy.data
  if [ -f stop ]; then
    echo 'the stop file exists... exiting. '
    rm -f stop
    if [ "a" = "$na" ]; then
      echo ' ' >> energy.data
    fi
    echo -n 'end time:'>>log ; date >> log
    exit
  fi
done
echo -n 'end time:'>>log ; date >> log
